/*
 ķ
   Program..: _DCCLASS.PRG                                 
   Author...:  Roger J. Donnay                             
   Notice...: (c) DONNAY Software Designs 2001-2002        
   Date.....: Apr  7, 2002                                 
   Notes....: eXPress++ GUI Dialog Classes                 
 Ľ

 Classes:

   DC_XbpGeneric
   DC_XbpStatic
   DC_XbpCheckBox
   DC_XbpComboBox
   DC_Xbp3State
   DC_XbpMLE
   DC_XbpSLE
   DC_XbpToolBar
   DC_XbpTabPage
   DC_XbpRadioButton
   DC_XbpSpinButton
   DC_XbpDialog
   DC_XbpListBox
   DC_XbpScrollBar
   DC_XbpProgressBar
   DC_XbpBitMap
   DC_XbpMenuBar
   DC_XbpMenu
   DC_XbpStatusBar
   DC_XbpPanel
   DC_XbpTreeView
   DC_XbpTreeViewItem
   DC_XbpActiveXControl
   DC_XbpSplitBar
   DC_WindowMenu
   DC_XbpHTMLViewer
   DC_XbpRTF
   DC_XbaseParts
*/

#INCLUDE "appevent.ch"
#INCLUDE "dcdialog.ch"
#INCLUDE "dcmsg.ch"
#INCLUDE "dll.ch"
#INCLUDE "dccursor.CH"

#ifndef XBPMENUBAR_MIA_OWNERDRAW
#define XBPMENUBAR_MIA_OWNERDRAW       131072
#endif

// Drawing modes used with XBPs
#ifndef XBP_DRAW_NORMAL
#define XBP_DRAW_NORMAL                0
#define XBP_DRAW_OWNER                 1
#define XBP_DRAW_OWNERADVANCED         2
#endif

#DEFINE _METHOD   METHOD
#define  MENUITEM_SEPARATOR   {NIL, NIL, XBPMENUBAR_MIS_SEPARATOR, 0}
#define CRLF Chr(13)+Chr(10)
#define RGN_OR    2

// Defines for the spacing between the individual
// elements that make up a menue entry
#define ITEM_SPACING        5
#define IMAGE_BOX           20

// Background color for the popup menu
#define MENU_BAR_BGCOLOR       GRA_CLR_BACKGROUND
#define MENU_BAR_FGCOLOR       GRA_CLR_BLACK
#define MENU_SUB_BGCOLOR       GraMakeRGBColor( {245,245,255} )
#define MENU_SUB_FGCOLOR       GRA_CLR_BLACK
#define MENU_SUB_BARCOLORFG    GraMakeRGBColor( {245,245,255} )
#define MENU_SUB_BARCOLORBG    GraMakeRGBColor( {200,200,255} )
#define MENU_SUB_OUTLINECOLOR  GraMakeRGBColor( {124,124,255} )
#define MENU_SUB_VERTBARFONT   '12.Arial Bold'
#define MENU_SUB_CHECKFONT     '10.Marlett'
#define MENU_SUB_CHECKCHAR     'b'
#define MENU_BAR_BARFONT       '8.Arial'
#define MENU_SUB_ITEMFONT      '8.Arial'

#if XPPVER > 1900000
  // Include the Automation Support Library
  #PRAGMA LIBRARY( "ASCOM10.LIB" )
#endif

STATIC aDllLoaded := {}

* =========================================================

CLASS DC_XbpGeneric FROM DC_XbaseParts
EXPORTED:
  _METHOD Init, Create, WhenHideEval
ENDCLASS

* ------------------

METHOD DC_XbpGeneric:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL aGetList, aGetListItem, aGetOptions, bBlock

::DC_XbaseParts:init( oGetList,,self)

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::cargo := { ::getListPointer, aGetList,  aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpGeneric:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aArray, aGetListItem, nOptions

aGetListItem := ::getList:getListArray[::getListPointer]

::DC_XbaseParts:setOrig(self)

RETURN self

* ---------------------------

METHOD DC_XbpGeneric:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* =========================================================

CLASS DC_XbpStatic FROM DC_XbpStaticSuper, DC_XbaseParts

EXPORTED:
  VAR color
  VAR colorFG
  VAR varBlock
  VAR captionBlock
  VAR picture
  VAR optionArray
  VAR size
  VAR enabled
  VAR captionEnabled
  VAR captionDisabled
  VAR noAutoResize
  VAR hyperLink
  VAR setPointerEnable
  VAR bitmap
  VAR captionResType
  VAR captionResFile
  VAR fontCompoundName
  VAR fontBlock
  VAR Border
  VAR AutoSize
  VAR TabStops
  VAR ownerDrawBlock
  VAR formattedText
  _METHOD Draw, Resize, SetCaption
  _METHOD init, create, refresh, WhenHideEval, enable, disable, hide, show

PROTECTED:
  VAR ParentFont
  VAR Lines
  VAR LastOptions

  _METHOD ParseCaption, ParseCaptionLine, DrawCaptionLine, ComputeLineWidth

ENDCLASS

* ---------------------

METHOD DC_XbpStatic:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, cCaption, bBlock, lAutoSize := .f., ;
      aGetList, aGetListItem, nType, cFont, nPointSize, ;
      cFontFamilyName

::DC_XbaseParts:init( oGetList,,self)
aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

::picture := aGetListItem[cGETLIST_PICTURE]

xOptions := aGetListItem[xGETLIST_OPTIONS5]
DEFAULT xOptions := {}
ASize(xOptions,2)
::captionResType := xOptions[1]
::captionResFile := xOptions[2]

cCaption := aGetListItem[cGETLIST_CAPTION]

IF !Empty(aGetListItem[nGETLIST_SUBTYPE])
  nType := aGetListItem[nGETLIST_SUBTYPE]
ELSE
  nType := XBPSTATIC_TYPE_TEXT
ENDIF

IF Valtype(cCaption) = 'B'
  IF nType == XBPSTATIC_TYPE_TEXT
    cCaption := DC_XtoC(Eval(cCaption,self))
  ELSE
    cCaption := Eval(cCaption,self)
  ENDIF
ELSEIF !Empty(::picture)
  cCaption := TransForm(cCaption,::picture)
ELSEIF Valtype(cCaption) $ 'NDL' .AND. Empty(::picture) .AND. ;
     nType==XBPSTATIC_TYPE_TEXT
  cCaption := DC_Xtoc(cCaption)
ELSEIF cCaption == NIL
  cCaption := ''
ENDIF

::lines := {}
::size = aSize
// ::clipChildren := .T.

DEFAULT ::size := {nil,nil}

IF nType == XBPSTATIC_TYPE_TEXT .AND. !(cCaption==NIL .OR. Len(cCaption)==0)
  DEFAULT ::size[1] := LEN(cCaption) * ::GetList:colPixels * ::GetList:scaleFactor[3]
  DEFAULT ::size[2] := ::GetList:rowPixels
ENDIF

IF Empty(::size[1])
  lAutoSize := .t.
  ::size[1] := 0
  IF Empty(::size[2])
    ::size[2] := 0
  ENDIF
ENDIF

IF DC_GroupBoxFix() .AND. nType == XBPSTATIC_TYPE_GROUPBOX
  oParent := XbpStatic():new(oParent,oOwner,aPos,::size,aPres,lVisible)
  oParent:clipChildren := .T.
  oParent:type := XBPSTATIC_TYPE_TEXT
  oParent:create()
  oOwner := oParent
  aPos := {0,0}
ENDIF

IF Empty(aPres)
  aPres := { { XBP_PP_DISABLED_BGCLR, GRA_CLR_BACKGROUND } }
ENDIF

::XbpStatic:init( oParent, oOwner, aPos, ::size, aPres, lVisible )

::tabstop := .f.
::type := nType
::noAutoResize := .f.
::setPointerEnable := .t.
xOptions := aGetListItem[xGETLIST_OPTIONS6]

::formattedText := .f.
IF Valtype(xOptions) == 'L' .AND. xOptions
  ::drawMode := XBP_DRAW_OWNER
  ::tabStops := 20
  ::formattedText := .t.
ENDIF

::ownerDrawBlock := aGetListItem[xGETLIST_OPTIONS7]

IF Valtype(::ownerDrawBlock) == 'B'
  ::drawMode := XBP_DRAW_OWNER
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS]
DEFAULT xOptions := {}

IF Valtype(cCaption) = 'A'
  ::captionEnabled := DC_GetBitMap(cCaption[1],nType,::captionResType,::captionResFile,,.t.)
  ::captionDisabled := DC_GetBitMap(cCaption[2],nType,::captionResType,::captionResFile,,.t.)
ELSE
  ::captionEnabled := DC_GetBitMap(cCaption,nType,::captionResType,::captionResFile,,.t.)
  ::captionDisabled := ::captionEnabled
ENDIF
IF ::type == XBPSTATIC_TYPE_TEXT
  ::caption := ::captionEnabled
ELSE
  ::caption := DC_GetBitMap(::captionEnabled,nType,::captionResType,::captionResFile,,.t.)
ENDIF

ASize(xOptions,1)
IF Valtype(xOptions[1]) = 'N'
  ::options := xOptions[1]
ENDIF

IF DC_BitTest(::options,5) // XBPSTATIC_TEXT_WORDBREAK
  ::caption := Strtran(::caption,';',Chr(13)+Chr(10))
ENDIF

IF Valtype(aGetListItem[cGETLIST_CAPTION]) == 'B'
  ::captionBlock := aGetListItem[cGETLIST_CAPTION]
ENDIF
::color := DC_GetBlock(aGetListItem[aGETLIST_COLOR])
IF Valtype(::color)#'B'
  ::color := aGetListItem[aGETLIST_COLOR]
ENDIF

IF !Empty(::caption) .AND. ::type == XBPSTATIC_TYPE_TEXT
  IF Valtype(::color) # 'B' .AND. Empty(::captionBlock)
    DEFAULT ::color := {GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT}
  ENDIF
ENDIF

::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
::optionArray := xOptions
::xbpStatic:autoSize := lAutoSize
::autoSize := lAutoSize
::enabled := .t.

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }
::clipSiblings := .T.

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  cFont := aGetListItem[cGETLIST_FONT]
  IF Valtype(cFont) == 'B'
    ::fontBlock := cFont
    cFont := Eval(::fontBlock)
  ENDIF
  cFont := Alltrim(cFont)
  IF ::GetList:scaleFactor[5]
    nPointSize := Val(cFont)
    cFontFamilyName := SubStr(cFont,At('.',cFont)+1)
    cFont := Alltrim(Str(Round(nPointSize * ::GetList:scaleFactor[3],0))) + ;
               '.' + cFontFamilyName
  ENDIF
  ::fontCompoundName := cFont
  ::setFontCompoundName(cFont)
ENDIF

IF Valtype(xOptions[1]) = 'N'
  ::options := xOptions[1]
ELSEIF ::getList:isSayRight
  ::options := XBPSTATIC_TEXT_RIGHT
ELSEIF Valtype(::getList:sayOptions) = 'N'
  ::options := ::getList:sayOptions
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* ------------------

METHOD DC_XbpStatic:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL j, xOptions, bBlock, nStartCol, nStartRow, nWidth, nHeight, ;
   oScroll, oStatic, aGetListItem, lWordBreak, oFont, oPS

lWordBreak := DC_BitTest(::options,5)

aGetListItem := ::getList:getListArray[::getListPointer]

DEFAULT oParent := ::setParent()

DC_XbpSetColor( ::color, self, oParent, ;
   aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

::colorFG := ::setColorFG()

::xbpStatic:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::hyperLink := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS9])

IF ::drawMode == XBP_DRAW_OWNER
  IF ::SetFont() == NIL
     oPS := ::SetParent():LockPS()
     ::ParentFont := oPS:SetFont()
     ::SetParent():UnlockPS()
  ENDIF
  ::setCaption( ::caption )
ENDIF

IF Valtype(::hyperLink) == 'B'
   oFont := ::setFont()
   IF Valtype(oFont) # 'O' .AND. !Empty(::setParent():setFontCompoundName())
      ::setFontCompoundName(::setParent():setFontCompoundName())
      oFont := ::setFont()
   ENDIF
   IF Valtype(oFont) = 'O'
      oFont:underscore := .T.
      oFont:configure()
      ::setFont(oFont)
      ::lbDown := {|a,b,o|Eval(::hyperLink,a,b,o)}
   ENDIF
ENDIF

IF ::size[1] = 0 .AND. aGetListItem[nGETLIST_TYPE]==GETLIST_SAY .AND. !lWordBreak .AND. ;
      ::currentSize()[2] < ::GetList:rowPixels
   nHeight := ::size[2]
   IF Empty(nHeight)
      nHeight := ::GetList:rowPixels
   ENDIF
   ::setSize( {::currentSize()[1],nHeight} )
ENDIF

IF Valtype(aGetListItem[xGETLIST_OPTIONS4]) == 'L'
   ::noAutoResize := aGetListItem[xGETLIST_OPTIONS4]
ENDIF

DEFAULT aGetListItem[xGETLIST_OPTIONS5] := .F.
IF aGetListItem[xGETLIST_OPTIONS5]
   ::setPos({::currentPos()[1]-::currentSize()[1],::currentPos()[2]})
ENDIF

IF !Empty(aGetListItem[xGETLIST_OPTIONS2]) .OR. ;
      !Empty(aGetListItem[xGETLIST_OPTIONS3])

   FOR j := 1 TO 2

      IF j = 1
         xOptions := aGetListItem[xGETLIST_OPTIONS2] // Vertical Scroll Bar
      ELSE
         xOptions := aGetListItem[xGETLIST_OPTIONS3] // Horizontal Scroll Bar
      ENDIF

      DEFAULT xOptions := {}
      ASize(xOptions,5)
      DEFAULT xOptions[2] := 0, ;
         xOptions[3] := 0
      bBlock := DC_GetBlock(xOptions[1])
      IF Valtype(bBlock) = 'B'
         oStatic := Eval(bBlock)
         IF Valtype(oStatic) = 'O'              // parent of object to scroll
            IF j = 1                            // Vertical
               nStartCol := oStatic:currentPos()[1]+oStatic:currentSize()[1]
               nStartRow := oStatic:currentPos()[2]
               nWidth    := 15
               nHeight   := oStatic:currentSize()[2]
            ELSE                                // Horizontal
               nStartCol := oStatic:currentPos()[1]
               nStartRow := oStatic:currentPos()[2]-15
               nWidth    := oStatic:currentSize()[1]
               nHeight   := 15
            ENDIF
            oScroll := XbpScrollBar():new( oStatic:setParent(),, ;
               {nStartCol,nStartRow}, {nWidth,nHeight}, ;
               _Pres(aGetListItem[aGETLIST_PRESENTATION]),lVisible)
            oScroll:cargo := { oStatic, self, ::currentPos()[IIF(j=1,2,1)], 0, j, xOptions[5] }
            oScroll:scroll := {|mp1,x,o|_StaticScroll(mp1,o)}
            oScroll:autotrack := .t.
            oScroll:dataLink := {||oScroll:cargo[4]}
            oScroll:type := IIF( j=1,XBPSCROLL_VERTICAL,XBPSCROLL_HORIZONTAL )
            oScroll:range := { xOptions[2], xOptions[3] }
            oScroll:create()
            bBlock := DC_GetBlock(xOptions[4])
            IF Valtype(bBlock)='B'
               Eval( bBlock, oScroll )
            ENDIF
         ENDIF
      ENDIF

   NEXT j

ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* -----------

METHOD DC_XbpStatic:enable()

LOCAL xCaption

IF !::enabled
  IF ::type == XBPSTATIC_TYPE_TEXT
    ::xbpStatic:enable()
  ELSE
    IF Valtype(::varBlock) = 'B'
      xCaption := DC_XtoC(Eval(::varBlock))
    ELSEIF Valtype(::captionBlock) = 'B'
      xCaption := DC_GetBitMap(Eval(::captionBlock,self),nil,::captionResType,::captionResFile,,.t.)
    ELSE
      xCaption := ::captionEnabled
    ENDIF
    IF Valtype(::caption) # Valtype(xCaption) .OR. !::caption == xCaption
      ::setCaption(xCaption)
    ENDIF
  ENDIF
  ::enabled := .t.
ENDIF

RETURN self

* -----------

METHOD DC_XbpStatic:disable()

LOCAL xCaption

IF ::enabled
  IF ::type == XBPSTATIC_TYPE_TEXT
    ::xbpStatic:disable()
  ELSE
    IF Valtype(::varBlock) = 'B'
      xCaption := DC_XtoC(Eval(::varBlock))
    ELSEIF Valtype(::captionBlock) = 'B'
      xCaption := DC_GetBitMap(Eval(::captionBlock,self),nil,::captionResType,::captionResFile,,.t.)
    ELSE
      xCaption := ::captionDisabled
    ENDIF
    IF Valtype(::caption) # Valtype(xCaption) .OR. !::caption == xCaption
      ::setCaption(xCaption)
    ENDIF
  ENDIF
  ::enabled := .f.
ENDIF

RETURN self

* -----------

METHOD DC_XbpStatic:refresh()

LOCAL xCaption, aGetListItem, cFont

BEGIN SEQUENCE
IF Valtype(::varBlock) = 'B'
  IF ::type == XBPSTATIC_TYPE_TEXT
    xCaption := DC_XtoC(Eval(::varBlock))
  ELSE
    xCaption := Eval(::varBlock)
  ENDIF
ELSEIF Valtype(::captionBlock) = 'B'
  IF ::type == XBPSTATIC_TYPE_TEXT
    xCaption := DC_XtoC(Eval(::captionBlock,self))
  ELSE
    xCaption := Eval(::captionBlock,self)
  ENDIF
ELSE
  BREAK
ENDIF

IF !(Valtype(::caption) == Valtype(xCaption)) .OR. ;
    !::caption == xCaption
  ::setCaption(xCaption)
  /*
  IF ::setParent():setColorBG() == XBPSYSCLR_TRANSPARENT
    ::setParent():invalidateRect()
  ENDIF
  */
ENDIF
END SEQUENCE

IF Valtype(::color)=='B'
  aGetListItem := ::getList:getListArray[::getListPointer]
  DC_XbpSetColor( ::color, self, nil, aGetListItem[aGETLIST_PRESENTATION], .t., .f. )
ENDIF

IF Valtype(::fontBlock) == 'B'
  cFont := Eval(::fontBlock)
  ::setFontCompoundName(cFont)
ENDIF

RETURN self

* -----------

METHOD DC_XbpStatic:WhenHideEval( lEnable, lShow, lProtect )

LOCAL i, aChildList := ::childList()

IF Valtype(::whenBlock) = 'B'
  lEnable:= Eval(::whenBlock,self)
  IF lEnable
    ::enable()
    FOR i := 1 TO Len(aChildList)
      IF IsMethod(aChildList[i],'whenHideEval')
        IF IsMemberVar(aChildList[i],'whenBlock') .AND. Valtype(aChildList[i]:whenBlock) == 'B'
          aChildList[i]:whenHideEval( lEnable, lShow, lProtect )
        ELSEIF IsMethod(aChildList[i],'enable')
          aChildList[i]:enable()
        ENDIF
      ELSEIF IsMethod(aChildList[i],'enable')
        aChildList[i]:enable()
      ENDIF
    NEXT
  ELSE
    ::disable()
    FOR i := 1 TO Len(aChildList)
      IF IsMethod(aChildList[i],'disable')
        aChildList[i]:disable()
      ENDIF
    NEXT
  ENDIF
ENDIF

IF Valtype(::hideBlock) = 'B'
  lShow := !Eval(::hideBlock,self)
  IF lShow
    IF !::isVisible()
      ::show()
    ENDIF
  ELSE
    IF ::isVisible()
      ::hide()
    ENDIF
  ENDIF
ENDIF

IF Valtype(lProtect) == 'L' .AND. Valtype(::protectBlock) = 'B'
  lProtect := Eval(::protectBlock,self)
ENDIF

RETURN self

* -----------

METHOD DC_XbpStatic:hide()

IF DC_GroupBoxFix() .AND. ::type == XBPSTATIC_TYPE_GROUPBOX
  ::setParent():hide()
ENDIF
::xbpStatic:hide()

RETURN self

* -----------

METHOD DC_XbpStatic:show()

IF DC_GroupBoxFix() .AND. ::type == XBPSTATIC_TYPE_GROUPBOX
  ::setParent():show()
ENDIF
::xbpStatic:show()

RETURN self

* -----------

/*
 "cCaption" must be a character string that may include optional
 formatting characters. A formatting option consists of a
 backslash ("\") followed by the formatting option. The class
 currently recognises the following formatting characters:
    "\n"     Defines a line break.
    "\b"     Enables bold type. Succeeding characters are
             rendered using a bold font.
    "\i"     Enables italic type. Succeeding characters are
             rendered using an italic font.
    "\u"     Enables underlined text. Succeeding characters are
             rendered using an underlined font.
    "\c"     Cancels bold, italic and/or italic mode. Succeeding
             characters are rendered using a plain (normal)
             font.
    "\t"     Tab character. Display of succeeding characters
             resumes at the next tab stop.
 Any other character preceded by a backslash is assumed to be
 an escaped character. "\\" translates to a single backslash.

 Notes: o A run-time error results if an illegal formatting
          option is specified. In order to display a backslash
          character, two backslashes must be entered into the
          input stream.
        o Defining the caption of a label object implicitly
          initialises the dimensions of the object.
*/

METHOD DC_XbpStatic:SetCaption( cCaption )

LOCAL oPS, oFont, nWidth, aSize := {0,0}, i

IF ::Status() == XBP_STAT_INIT
   ::xbpStatic:Caption := cCaption
   ::caption := cCaption
   RETURN .T.
ENDIF

IF !::formattedText
   ::xbpStatic:setCaption(cCaption)
   ::caption := cCaption
   RETURN .T.
ENDIF

// Parse the string passed to break it down
// into individual lines. Afterwards, process
// each line to determine size requirements
// if auto-sizing is enabled

oPS   := ::LockPS()

::ParseCaption( oPS, cCaption )

IF ::AutoSize == .T.
   oFont := oPS:SetFont()

   FOR i:=1 TO Len(::Lines)
     nWidth   := ::ComputeLineWidth( oPS, ::Lines[i] )
     aSize[1] := Max( aSize[1], nWidth )
     aSize[2] += oFont:Height
     IF i == 1
        aSize[2] += 3
     ENDIF
   NEXT

   ::UnlockPS()

   ::SetSize( aSize )
ELSE
   ::UnlockPS()
   ::InvalidateRect()
ENDIF

::Caption := cCaption

RETURN .T.

* -----------

METHOD DC_XbpStatic:Draw( oPS, aInfo )

#if XPPVER > 1900331

LOCAL aStringAttr, i, oFont, aPos, aRect, aSize, nTmp

IF !Empty(::ownerDrawBlock)
  RETURN Eval( ::ownerDrawBlock, oPS, aInfo, self )
ENDIF

aRect := aInfo[XBP_DRAWINFO_RECT]

oFont := ::SetFont()
IF oFont == NIL
   oFont := ::ParentFont
ENDIF
oPS:SetFont( oFont )

GraBackground( oPS, {aRect[1],aRect[2]}, {aRect[3]-1, aRect[4]-1} )
IF ::Border == .T.
   GraEdge( oPS, {aRect[1],aRect[2]}, {aRect[3]-1, aRect[4]-1}, GRA_EDGESTYLE_SIMPLE )
ENDIF

GraPathBegin( oPS )
GraBox( oPS, {4,2}, {::CurrentSize()[1]-4,::CurrentSize()[2]-2} )
GraPathEnd( oPS )
GraPathClip( oPS, .T. )

// Successively render each line of
// text to be displayed in the label

aStringAttr := Array( GRA_AS_COUNT )
aStringAttr[GRA_AS_COLOR]     := ::SetColorFG()
aStringAttr[GRA_AS_VERTALIGN] := GRA_VALIGN_TOP
GraSetAttrString( oPS, aStringAttr )

aSize := ::CurrentSize()

aPos := {4,::CurrentSize()[2]-2}
GraPos( oPS, aPos )

IF Band(::Options, XBPSTATIC_TEXT_RIGHT) == XBPSTATIC_TEXT_RIGHT
   nTmp   := 0
   FOR i:=1 TO Len(::Lines)
      nTmp := Max( nTmp, ::ComputeLineWidth(oPS,::Lines[i]) )
   NEXT
   aPos[1]:= aSize[1] - nTmp
ELSEIF Band(::Options, XBPSTATIC_TEXT_CENTER) == XBPSTATIC_TEXT_CENTER
   nTmp   := 0
   FOR i:=1 TO Len(::Lines)
      nTmp := Max( nTmp, ::ComputeLineWidth(oPS,::Lines[i]) )
   NEXT
   aPos[1]:= 4 + (aSize[1] - nTmp) /2
ENDIF
IF Band(::Options, XBPSTATIC_TEXT_BOTTOM) == XBPSTATIC_TEXT_BOTTOM
   nTmp   := Len(::Lines) * oFont:Height
   aPos[2]:= 2 + nTmp
ELSEIF Band(::Options, XBPSTATIC_TEXT_VCENTER) == XBPSTATIC_TEXT_VCENTER
   nTmp   := Len(::Lines) * oFont:Height
   aPos[2]-= (aSize[2] - nTmp) /2
ENDIF

GraPos( oPS, aPos )

FOR i:=1 TO Len(::Lines)
  ::DrawCaptionLine( oPS, ::Lines[i] )
  aPos[2] -= oFont:Height
  GraPos( oPS, aPos )
NEXT

GraPathClip( oPS, .F. )

#endif

RETURN self

* -------------

METHOD DC_XbpStatic:Resize( aNew, aOld )

::XbpStatic:Resize( aNew, aOld )

IF BAnd(::Options, XBPSTATIC_TEXT_WORDBREAK) == XBPSTATIC_TEXT_WORDBREAK
   ::SetCaption( ::Caption )
ENDIF

RETURN self

* ----------

METHOD DC_XbpStatic:ParseCaption( oPS, cCaption )

LOCAL nIndex, cLine, nLine := 1, nChar, nCharOld, nTmp

::Lines := {cCaption}

// Process "hard returns" in the caption
// string for pre-formatting lines.

DO WHILE .T.
   cLine := ::Lines[Len(::Lines)]
   nIndex := At( "\n", cLine )
   IF nIndex == 0
      EXIT
   ENDIF

   ::Lines[Len(::Lines)] := Left( cLine, nIndex -1 )
   AAdd( ::Lines, "\c" + SubStr(cLine, nIndex+2) )
ENDDO

IF BAnd(::Options, XBPSTATIC_TEXT_WORDBREAK) != XBPSTATIC_TEXT_WORDBREAK .OR.;
   ::AutoSize == .T.
   RETURN
ENDIF

DO WHILE nLine <= Len(::Lines)
   cLine := ::Lines[nLine]
   GraPos( oPS, {4,2} )

   nChar := At( " ", cLine )
   nCharOld := nChar

   DO WHILE nChar > 0 .AND. ::ComputeLineWidth(oPS, Left(cLine, nChar)) < ::CurrentSize()[1] -4
      GraPos( oPS, {4,2} )
      nCharOld := nChar

      IF nChar >= Len(cLine)
         EXIT
      ENDIF

      nChar := At( " ", cLine, nChar +1 )
      IF nChar == 0
         nChar := Len( cLine ) +1
      ENDIF
   ENDDO

   IF nCharOld > 0
      // Break the line at the last white space found
      ::Lines[nLine] := SubStr( cLine, 1, nCharOld - 1 )

      cLine := ::LastOptions + SubStr( cLine, nCharOld + 1 )

      // Indent the new line the same way as the current
      // one
      nTmp  := 1
      DO WHILE Upper(SubStr(::Lines[nLine], nTmp, 2)) == "\T"
         cLine := "\t" + cLine
         nTmp  += 2
      ENDDO

      // Insert the new line into the line array
      IF nLine == Len(::Lines)
         AAdd( ::Lines, cLine )
      ELSEIF Upper(Left(::Lines[nLine+1], 2)) == "\T"
         AAdd( ::Lines, "" )
         AIns( ::Lines, nLine+1, cLine )
      ELSE
         ::Lines[nLine+1] := cLine + " " + ::Lines[nLine+1]
      ENDIF
   ENDIF

   nLine++
ENDDO

RETURN

* ---------

METHOD DC_XbpStatic:ParseCaptionLine( oPS, cLine, bCallback, xData )

LOCAL cTmp := "", c, oFontPrev   := oPS:SetFont(), i, oFont, ;
      lSetFont, lTabify, aPos, aBox

oFont := XbpFont():New( oPS )
oFont:FamilyName := oFontPrev:FamilyName
oFont:Height     := oFontPrev:Height
oFont:CodePage   := oFontPrev:CodePage
oFont:WeightClass:= XBPFONT_WEIGHT_NORMAL
oFont:Generic    := oFontPrev:Generic
oFont:Vector     := oFontPrev:Vector
oFont:Fixed      := oFontPrev:Fixed
oFont:Create()

oPS:SetFont( oFont )

::LastOptions := ""

aPos    := GraPos( oPS )

FOR i:=1 TO Len(cLine)
   c := cLine[i]
   IF c != "\"
      cTmp += c
      LOOP
   ENDIF

   i++
   IF i > Len(cLine)
      EXIT
   ENDIF

   lSetFont := .F.
   lTabify  := .F.

   c := Upper( cLine[i] )

   DO CASE
      CASE c == "\"
         cTmp += "\"
         LOOP
      CASE c == "B"
         oFont:Bold        := .T.
         lSetFont          := .T.
         IF At("\B", ::LastOptions) == 0
            ::LastOptions += "\B"
         ENDIF
      CASE c == "I"
         oFont:Italic      := .T.
         lSetFont          := .T.
         IF At("\I", ::LastOptions) == 0
            ::LastOptions += "\I"
         ENDIF
      CASE c == "U"
         oFont:Underscore  := .T.
         lSetFont          := .T.
         IF At("\U", ::LastOptions) == 0
            ::LastOptions += "\U"
         ENDIF
      CASE c == "C"
         oFont:Bold        := .F.
         oFont:Italic      := .F.
         oFont:Underscore  := .F.
         oFont:WeightClass := XBPFONT_WEIGHT_NORMAL
         lSetFont          := .T.
         ::LastOptions     := ""
      CASE c == "T"
         IF ::TabStops == 0
            LOOP
         ENDIF

         lTabify := .T.
         IF At("\T", ::LastOptions) == 0
            ::LastOptions += "\T"
         ENDIF
      OTHERWISE
         // (Assume escaped character)
         cTmp += cLine[i]
   ENDCASE

   IF Len(cTmp) > 0
      Eval( bCallback, oPS, cTmp, @xData )
      GraPos( oPS, aPos )

      aBox    := GraQueryTextBox( oPS, cTmp )
      aPos[1] += (aBox[3,1]-aBox[1,1])
   ENDIF

   IF lSetFont == .T.
      oFont:Width := 0
      oFont:Configure()
      oPS:SetFont( oFont )
   ENDIF

   IF lTabify == .T.
      IF (aPos[1] % ::TabStops) != 0
         aPos[1] := Int( aPos[1] / ::TabStops ) +1
      ELSE
         aPos[1] := Int( aPos[1] / ::TabStops )
      ENDIF

      aPos[1] := aPos[1] * ::TabStops
   ENDIF

   GraPos( oPS, aPos )

   cTmp := ""
NEXT

IF Len(cTmp) > 0
   Eval( bCallback, oPS, cTmp, @xData )
ENDIF

oPS:SetFont( oFontPrev )

RETURN

* ------------

METHOD DC_XbpStatic:DrawCaptionLine( oPS, cLine )
RETURN ::ParseCaptionLine(oPS, cLine, {|oPS,cElem| GraStringAt(oPS,, cElem)})

* ------------

METHOD DC_XbpStatic:ComputeLineWidth( oPS, cLine )

 LOCAL nWidth    := 0

/*
 LOCAL bCallback := {|oPS,cElem,nWidth,aBox| (wtf cElem), aBox   := GraQueryTextBox(oPS, cElem),;
                                             nWidth := GraPos(oPS)[1] + (aBox[3,1] - aBox[1,1]), (wtf nWidth), nWidth}
   ::ParseCaptionLine( oPS, cLine, bCallback, @nWidth )
*/

 LOCAL bCallback := {|oPS,cElem,nWidth,aBox| aBox   := GraQueryTextBox(oPS, cElem),;
                                             nWidth += (aBox[3,1] - aBox[1,1]) + 5}
   ::ParseCaptionLine( oPS, cLine, bCallback, @nWidth )

RETURN nWidth

* ------------------------

STATIC FUNCTION _StaticScroll( a, oScroll )

LOCAL nEvent, aCargo := oScroll:cargo
LOCAL oStatic1 := aCargo[1], oStatic2 := aCargo[2], nStart := aCargo[3], ;
      nOffset := aCargo[4], nScroll := aCargo[5]

nEvent := NextAppEvent()
IF nEvent = xbeSB_Scroll
  RETURN nil
ENDIF

IF a[2] == XBPSB_NEXTPAGE
  nOffset += oStatic1:currentSize()[nScroll]
  oScroll:setData()
ELSEIF a[2] == XBPSB_PREVPAGE
  nOffset -= oStatic1:currentSize()[nScroll]
  oScroll:setData()
ELSEIF a[2] == XBPSB_SLIDERTRACK
  nOffset := a[1]
ELSE
  nOffset := a[1]
ENDIF

IF nScroll = 1 // vertical
  oStatic2:setPos({oStatic2:currentPos()[1],nStart+nOffset})
ELSE // horizontal
  oStatic2:setPos({nStart-nOffset,oStatic2:currentPos()[2]})
ENDIF
aCargo[4] := nOffset

RETURN nil

* =========================================================================

CLASS DC_XbpCheckBox FROM DC_XbpCheckBoxSuper, DC_XbaseParts
EXPORTED:
  VAR captionBlock
  VAR varBlock
  VAR validate
  VAR color
  VAR size
  VAR actionBlock
  VAR options
  _METHOD Init, Create, Refresh, WhenHideEval
ENDCLASS

* ------------------

METHOD DC_XbpCheckBox:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xData, cCaption, lAutoSize := .f., aGetList, aGetListItem, aGetOptions, bBlock

::size := aSize
DEFAULT ::size := {0,0}
IF ::size[1] = 0
  ::size[2] := 0
  lAutoSize := .t.
ENDIF

::DC_XbaseParts:init( oGetList,,self)

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
IF Valtype(::varBlock) = 'B'
  xData := Eval(::varBlock)
  IF !DC_ReadDataCheck( xData, 'L', aGetList, ::getListPointer )
    RETURN nil
  ENDIF
ENDIF

IF Empty(aPres)
  aPres := { { XBP_PP_DISABLED_BGCLR, GRA_CLR_BACKGROUND } }
ENDIF

::XbpCheckBox:init( oParent, oOwner, aPos, ::size, aPres, lVisible )

::options := aGetListItem[xGETLIST_OPTIONS]

cCaption := aGetListItem[cGETLIST_CAPTION]
IF Valtype(cCaption) = 'B'
  ::captionBlock := cCaption
  cCaption := DC_XtoC(Eval(cCaption,self))
ENDIF
IF Valtype(cCaption) = 'C'
  ::caption := cCaption
ENDIF

DEFAULT cCaption := ''

IF Valtype(::options) = 'N' .AND. Valtype(::caption) = 'C'
  ::caption := StrTran(::caption,';',Chr(13))
ENDIF

::clipSiblings := .T.

IF Valtype(::varBlock) = 'B'
  ::selection := Eval( ::varBlock )
ENDIF

::datalink := ::varBlock

IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|DC_HiliteGets(o,2,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
ENDIF

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  ::SetFontCompoundName( Alltrim(aGetlistItem[cGETLIST_FONT]) )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
IF Valtype(bBlock)=='B'
  ::selected := DC_MergeBlocks({|a,b,o|o:GetData()},bBlock,self)
ELSE
  ::selected := {|a,b,o|o:GetData()}
ENDIF

/*
::keyboard := {|a,b,o,k|k:=(a=xbeK_SPACE),;
              IIF(k,DC_GetRefresh(aGetList,nil, ;
              DCGETREFRESH_TYPE_EXCLUDE,{GETLIST_BROWSE},,.f.),nil)}
*/

::validate := DC_GetBlock(aGetListItem[bGETLIST_VALID])
::autoSize := lAutoSize
::color := aGetListItem[aGETLIST_COLOR]
::cargo := { ::getListPointer, aGetList,  aGetListItem[xGETLIST_CARGO] } ; // User Cargo

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpCheckBox:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aArray, aGetListItem, nOptions

::xbpCheckBox:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]

DC_XbpSetColor( ::color, self, ::setParent(), ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

IF ::size[1] = 0 .AND. !Empty(::caption)
  aArray := GraQueryTextBox( ::lockPS(), ::caption + Chr(255) + Chr(255) )
  ::size[1] := aArray[3,1] - aArray[1,1] + 20 // width
  //  ::size[2] := Max( ::size[2], ( aArray[1,2] - aArray[2,2]) ) // height
  ::size[2] := Max( ::size[2], ( aArray[1,2] - (aArray[2,2] * 2))) // height - Jack Djuif

  ::unlockPS()
  ::setSize( ::size )
ENDIF

IF Valtype(::options) == 'N'
  nOptions := GetWindowLonga(::GetHwnd(), GWL_STYLE) + ::options
  SetWindowLongA(::GetHwnd(), GWL_STYLE, nOptions )
ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* --------------------

METHOD DC_XbpCheckBox:refresh()

::SetData( Eval(::datalink) )

DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )

IF Valtype(::captionBlock)='B'
  ::SetCaption(Eval(::captionBlock,self))
ENDIF

RETURN self

* ---------------------------

METHOD DC_XbpCheckBox:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ====================

CLASS DC_XbpComboBox FROM DC_XbpComboBoxSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR listBlock
  VAR pointerBlock
  VAR color
  VAR dataValue
  _METHOD Init, Create, Refresh, WhenHideEval
ENDCLASS

* --------------------

METHOD DC_XbpComboBox:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aArray, nWidth, nHeight, xData, ;
      aGetList, aGetListItem, aGetOptions

DEFAULT aSize := {0,0}
nWidth := aSize[1]
nHeight := aSize[2]

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::listBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
::color := aGetListItem[aGETLIST_COLOR]
IF Empty(aPres)
  DEFAULT ::color := { GRA_CLR_BLACK, GRA_CLR_WHITE }
ENDIF

IF Valtype(nWidth) # 'N'
  IF Valtype(::listBlock) = 'B'
    nWidth := (Len(Transform(Eval(::listBlock),''))*8.5) + 7
  ENDIF
ENDIF

IF Valtype(::listBlock) = 'B'
  aArray := Eval( ::listBlock )
  IF !DC_ReadDataCheck( aArray, 'A', aGetList, ::getListPointer )
    RETURN nil
  ENDIF
ENDIF

IF Valtype(::varBlock) = 'B'
  xData := Eval(::varBlock)
  IF !DC_ReadDataCheck( xData, 'C', aGetList, ::getListPointer )
    RETURN nil
  ENDIF
ENDIF

aSize := {nWidth,nHeight}

::XbpComboBox:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::clipSiblings := .T.

::type := aGetListItem[nGETLIST_SUBTYPE]
IF Empty(::type) .OR. Valtype(::type) # 'N'
  ::type := XBPCOMBO_DROPDOWN
ENDIF
IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  ::SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
ENDIF

::XbpSLE:datalink := ::varBlock

IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:GetList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|o:xbpSLE:getData(),DC_HiliteGets(o,2,o:GetList:getOptions[nGETOPT_HILITECOLOR]) }
ELSE
  ::killInputFocus := {|x,y,o|o:xbpSLE:getData()}
ENDIF

::pointerBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS2])

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

xOptions := aGetListItem[xGETLIST_OPTIONS]
DEFAULT xOptions := {}
ASize(xOptions,2)
DEFAULT xOptions[1] := .f., ;
        xOptions[2] := .f.

IF xOptions[1] // REFRESH clause was used
  IF xOptions[2] // IMMEDIATE clause was used
    ::ItemMarked := {|mp1, mp2, obj|DC_VarFromListBox( obj ), ;
                      DC_GetRefresh(obj:getList:getListArray, nil, ;
                      DCGETREFRESH_TYPE_EXCLUDE,{GETLIST_BROWSE})}
  ELSE
    ::ItemSelected := {|mp1, mp2, obj|DC_VarFromListBox( obj ), ;
                      DC_GetRefresh(obj:getList:getListArray, nil, ;
                      DCGETREFRESH_TYPE_EXCLUDE,{GETLIST_BROWSE})}
  ENDIF
ELSE
  IF xOptions[2] // IMMEDIATE clause was used
    ::ItemMarked := {|mp1, mp2, obj|DC_VarFromListBox( obj )}
  ELSE
    ::ItemSelected := {|mp1, mp2, obj|DC_VarFromListBox( obj )}
  ENDIF
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS2]
IF Valtype(xOptions) = 'B'
  ::itemMarked := DC_MergeBlocks(::itemMarked,xOptions)
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS3]
IF Valtype(xOptions) = 'B'
  ::itemSelected := DC_MergeBlocks(::itemSelected,xOptions)
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_VALID])
::XbpSLE:validate := bBlock
::validate := bBlock

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpComboBox:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL j, bBlock, aArray, aGetListItem

aGetListItem := ::getList:getListArray[::getListPointer]

::xbpComboBox:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

DC_XbpSetColor( ::color, self, ::setParent(), ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
IF Valtype(bBlock) = 'B'
  aArray := Eval( bBlock )
ENDIF
IF Valtype(aArray) = 'A'
  FOR j := 1 TO LEN(aArray)
    ::Additem(aArray[j])
  NEXT
ENDIF

IF Valtype(::XbpSLE:dataLink) = 'B'
  ::XbpSLE:SetData()
ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* -------------------

METHOD DC_XbpComboBox:refresh()

::XbpSLE:SetData()

DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )

RETURN self

* ---------------------------

METHOD DC_XbpComboBox:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ====================

CLASS DC_Xbp3State FROM DC_Xbp3StateSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR color
  VAR promptArray
  VAR optionArray
  VAR size
  _METHOD Init, Create, Refresh, WhenHideEval
ENDCLASS

* ------------------

METHOD DC_Xbp3state:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL bBlock, aGetList, xData, aGetListItem, aGetOptions, ;
      nHeight, lAutoSize := .f., xFont, nWidth := nil

::size := aSize
DEFAULT ::size := {0,0}
IF ::size[1] = 0
  ::size[2] := 0
  lAutoSize := .t.
ENDIF

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

IF nWidth = 0
  nHeight := 0
  lAutoSize := .t.
ENDIF
aSize := { nWidth, nHeight }

::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
IF Valtype(::varBlock) = 'B'
  xData := Eval(::varBlock)
  IF !DC_ReadDataCheck( xData, 'NIF', aGetList, ::getListPointer )
    RETURN nil
  ENDIF
ENDIF

::color := aGetListItem[aGETLIST_COLOR]

IF Empty(aPres)
  aPres := { { XBP_PP_DISABLED_BGCLR, GRA_CLR_BACKGROUND }, ;
             { XBP_PP_BGCLR, GRA_CLR_BACKGROUND } }
ENDIF

::Xbp3State:init( oParent, oOwner, aPos, ::size, aPres, lVisible )

::clipSiblings := .T.
::autoSize := lAutoSize
::datalink := ::varBlock
::promptArray := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])

::validate := DC_GetBlock(aGetListItem[bGETLIST_VALID])

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

::selected := {| a,b,o| o:refresh(.t.) }

::keyboard := {|a,b,o,k, n|k:=(a=xbeK_ENTER), ;
                           n:=o:editBuffer(),;
                           n:=n+1, n:=IIF(n>2,0,n),;
                           IIF(k, (o:SetData(n),;
                                   o:GetData(),;
                                   o:refresh(.t.), ;
                                   DC_GetRefresh(o:getList:getListArray,nil, ;
                                 DCGETREFRESH_TYPE_EXCLUDE,{GETLIST_BROWSE})), nil ) }

xFont := aGetListItem[cGETLIST_FONT]
IF !Empty(xFont)
  IF Valtype(xFont) == 'B'
    xFont := Eval(xFont)
  ENDIF
  IF Valtype(xFont) == 'O'
    ::SetFont(xFont)
  ELSE
    ::SetFontCompoundName( xFont )
  ENDIF
ENDIF
IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|DC_HiliteGets(o,2,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_Xbp3State:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aArray, aGetListItem

::xbp3State:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]

DC_XbpSetColor( ::color, self, ::setParent(), ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

IF ::size[1] = 0 .AND. !Empty(::caption)
  aArray := GraQueryTextBox( ::lockPS(), ::caption + Chr(255) + Chr(255) )
  ::size[1] := aArray[3,1] - aArray[1,1] + 20 // width
  // ::size[2] := Max( ::size[2], ( aArray[1,2] - aArray[2,2]) ) // height
  ::size[2] := Max( ::size[2], ( aArray[1,2] - (aArray[2,2] * 2))) // height - Jack Djuif

  ::unlockPS()
  ::setSize( ::size )
ENDIF

::DC_XbaseParts:setOrig(self)

IF Valtype(::datalink) = 'B'
  ::SetData()
ENDIF

::refresh(.t.)

RETURN self

* -------------------

METHOD DC_Xbp3State:refresh( lCaptionOnly )

LOCAL aArray
DEFAULT lCaptionOnly := .f.

IF !lCaptionOnly
  ::SetData(Eval(::varBlock))
  DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )
ENDIF

aArray := ::promptArray
IF Valtype(aArray) == 'B'
  aArray := Eval(aArray)
ENDIF

DEFAULT aArray := { '0 state', '1 state', '2 state' }

::SetCaption(aArray[::getData()+1])

RETURN self

* ---------------------------

METHOD DC_Xbp3State:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ====================

CLASS DC_XbpMle FROM DC_XbpMleSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR validBlock
  VAR color
  VAR exitKey
  VAR maxLines
  VAR maxLinesMsg
  VAR maxLineLen
  VAR maxLineLenMsg
  VAR maxChars
  VAR maxCharsMsg
  VAR started
  VAR goBottom
  VAR optionArray
  _METHOD Init, Create, Refresh, Validate, WhenHideEval
ENDCLASS

* --------------------

METHOD DC_XbpMLE:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, xData, aGetList, aGetListItem, aGetOptions

::XbpMLE:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF Valtype(oGetList) # 'O'
  RETURN self
ENDIF

::DC_XbaseParts:init(oGetList,,self)

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])

IF Valtype(::varBlock) = 'B'
  xData := Eval(::varBlock)
  IF !DC_ReadDataCheck( xData, 'CM', aGetList, ::getListPointer )
    RETURN nil
  ENDIF
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS]

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF Valtype(aGetListItem[cGETLIST_FONT])='C'
  ::SetFontCompoundName(Alltrim(aGetListItem[cGETLIST_FONT]))
ENDIF

::goBottom := .f.

IF Valtype(xOptions) = 'A'
  ASize(xOptions,9)
  ::WordWrap    := !xOptions[1]
  ::Border      := !xOptions[2]
  ::VertScroll  := !xOptions[3]
  ::HorizScroll := !xOptions[4]
  ::IgnoreTab   := xOptions[5]
  ::goBottom    := xOptions[9]
  DEFAULT ::goBottom := .f.
  IF Valtype(xOptions[6])='L' .AND. xOptions[6]
    ::keyboard := {|mp1,mp2,oMLE|DC_GuiMemoNav(mp1,mp2,oMLE)}
  ENDIF
ENDIF

::optionArray := xOptions
::color := aGetListItem[aGETLIST_COLOR]
DEFAULT ::color := { GRA_CLR_BLACK, GRA_CLR_WHITE }

IF Valtype(xOptions[7]) = 'L'
  ::editable := !xOptions[7]
ENDIF
::clipSiblings := .T.
::datalink := ::varBlock
IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|o:getData(),DC_HiliteGets(o,2,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
ELSE
  ::killInputFocus := {|x,y,o|o:getData()}
ENDIF

DEFAULT aGetListItem[xGETLIST_OPTIONS2] := {}
ASize( aGetListItem[xGETLIST_OPTIONS2], 2 )
DEFAULT aGetListItem[xGETLIST_OPTIONS3] := {}
ASize( aGetListItem[xGETLIST_OPTIONS3], 2 )
DEFAULT aGetListItem[xGETLIST_OPTIONS4] := {}
ASize( aGetListItem[xGETLIST_OPTIONS4], 2 )

IF !Empty(aGetListItem[xGETLIST_OPTIONS2,1]) .OR. ;
  !Empty(aGetListItem[xGETLIST_OPTIONS3,1]) .OR. ;
  !Empty(aGetListItem[xGETLIST_OPTIONS4,1])
  ::keyboard := DC_MergeBlocks(::keyboard,{|mp1,mp2|::Validate(mp1,mp2)})
ENDIF

::validBlock := DC_GetBlock(aGetListItem[bGETLIST_VALID])
::exitKey := _Default(xOptions[8],0)
::maxLines := aGetListItem[xGETLIST_OPTIONS2,1]
::maxLinesMsg := aGetListItem[xGETLIST_OPTIONS2,2]
::maxLineLen := aGetListItem[xGETLIST_OPTIONS3,1]
::maxLineLenMsg := aGetListItem[xGETLIST_OPTIONS3,2]
::maxChars := aGetListItem[xGETLIST_OPTIONS4,1]
::maxCharsMsg := aGetListItem[xGETLIST_OPTIONS4,2]
::started := .f.

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

DC_XbpSetColor( ::color, self, ::setParent(), ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpMLE:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::xbpMLE:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF Valtype(::getList) # 'O'
  RETURN self
ENDIF

IF Valtype(::dataLink) = 'B'
  ::SetData()
  IF ::goBottom
    ::setFirstChar(Len(::editBuffer()))
  ENDIF
ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* -------------------

METHOD DC_XbpMLE:refresh()

LOCAL nFirstChar := ::queryFirstChar(), bDataLink := ::dataLink

IF Valtype(::dataLink) = 'B'
  ::SetData()
  ::dataLink := nil
  IF Eval(bDataLink) == ::getData()
    ::setFirstChar(nFirstChar)
  ENDIF
  ::dataLink := bDataLink
ENDIF

DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )

RETURN self

* ---------------------------

METHOD DC_XbpMLE:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ---------------------------

METHOD DC_XbpMLE:validate(mp1,mp2)

LOCAL cBuffer, aLines, i, bcMessage, oAppFocus := SetAppFocus(), nPos

cBuffer     := ::editBuffer()
nPos        := ::pos()
Grok(mp1,mp2)

BEGIN SEQUENCE

IF !Empty(::maxLines) .OR. !Empty(::maxLineLen)
  aLines := DC_TokenArray(cBuffer,chr(13))
  IF !Empty(::maxLines)
    IF Len(aLines) > ::maxLines
      bcMessage := ::maxLinesMsg
      IF Valtype(bcMessage) = 'B'
        bcMessage := Eval(bcMessage,mp1)
      ELSEIF Valtype(bcMessage) = 'C'
        DC_WinAlert(bcMessage)
      ENDIF
      SetAppFocus(oAppFocus)
      IF !::started
        ::undo()
        nPos := ::charFromLine(::maxLines+1)
        ::setMarked( {nPos-2,Len(::getData())+2} )
        ::deleteMarked()
      ELSE
        ::delete(nPos-2,2)
      ENDIF
      BREAK
    ENDIF
  ENDIF
  IF !Empty(::maxLineLen)
    FOR i := 1 TO Len(aLines)
      IF Len(Strtran(aLines[i],Chr(10),'')) > ::maxLineLen
        bcMessage := ::maxLineLenMsg
        IF Valtype(bcMessage) = 'B'
          bcMessage := Eval(bcMessage,mp1)
        ELSEIF Valtype(bcMessage) = 'C'
          DC_WinAlert(bcMessage)
        ENDIF
        SetAppFocus(oAppFocus)
        ::delete(nPos-1,1)
        BREAK
      ENDIF
    NEXT
  ENDIF
ENDIF

IF !Empty(::maxChars) .AND. Len(Trim(cBuffer)) > ::maxChars
  bcMessage := ::maxCharsMsg
  IF Valtype(bcMessage) = 'B'
    bcMessage := Eval(bcMessage,mp1)
  ELSEIF Valtype(bcMessage) = 'C'
    DC_WinAlert(bcMessage)
  ENDIF
  SetAppFocus(oAppFocus)
  ::delete(nPos-1,1)
ENDIF

END SEQUENCE

::started := .t.

RETURN self

* ---------------------------

FUNCTION DC_MleValid( mp1, mp2, oMLE )

oMLE:validate(mp1,mp2)

RETURN nil

* ====================

CLASS DC_XbpSle FROM DC_XbpSleSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR validBlock
  VAR color
  VAR optionArray
  _METHOD Init, Create, Refresh, WhenHideEval
ENDCLASS

* --------------------

METHOD DC_XbpSLE:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, xData, aGetList, aGetListItem, aGetOptions

::XbpSLE:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF Valtype(oGetList) # 'O'
  RETURN self
ENDIF

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])

IF Valtype(::varBlock) = 'B'
  xData := Eval(::varBlock)
  IF !DC_ReadDataCheck( xData, 'CM', aGetList, ::getListPointer )
    RETURN nil
  ENDIF
ENDIF

IF Valtype(aGetListItem[xGETLIST_OPTIONS2]) == 'N'
  ::bufferLength := aGetListItem[xGETLIST_OPTIONS2]
ENDIF

IF Valtype(aGetListItem[xGETLIST_OPTIONS3]) == 'C'
  ::cueBanner := aGetListItem[xGETLIST_OPTIONS3]
ENDIF

IF Valtype(aGetListItem[xGETLIST_OPTIONS4]) == 'N'
  ::align := aGetListItem[xGETLIST_OPTIONS4]
ENDIF

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF Valtype(aGetListItem[cGETLIST_FONT])='C'
  ::SetFontCompoundName(Alltrim(aGetListItem[cGETLIST_FONT]))
ENDIF

::color := aGetListItem[aGETLIST_COLOR]
DEFAULT ::color := { GRA_CLR_BLACK, GRA_CLR_WHITE }

::clipSiblings := .T.
::datalink := ::varBlock
IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|o:getData(),DC_HiliteGets(o,2,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
ELSE
  ::killInputFocus := {|x,y,o|o:getData()}
ENDIF

::validBlock := DC_GetBlock(aGetListItem[bGETLIST_VALID])

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

DC_XbpSetColor( ::color, self, ::setParent(), ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpSLE:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::xbpSLE:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF Valtype(::getList) # 'O'
  RETURN self
ENDIF

IF Valtype(::dataLink) = 'B'
  ::SetData()
ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* -------------------

METHOD DC_XbpSLE:refresh()

LOCAL bDataLink := ::dataLink

IF Valtype(::dataLink) = 'B'
  ::SetData()
  ::dataLink := bDataLink
ENDIF

DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )

RETURN self

* ---------------------------

METHOD DC_XbpSLE:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ==============================================

CLASS DC_XbpToolBar FROM DC_XbpToolBarSuper, DC_XbaseParts

EXPORTED:
  VAR optionArray
  VAR fancy
  VAR align
  VAR buttonWidth
  VAR buttonHeight
  VAR buttonRow
  VAR buttonCol
  VAR pixel
  VAR scrollOffset
  VAR spacing
  VAR fontCompoundName
  VAR fit
  VAR anchor
  VAR buttonConfig
  _METHOD Init, Create, WhenHideEval
ENDCLASS

* ---------------------

METHOD DC_XbpToolBar:Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, lPixel, aGetList, aGetListItem, aGetOptions, ;
      cFont, cFontFamilyName, nPointSize

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions
::spacing := 0

lPixel := aGetListItem[lGETLIST_PIXEL]

xOptions := aGetListItem[xGETLIST_OPTIONS]
ASize(xOptions,8)
DEFAULT xOptions[4] := .f., ; // FANCY off
        xOptions[5] := .f., ; // Vertical
        xOptions[6] := .f., ; // Horizontal
        xOptions[7] := 0,   ; // Spacing
        xOptions[8] := .f.    // Fit to buttons

::spacing := xOptions[7]
::fit := xOptions[8]

IF xOptions[5] // vertical
  ::align := TOOLBAR_LEFT
ELSEIF xOptions[6] // horizontal
  ::align := TOOLBAR_TOP
ELSE
  ::align := IIF( aSize[1] > aSize[2], TOOLBAR_TOP, TOOLBAR_LEFT )
ENDIF

::anchor := xOptions[1]

IF Empty(aGetListItem[nGETLIST_SUBTYPE])
  aGetListItem[nGETLIST_SUBTYPE] := XBPSTATIC_TYPE_TEXT
ENDIF

::XbpStatic:Init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::type    := aGetListItem[nGETLIST_SUBTYPE]

::tabstop := .f.

::buttonWidth := xOptions[2]
::buttonHeight := xOptions[3]

IF !lPixel .AND. Valtype(::buttonWidth)='N' .AND. Valtype(::buttonHeight)='N'
  ::buttonWidth *= aGetOptions[nGETOPT_COLPIXELS]
  ::buttonHeight *= aGetOptions[nGETOPT_ROWPIXELS]
ENDIF

IF Empty(::buttonWidth)
  IF aSize[1] < aSize[2]
    ::buttonWidth := 70
  ELSE
    ::buttonWidth := aSize[1]
  ENDIF
ENDIF

IF Empty(::buttonHeight)
  IF aSize[2] < aSize[1]
    ::buttonHeight := aSize[2]
  ELSE
    ::buttonHeight := 20
  ENDIF
ENDIF

//::buttonWidth *= ::GetList:scalefactor[3]
::buttonHeight *= ::GetList:scalefactor[4]

::buttonRow := 0
::buttonCol := 0
::fancy := xOptions[4]
::scrollOffset := 0
::pixel := lPixel
::buttonConfig := aGetListItem[xGETLIST_OPTIONS2]

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  cFont := Alltrim(aGetListItem[cGETLIST_FONT])
  /*
  IF ::GetList:scaleFactor[5]
    nPointSize := Val(cFont)
    cFontFamilyName := SubStr(cFont,At('.',cFont)+1)
    cFont := Alltrim(Str(Round(nPointSize * ::GetList:scaleFactor[3],0))) + ;
               '.' + cFontFamilyName
  ENDIF
  */
  ::setFontCompoundName(cFont)
  ::fontCompoundName := cFont
ENDIF

::clipSiblings := .T.

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------------

METHOD DC_XbpToolBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem

::XbpStatic:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]

DEFAULT oParent := ::setParent()

DC_XbpSetColor( aGetListItem[aGETLIST_COLOR], self, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

::DC_XbaseParts:setOrig(self)

RETURN self

* ---------------------------

METHOD DC_XbpToolBar:WhenHideEval( lEnable, lShow, lProtect )

LOCAL aChildren, i

IF Valtype(::whenBlock) = 'B'
  lEnable:= Eval(::whenBlock,self)
  aChildren := ::childList()
  FOR i := 1 TO Len(aChildren)
    IF lEnable
      aChildren[i]:enable()
    ELSE
      aChildren[i]:disable()
    ENDIF
  NEXT
ENDIF

IF Valtype(::hideBlock) = 'B'
  lShow := !Eval(::hideBlock,self)
  IF lShow
    ::show()
  ELSE
    ::hide()
  ENDIF
ENDIF

IF Valtype(lProtect) == 'L' .AND. Valtype(::protectBlock) = 'B'
  lProtect := Eval(::protectBlock,self)
ENDIF

RETURN self

* =====================

CLASS DC_XbpTabPage FROM DC_XbpTabPageSuper, DC_XbaseParts

EXPORTED:

  VAR validBlock
  VAR actionBlock
  VAR color
  VAR tabNumber
  VAR enabledColorBG
  VAR disabledColorBG
  VAR enabledColorFG
  VAR disabledColorFG
  VAR enabledColorBlock
  VAR disabledColorBlock
  VAR saveColor
  VAR gotFocusBlock
  VAR lostFocusBlock
  VAR captionBlock
  VAR staticArea
  VAR optionArray
  VAR relTabPage
  VAR origSize
  VAR lockUpdate
  VAR resize
  VAR captionResType
  VAR captionResFile
  VAR initPos
  VAR minMaxColor
  _METHOD Init, Create, Refresh, WhenHideEval, TabGetHWND, SetCaption
  _METHOD Draw
  // _METHOD LockUpdate

  VAR Image
  VAR SelectedImage
  VAR DisabledImage
  VAR DLLName
  VAR TextAlign
  VAR ImageAlign
  VAR CaptionLayout
  VAR font
  VAR isCreateChildren

  _METHOD CreateChildren

PROTECTED:
      // GRA attributes for tab page elements
  VAR TextAttrs
  VAR AreaAttrs
      // Rectangles for tab page element alignment, see
      // ::ComputeLayout()
  VAR ImageRect
  VAR TextRect

  _METHOD ComputeLayout, DrawText, DrawImage

ENDCLASS

* ---------------------

METHOD DC_XbpTabPage:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList, oRel )

LOCAL xOptions, cCaption, bBlock, nStyle, aArray, aGetList, ;
      aGetListItem, aGetOptions, nWidth, nHeight, aColors

DEFAULT aSize := {0,0}
nWidth := aSize[1]
nHeight := aSize[2]

IF nWidth <= 0
  nWidth := 500
ENDIF
IF nHeight <= 0
  nHeight := 300
ENDIF

::DC_XbaseParts:init( oGetList,,self )

aSize := { nWidth, nHeight }

IF Empty(aPres)
  aPres := { { XBP_PP_DISABLED_BGCLR, GRA_CLR_BACKGROUND } }
ENDIF

::XbpTabPage:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF IsMemberVar(self,'useVisualStyle')
  ::useVisualStyle := .t.
ENDIF

::tabstop := .f.
::lockUpdate := .F.

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions
::clipChildren := .t.

IF Valtype(aGetListItem[xGETLIST_OPTIONS6]) == 'L'
  ::isCreateChildren := !aGetListItem[xGETLIST_OPTIONS6]
ELSE
  ::isCreateChildren := .t.
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS2]
DEFAULT xOptions := {}
ASize(xOptions,2)

::captionResType := xOptions[1]
::captionResFile := xOptions[2]

IF Valtype(oRel) # 'O'
  bBlock := DC_GetBlock(aGetListItem[bGETLIST_RELATIVE],'O')
  IF Valtype( bBlock ) = 'B'
    oRel := Eval( bBlock )
  ENDIF
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS]
DEFAULT xOptions := {}
ASize(xOptions,6)

::optionArray := xOptions

nStyle := xOptions[5] // tab width
IF Valtype(nStyle) = 'N'
  IF !aGetListItem[lGETLIST_PIXEL]
    nStyle *= aGetOptions[nGETOPT_COLPIXELS]
  ENDIF
  nStyle *= ::getList:scaleFactor[3]
ENDIF

IF ( Valtype(xOptions[1]) = 'U' .OR. Valtype(xOptions[2]) = 'U' ) .OR. ;
         Empty(xOptions[1]) .AND. Empty(xOptions[2])
  IF Valtype(oRel) = 'O'
    ::relTabPage := oRel
    xOptions[1] := oRel:preOffset + (100-(oRel:preOffset+oRel:postOffset))
    xOptions[2] := oRel:postOffset - (100-(oRel:preOffset+oRel:postOffset))
    xOptions[4] := oRel:TabHeight
    aGetListItem[aGETLIST_RESIZE] := oRel:resize
    ::resize := oRel:resize
  ELSE
    xOptions[1] := 0
    xOptions[2] := 85
    ::resize := aGetListItem[aGETLIST_RESIZE]
  ENDIF
ENDIF

IF Len(::getList:tabpageControls)=0
  ::minimized := .f.
ENDIF
cCaption := aGetListItem[cGETLIST_CAPTION]
IF Valtype(cCaption) = 'B'
  ::captionBlock := cCaption
  cCaption := DC_Xtoc(Eval(cCaption,self))
ENDIF
IF Empty(cCaption)
  cCaption := 'TabPage'
ENDIF
::caption := DC_GetBitmap(cCaption,,::captionResType,::captionResFile,,.t.)

IF Valtype(xOptions[4]) = 'N' .AND. xOptions[4] >= 0
  IF Valtype(oRel) = 'O'
    ::TabHeight := oRel:TabHeight
  ELSE
    ::TabHeight := xOptions[4] * ::getList:scaleFactor[4]
  ENDIF
ENDIF

IF ::TabHeight == -1 // .AND. ::getList:scaleFactor[4] # 1
  ::TabHeight := 20 * ::getList:scaleFactor[4]
ENDIF

IF Valtype(xOptions[6]) = 'N'
  ::angle := xOptions[6]
ELSEIF Valtype(oRel) = 'O' .AND. Valtype(oRel:angle) = 'N'
  ::angle := oRel:angle
ENDIF

nWidth := aSize[1]

IF Valtype(nStyle) = 'N'
  IF Valtype(oRel) = 'O'
    ::preOffset := oRel:preOffset + Round(100-(oRel:preOffset+oRel:postOffset),2)
    ::postOffset := ;
      Round((((( nStyle + ( nWidth * ::preOffset * .01 ) ) / nWidth) / .01) - 100) * -1,2)
  ELSE
    ::preOffset := 0
    ::postOffset := Round(100 - ( nStyle/nWidth) * 100,2)
  ENDIF

ELSE
  IF Valtype(xOptions[1]) = 'N'
    ::preOffset := xOptions[1]
  ENDIF
  IF Valtype(xOptions[2]) = 'N'
    ::postOffset := xOptions[2]
  ENDIF
ENDIF
IF !Empty(aGetListItem[nGETLIST_SUBTYPE])
  ::type := aGetListItem[nGETLIST_SUBTYPE]
ENDIF

IF DC_EnableTabPageColors()

  aArray := aGetListItem[aGETLIST_COLOR]
  IF Valtype(aArray) == 'A' .AND. IsMemberVar(self,'useVisualStyle')
    ::useVisualStyle := .f.
  ENDIF
  DEFAULT aArray := { nil, nil }
  ASize(aArray,2)
  ::enabledColorBlock := aArray[1]
  IF Valtype(::enabledColorBlock) = 'B'
    aColors := Eval(::enabledColorBlock,self)
    DEFAULT aColors := {}
    ASize(aColors,2)
    ::enabledColorFG := ConvertColor(aColors[1])
    ::enabledColorBG := ConvertColor(aColors[2])
    ::setColorBG(::enabledColorBG)
    ::setColorFG(::enabledColorFG)
  ELSEIF Valtype(::enabledColorBlock) = 'A' .AND. Len(::enabledColorBlock) == 2
    ::enabledColorFG := ConvertColor(::enabledColorBlock[1])
    ::enabledColorBG := ConvertColor(::enabledColorBlock[2])
    ::setColorBG(::enabledColorBG)
    ::setColorFG(::enabledColorFG)
  ELSE
    ::enabledColorBG := ConvertColor(aArray[1])
  ENDIF

  ::disabledColorBlock := aArray[2]
  IF Valtype(::disabledColorBlock) = 'B'
    aColors := Eval(::disabledColorBlock,self)
    DEFAULT aColors := {}
    ASize(aColors,2)
    ::disabledColorFG := ConvertColor(aColors[1])
    ::disabledColorBG := ConvertColor(aColors[2])
  ELSEIF Valtype(::disabledColorBlock) = 'A' .AND. Len(::disabledColorBlock) == 2
    ::disabledColorFG := ConvertColor(::disabledColorBlock[1])
    ::disabledColorBG := ConvertColor(::disabledColorBlock[2])
  ELSE
    ::disabledColorBG := ConvertColor(aArray[2])
  ENDIF

  IF Valtype(::enabledColorBG) == 'N'
    ::colorBG := ::enabledColorBG
  ENDIF
  ::saveColor := aArray[1]

ENDIF

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GOTFOCUS])
::setInputFocus := ;
   _TabInputFocus( bBlock, oGetList:tabpageControls, oGetList:isDisplayFocus, self)

::protectBlock := DC_GetBlock(aGetlistItem[bGETLIST_PROTECT])
::actionBlock := DC_GetBlock(aGetlistItem[bGETLIST_ACTION])
::tabNumber := Len(::getList:tabpageControls) + 1

aArray := aGetListItem[xGETLIST_OPTIONS3]
IF Valtype(aArray) == 'A'
  ::minMaxColor := aArray
ENDIF

aArray := aGetListItem[xGETLIST_OPTIONS4]
IF Valtype(aArray) == 'A'
  ::minMaxFont := aArray
ENDIF

::TextAlign    := XBPALIGN_VCENTER + XBPALIGN_LEFT
::ImageAlign   := XBPALIGN_LEFT + XBPALIGN_VCENTER
::CaptionLayout:= XBP_LAYOUT_TEXTRIGHT

aArray := aGetListItem[xGETLIST_OPTIONS5]
IF Valtype(aArray) == 'A'
  ASize(aArray,6)
  ::image := DC_GetBitmap(aArray[1],,,,,.t.)
  ::selectedImage := DC_GetBitmap(aArray[2],,,,,.t.)
  ::disabledImage := DC_GetBitmap(aArray[3],,,,,.t.)
  IF Valtype(aArray[4]) == 'N'
    ::imageAlign := aArray[4]
  ENDIF
  IF Valtype(aArray[5]) == 'N'
    ::textAlign := aArray[5]
  ENDIF
  IF Valtype(aArray[6]) == 'N'
    ::captionLayout := aArray[6]
  ENDIF
ENDIF

IF AScan( aArray, {|x|!Empty(x)} ) > 0 .AND. IsMemberVar(self,'drawmode')
   ::DrawMode := XBP_DRAW_OWNER
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock)='B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* --------------------

METHOD DC_XbpTabPage:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL bBlock, oStatic, nWidth, nHeight, aGetListItem, xFont, aTabColor, ;
      aColor, nColor

::xbpTabPage:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]

DEFAULT oParent := ::setParent()

xFont := aGetListItem[cGETLIST_FONT]
IF !Empty(xFont)
  IF Valtype(xFont) = 'B'
    xFont := Eval(xFont)
  ENDIF
  IF Valtype(xFont) == 'O'
    ::SetFont(xFont)
  ELSE
    ::SetFontCompoundName( Alltrim(xFont) )
  ENDIF
  ::font := xFont
ELSEIF Valtype(::relTabPage) = 'O' .AND. ::relTabPage:isDerivedFrom('XbpTabPage') .AND. !Empty(::relTabPage:setFont())
  ::SetFont(::relTabPage:SetFont())
ENDIF

::DC_XbaseParts:setOrig(self)

bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR],'O')

IF Valtype(bBlock) = 'B' // put a Static on TabPage
  nWidth := ::currentSize()[1]
  nHeight := ::currentSize()[2]
  oStatic := XbpStatic():new(self,,{3,3}, ;
              {nWidth-6,nHeight-IIF(::tabHeight<=0,30,::tabHeight-10)})

  ::resize := {|a,b,o|::staticArea:setSize({::currentSize()[1]-6, ;
                      ::currentSize()[2]-(::tabHeight+10)})}

  oStatic:type := XBPSTATIC_TYPE_TEXT
  IF IsMemberVar(oStatic,"useVisualStyle")
    oStatic:useVisualStyle := .f.
    oStatic:setcolorBG(XBPSYSCLR_TRANSPARENT)
  ELSE
    oStatic:setColorBG(::colorBG)
  ENDIF
  // oStatic:clipChildren := .T.
  oStatic:create()
  oStatic:cargo := 'STATICAREA'
  Eval( bBlock, oStatic )
  ::staticArea := oStatic
  Eval(::resize)

ENDIF

::origSize := ::currentSize()

aTabColor := DC_TabPageColor()

IF Empty(::enabledColorBlock) .AND. (Valtype(aTabColor) = 'A' .OR. Valtype(::minMaxColor) = 'A')

  IF ::minimized
    IF Valtype(::minMaxColor) == 'A'
      aColor := ::minMaxColor[1]
    ELSE
      aColor := aTabColor[1]
    ENDIF
  ELSE
    IF Valtype(::minMaxColor) == 'A'
      aColor := ::minMaxColor[2]
    ELSE
      aColor := aTabColor[2]
    ENDIF
  ENDIF
  IF Valtype(aColor) == 'A'
    nColor := aColor[1]
    IF Valtype(nColor) = 'A'
      nColor := GraMakeRGBColor(nColor)
    ENDIF
    ::setColorFG(nColor)
    nColor := aColor[2]
    IF Valtype(nColor) = 'A'
      nColor := GraMakeRGBColor(nColor)
    ENDIF
    ::setColorBG(nColor)
  ENDIF
ENDIF

RETURN self

* ---------------------

//////////////////////////////////////////////////////////////////////
/// (Owner-) Draw method which is called by the system to control
/// control drawing of the button
//////////////////////////////////////////////////////////////////////
METHOD DC_XbpTabPage:Draw( oPS, aInfo )

#if XPPVER > 1900331

// Align and draw image and caption
::ComputeLayout( oPS, aInfo )

::DrawImage( oPS, aInfo )
::DrawText( oPS, aInfo )

// Add focus rectangle, if the tab
// page has the input focus
IF BAnd(aInfo[3],XBP_DRAWSTATE_FOCUS) == XBP_DRAWSTATE_FOCUS .OR.;
   ::HasInputFocus() == .T.
   GraFocusRect( oPS, {aInfo[XBP_DRAWINFO_RECT,1],aInfo[XBP_DRAWINFO_RECT,2]},;
                      {aInfo[XBP_DRAWINFO_RECT,3],aInfo[XBP_DRAWINFO_RECT,4]} )
ENDIF

#endif

RETURN .F.


//////////////////////////////////////////////////////////////////////
/// Draw image corresponding to the current object state
//////////////////////////////////////////////////////////////////////
METHOD DC_XbpTabPage:DrawImage( oPS, aInfo )

#if XPPVER > 1900331

LOCAL oImage
LOCAL aRect := AClone( ::ImageRect )
LOCAL nWidth
LOCAL nHeight
LOCAL nImgWidth
LOCAL nImgHeight
LOCAL nDiffX, nDiffY

DO CASE
   CASE BAnd(aInfo[3],XBP_DRAWSTATE_DISABLED) == XBP_DRAWSTATE_DISABLED
      oImage := ::DisabledImage
   CASE BAnd(aInfo[3],XBP_DRAWSTATE_SELECTED) == XBP_DRAWSTATE_SELECTED
      oImage := ::SelectedImage
ENDCASE

IF Valtype(oImage) # 'O'
   oImage = ::Image
ENDIF

IF Valtype(oImage) # 'O'
   RETURN
ENDIF

nImgWidth  = oImage:XSize
nImgHeight = oImage:YSize
nWidth     = aRect[3] - aRect[1]
nHeight    = aRect[4] - aRect[2]

IF nImgWidth > nWidth
   nImgHeight -= (nImgWidth - nWidth)
   nImgWidth  =  nWidth
ENDIF
IF nImgHeight > nHeight
   nImgWidth  -= (nImgHeight - nHeight)
   nImgHeight =  nHeight
ENDIF

nDiffX = nWidth  - nImgWidth
nDiffY = nHeight - nImgHeight

DO CASE
  CASE BAnd(::ImageAlign,XBPALIGN_RIGHT) == XBPALIGN_RIGHT
     aRect[1] += nDiffX
  CASE BAnd(::ImageAlign,XBPALIGN_HCENTER) == XBPALIGN_HCENTER
     aRect[1] += nDiffX /2
     aRect[3] -= nDiffX /2
  OTHERWISE
     // XBPALIGN_LEFT
     aRect[3] -= nDiffX
ENDCASE

DO CASE
  CASE BAnd(::ImageAlign,XBPALIGN_BOTTOM) == XBPALIGN_BOTTOM
    aRect[4] -= nDiffY
  CASE BAnd(::ImageAlign,XBPALIGN_VCENTER) == XBPALIGN_VCENTER
     aRect[2] += nDiffY /2
     aRect[4] -= nDiffY  /2
  OTHERWISE
     // XBPALIGN_TOP
     aRect[2] += nDiffY
ENDCASE

IF BAnd(aInfo[3],XBP_DRAWSTATE_DISABLED) == XBP_DRAWSTATE_DISABLED
   IF oImage:IsDerivedFrom("XbpBitmap") == .T.
      oImage:Draw( oPS, aRect,,,, XBP_STATE_DISABLED )
   ELSE
      oImage:Draw( oPS, aRect, XBP_STATE_DISABLED )
   ENDIF
ELSE
   oImage:Draw( oPS, aRect )
ENDIF

#endif

RETURN


//////////////////////////////////////////////////////////////////////
/// Draw the caption
//////////////////////////////////////////////////////////////////////
METHOD DC_XbpTabPage:DrawText( oPS, aInfo )

#if XPPVER > 1900331

LOCAL aAttrsPrev
LOCAL aAttrs := Array( GRA_AS_COUNT )

IF BAnd(aInfo[3],XBP_DRAWSTATE_DISABLED) == XBP_DRAWSTATE_DISABLED
  aAttrs[GRA_AS_COLOR] := XBPSYSCLR_ACTIVEBORDER
  aAttrsPrev := GraSetAttrString( oPS, aAttrs )
ENDIF

IF Empty(::font)
  GraSetFont( oPS, XbpFont():New():Create(XBPSYSFNT_GUIDEFAULT) )
ELSEIF Valtype(::font) == 'O'
  GraSetFont( oPS, ::font )
ELSEIF Valtype(::font) == 'C'
  GraSetFont( oPS, XbpFont():New():create(::font) )
ENDIF

// WORK-AROUND PDR 6129
oPS:ThemeHandle := 0
GraCaptionStr( oPS, {::TextRect[1],::TextRect[2]}, ;
                    {::TextRect[3],::TextRect[4]}, ::Caption, ;
               ::TextAlign )
IF aAttrsPrev != NIL
  GraSetAttrString( oPS, aAttrsPrev )
ENDIF

#endif

RETURN

//////////////////////////////////////////////////////////////////////
/// Computes rectangles for text and image rendering
///
/// Notes: o This methods initializes members ::TextRect and
///          ::ImageRect
//////////////////////////////////////////////////////////////////////
METHOD DC_XbpTabPage:ComputeLayout( oPS, aInfo )

#if XPPVER > 1900331

LOCAL aRect
LOCAL aSize
LOCAL nImgWidth
LOCAL nImgHeight
LOCAL aImgRect
LOCAL aTxtRect

UNUSED( oPS )

IF ValType(::ImageRect) == "A" .AND. ValType(::TextRect) == "A"
   RETURN
ENDIF

aRect      := aInfo[XBP_DRAWINFO_RECT]
aSize      := {aRect[3]-aRect[1],aRect[4]- aRect[2]}
nImgWidth  := 0
nImgHeight := 0
aImgRect   := {0,0,0,0}
aTxtRect   := {0,0,0,0}

IF ValType(::Image) == "O"
   nImgWidth  := ::Image:XSize
   nImgHeight := ::Image:YSize
ELSEIF Valtype(::SelectedImage) == 'O'
   nImgWidth  := ::SelectedImage:XSize
   nImgHeight := ::SelectedImage:YSize
ENDIF

DO CASE
  CASE ::CaptionLayout == XBP_LAYOUT_TEXTLEFT
     aImgRect[2] := aTxtRect[2] := aRect[2] + TAB_PADDING
     aImgRect[4] := aTxtRect[4] := aRect[4] - TAB_PADDING
     aTxtRect[1] = aRect[1] + STD_SPACING
     aTxtRect[3] = aRect[3] - Min( (aSize[1] - MIN_SPACING) /2, ;
                   nImgWidth + STD_SPACING + MIN_SPACING )
     aImgRect[1] = aTxtRect[3] + MIN_SPACING
     aImgRect[3] = aRect[3] - STD_SPACING
  CASE ::CaptionLayout == XBP_LAYOUT_TEXTTOP
     aImgRect[1] := aTxtRect[1] := aRect[1] + STD_SPACING
     aImgRect[3] := aTxtRect[3] := aRect[3] - STD_SPACING
     aImgRect[2] = aRect[2] + TAB_PADDING
     aImgRect[4] = aRect[2] + Min( (aSize[2] - MIN_SPACING) /2, ;
                   nImgHeight + TAB_PADDING )
     aTxtRect[2] = aImgRect[4] + MIN_SPACING
     aTxtRect[4] = aRect[4] - TAB_PADDING
  CASE ::CaptionLayout == XBP_LAYOUT_TEXTRIGHT
     aImgRect[2] := aTxtRect[2] := aRect[2] + TAB_PADDING
     aImgRect[4] := aTxtRect[4] := aRect[4] - TAB_PADDING
     aImgRect[1] = aRect[1] + STD_SPACING
     aImgRect[3] = aImgRect[1] + Min( (aSize[1] - MIN_SPACING) /2, ;
                   nImgWidth + MIN_SPACING )
     aTxtRect[1] = aImgRect[3] + MIN_SPACING
     aTxtRect[3] = aRect[3] - STD_SPACING
  CASE ::CaptionLayout == XBP_LAYOUT_TEXTBOTTOM
     aImgRect[1] := aTxtRect[1] := aRect[1] + STD_SPACING
     aImgRect[3] := aTxtRect[3] := aRect[3] - STD_SPACING
     aImgRect[4] = aRect[4] - TAB_PADDING
     aImgRect[2] = aRect[4] - Min( (aSize[2] - MIN_SPACING) /2, ;
                   nImgHeight + TAB_PADDING )
     aTxtRect[4] = aImgRect[2] - MIN_SPACING
     aTxtRect[2] = aRect[2] + MIN_SPACING
  OTHERWISE
     // XBP_LAYOUT_TEXTCENTER
     aImgRect[1] := aTxtRect[1] := aRect[1] + MIN_SPACING
     aImgRect[3] := aTxtRect[3] := aRect[3] - TAB_PADDING
     aImgRect[2] := aTxtRect[2] := aRect[2] + MIN_SPACING
     aImgRect[4] := aTxtRect[4] := aRect[4] - TAB_PADDING
ENDCASE

::ImageRect := aImgRect
::TextRect  := aTxtRect

#endif

RETURN

* ---------------------

METHOD DC_XbpTabPage:refresh()

LOCAL cCaption, aChildList, oAppFocus
IF Valtype(::captionBlock) = 'B'
  cCaption := DC_Xtoc(Eval(::captionBlock,self))
  IF !(cCaption == ::caption)

// J. Duijf 27-09-2011  Why destroy and re-create all children if  ::SetCaption() is already inplemented  ??
//                      Crowded tab-pages are much more responsive now when caption is a code-block
// R.D. - Because ::setCaption() was not supported in old versions of Xbase++.  Thanks for catching this.

    ::SetCaption(cCaption)

//    ::caption := cCaption
//    oAppFocus := SetAppFocus()
//    aChildList := _destroyChildren(::ChildList())
//    ::configure()
//    _createChildren(aChildList)
//    SetAppFocus(oAppFocus)
  ENDIF
ENDIF
RETURN self

* --------------------------

METHOD DC_XbpTabPage:WhenHideEval( lEnable, lShow, lProtect )

LOCAL lMinimized := ::minimized, aColors, lEnabled

IF Valtype(::whenBlock) == 'B'
  lEnabled := Eval(::whenBlock,self)
  IF lEnabled .AND. !::isEnabled()
    lEnable := .t.
    ::Enable()
  ELSEIF !lEnabled .AND. ::isEnabled()
    ::Disable()
  ENDIF
  IF Valtype(::saveColor)='N' .AND. ::saveColor # ::colorBG
    ::Maximize()
    IF lMinimized
      ::Minimize()
    ENDIF
  ENDIF
  ::saveColor := ::colorBG
ENDIF

IF Valtype(::hideBlock) = 'B'
  lShow := !Eval(::hideBlock,self)
  IF lShow
    IF !Empty(::initPos)
      ::setPos(::initPos)
      ::initPos := nil
    ENDIF
  ELSE
    IF Empty(::initPos)
      ::initPos := ::currentPos()
      ::setPos( {-2000,-2000})
    ENDIF
  ENDIF
ENDIF

IF ::isEnabled()
  IF Valtype(::enabledColorBlock) = 'B'
     aColors := Eval(::enabledColorBlock,self)
     DEFAULT aColors := {}
     ASize(aColors,2)
     ::enabledColorFG := ConvertColor(aColors[1])
     ::enabledColorBG := ConvertColor(aColors[2])
  ENDIF
  IF Valtype(::enabledColorBG)='N' .AND. !(::setColorBG() == ::enabledColorBG)
    ::setColorBG(::enabledColorBG)  // enabled BG color
  ENDIF
  IF Valtype(::enabledColorFG)='N' .AND. !(::setColorFG() == ::enabledColorFG)
    ::setColorFG(::enabledColorFG)  // enabled FG color
  ENDIF
ELSE
  IF Valtype(::disabledColorBlock) = 'B'
    aColors := Eval(::disabledColorBlock,self)
    DEFAULT aColors := {}
    ASize(aColors,2)
    ::disabledColorFG := ConvertColor(aColors[1])
    ::disabledColorBG := ConvertColor(aColors[2])
  ENDIF
  IF Valtype(::disabledColorBG)='N' .AND. !(::setColorBG() == ::disabledColorBG)
    ::setColorBG(::disabledColorBG)  // disabled BG color
  ENDIF
  IF Valtype(::disabledColorFG)='N' .AND. !(::setColorFG() == ::disabledColorFG)
    ::setColorFG(::disabledColorFG)  // disabled FG color
  ENDIF
ENDIF

IF Valtype(::protectBlock) = 'B'
  lProtect := Eval(::protectBlock,self)
ENDIF

RETURN self

* -----------------

METHOD DC_XbpTabPage:TabGetHWND()

LOCAL hWnd

hWnd := FindWindowExA( ::setParent():getHWND(), 0, ;
                       "XbpTab", strtran( ::Caption, "~", "&" ) )

RETURN hWnd

* -----------------

METHOD DC_XbpTabPage:setCaption( cCaption )

LOCAL lOK  := .F.
LOCAL hWnd := ::TabGetHWND()
LOCAL rc
LOCAL nLen := Len(cCaption)

IF hWnd <> 0
   rc := SetWindowTextA( hWnd, strtran( cCaption, "~", "&" ), nLen )
   IF rc <> 0
      InvalidateRect( hWnd, 0, 0 )
      ::Caption := cCaption   // update Ivar to reflect changed caption
      lOK       := .T.       // return success
   ENDIF
ENDIF

RETURN lOK

* ---------------

METHOD DC_XbpTabPage:createChildren()

LOCAL GetList := ::getList:getListArray, aSaveSize := ::currentSize()

IF ::isCreateChildren
  RETURN .f.
ENDIF
::isCreateChildren := .t.
::parent:lockUpdate(.t.)
::setSize(::origSize)

DCREAD GUI EXIT PARENT self SAVE OPTIONS ::getList:getOptions

::setSize(aSaveSize)

DC_ReSize( ::origSize, aSaveSize, self, GetList, ::getList )
::parent:lockUpdate(.f.)
::invalidateRect()

RETURN .t.

* ---------------

/*
METHOD DC_XbpTabPage:lockUpdate( lLock )

::lockUpdate := lLock
RETURN ::xbpTabPage:lockUpdate(lLock)
*/

* ---------------

STATIC FUNCTION _DestroyChildren( aChilds )

LOCAL x, y := LEN( aChilds )
LOCAL aChildren := {}

FOR x := 1 TO y
  IF ValType( aChilds) =  "A"
     AADD( aChildren, aChilds[x])
     IF aChilds[x]:status() > 0
       AADD( aChildren, _DestroyChildren( aChilds[x]:childList()))
     ENDIF
  ENDIF
  IF aChilds[x]:status() > 0
    aChilds[x]:destroy()
  ENDIF
NEXT

RETURN aChildren

* ---------------

STATIC FUNCTION _CreateChildren( aChildren )

LOCAL x, y := LEN( aChildren)

FOR x := 1 TO y
  IF ValType(aChildren[x]) == "A"
    _CreateChildren( aChildren[x])
  ELSE
    aChildren[x]:create()
  ENDIF
NEXT

RETURN nil

* ---------------------

STATIC FUNCTION _TabInputFocus( bBlock, aTabPageControls, lDisplayFocus, self )

RETURN {|x,y,o|_TabActivate(aTabPageControls,o,lDisplayFocus,x,y), ;
               IIF( !::isCreateChildren, ::createChildren(),nil), ;
               IIF( Valtype(bBlock)='B',(Eval(bBlock,x,y,o)),nil)}

* ---------------------

STATIC FUNCTION _TabActivate( aTabPages, oTabPage, lFocus, mp1, mp2 )

LOCAL i, bWhen, bValid, nTab, j, aChildList, oParent := SetAppWindow(), ;
      aTabColor, aColor, nColor

IF Empty(aTabPages)
   RETURN nil
ENDIF

DEFAULT mp1 := .f.

IF Valtype(oTabPage) = 'O' .AND. oTabPage:isDerivedFrom('XbpTabPage')
  IF !oTabPage:minimized .AND. !mp1
     RETURN nil
  ENDIF
  nTab := oTabPage:tabNumber
  bWhen := oTabPage:whenBlock
  oParent := oTabPage:setParent()
ELSE
  nTab := 0
ENDIF

IF (Valtype(bWhen)='B' .AND. !Eval(bWhen,oTabPage)) .OR. !lFocus
  RETURN nil
ENDIF

aTabColor := DC_TabPageColor()

FOR i := 1 TO LEN(aTabPages)
  IF aTabPages[i]:setParent() == oParent
    IF !aTabPages[i]:minimized
      bValid := aTabPages[i]:validBlock
      IF Valtype(bValid) = 'B' .AND. !Eval(bValid,oTabPage)
         RETURN nil
      ENDIF
      aTabPages[i]:minimize()
      IF (Valtype(aTabColor) = 'A' .OR. Valtype(aTabPages[i]:minMaxColor) == 'A') .AND. Empty(aTabPages[i]:enabledColorBlock)
        IF Valtype(aTabPages[i]:minMaxColor) == 'A'
          aColor := aTabPages[i]:minMaxColor[1]
        ELSE
          aColor := aTabColor[1]
        ENDIF
        IF Valtype(aColor) == 'A'
          nColor := aColor[1]
          IF Valtype(nColor) = 'A'
            nColor := GraMakeRGBColor(nColor)
          ENDIF
          IF Valtype(nColor) == 'N'
            aTabPages[i]:setColorFG(nColor)
          ENDIF
          nColor := aColor[2]
          IF Valtype(nColor) = 'A'
            nColor := GraMakeRGBColor(nColor)
          ENDIF
          IF Valtype(nColor) == 'N'
            aTabPages[i]:setColorBG(nColor)
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  ENDIF
NEXT
FOR i := 1 TO LEN(aTabPages)
  IF i = nTab
    bWhen := aTabPages[i]:whenBlock
    IF Valtype(bWhen) # 'B' .OR. Eval(bWhen,oTabPage)
      IF Valtype(aTabPages[i]:enabledColorBG) = 'N'
        aTabPages[i]:colorBG := aTabPages[i]:enabledColorBG
      ENDIF
      aTabPages[i]:maximize()
      IF (Valtype(aTabColor) = 'A' .OR. Valtype(aTabPages[i]:minMaxColor) == 'A') .AND. Empty(aTabPages[i]:enabledColorBlock)
        IF Valtype(aTabPages[i]:minMaxColor) == 'A'
          aColor := aTabPages[i]:minMaxColor[2]
        ELSE
          aColor := aTabColor[2]
        ENDIF
        IF Valtype(aColor) == 'A'
          nColor := aColor[1]
          IF Valtype(nColor) = 'A'
            nColor := GraMakeRGBColor(nColor)
          ENDIF
          aTabPages[i]:setColorFG(nColor)
          nColor := aColor[2]
          IF Valtype(nColor) = 'A'
            nColor := GraMakeRGBColor(nColor)
          ENDIF
          aTabPages[i]:setColorBG(nColor)
        ENDIF
      ENDIF
      aChildList := aTabPages[i]:childList()
      FOR j := 1 TO Len(aChildList)
        IF aChildList[j]:isDerivedFrom('XbpCrt')
          SetAppFocus(aChildList[j])
          EXIT
        ELSEIF (Valtype(aTabColor) = 'A' .OR. Valtype(aTabPages[i]:minMaxColor) == 'A') .AND. ;
               Empty(aTabPages[i]:enabledColorBlock) .AND. Valtype(aChildList[j]:setColorBG()) == 'N'
          aChildList[j]:setColorBG(aChildList[j]:setColorBG())
        ENDIF
      NEXT
      IF Valtype(aTabPages[i]:actionBlock) = 'B' // Run ACTION block
        Eval(aTabPages[i]:actionBlock,oTabPage)
      ENDIF
    ELSE
      IF Valtype(aTabPages[i]:disabledColorBG) = 'N'
        aTabPages[i]:colorBG := aTabPages[i]:disabledColorBG
      ENDIF
    ENDIF
  ENDIF
NEXT
RETURN nil

* ==============================================================

CLASS DC_XbpRadioButton FROM DC_XbpRadioButtonSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR listBlock
  VAR pointerBlock
  VAR captionBlock
  VAR actionBlock
  VAR color
  VAR dataValue
  VAR optionArray
  VAR size
  VAR options
  _METHOD Init, Create, Refresh, WhenHideEval, Select
ENDCLASS

* -----------------

METHOD DC_XbpRadioButton:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, cCaption, bBlock, aGetList, aGetListItem, aGetOptions, ;
      lAutoSize := .f.

::size := aSize
DEFAULT ::size := {0,0}
IF Empty(::size[1])
  ::size[2] := 0
  lAutoSize := .t.
ENDIF

IF Empty(aPres)
  aPres := { { XBP_PP_DISABLED_BGCLR, GRA_CLR_BACKGROUND } }
ENDIF

::XbpRadioButton:init( oParent, oOwner, aPos, ::size, aPres, lVisible )

::tabstop := .f.

::DC_XbaseParts:init( oGetList,,self  )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

xOptions := aGetListItem[xGETLIST_OPTIONS]
::options := aGetListItem[xGETLIST_OPTIONS2]

cCaption := aGetListItem[cGETLIST_CAPTION]
IF Valtype(cCaption) = 'B'
  cCaption := DC_XtoC(Eval(cCaption,self))
ELSEIF Valtype(cCaption) # 'C'
  cCaption := DC_XtoC(cCaption)
ENDIF
::caption := cCaption
IF Valtype(::options) = 'N' .AND. Valtype(::caption) = 'C'
  ::caption := Strtran(::caption,';',Chr(13))
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
ASize(xOptions,2)
::datalink := bBlock
IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|DC_HiliteGets(o,2,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
ENDIF

::keyboard := { |a,b,o|IIF(a=xbeK_ENTER,::select(),nil), ;
                       IIF(a=xbeK_SPACE,Eval(::dataLink,::dataValue),nil) }
::selected := bBlock
::selection := Eval(bBlock) == xOptions[1]

::validate := DC_GetBlock(aGetListItem[bGETLIST_VALID])
::actionBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
::captionBlock := aGetListItem[cGETLIST_CAPTION]
::varBlock := bBlock
::color := aGetListItem[aGETLIST_COLOR]
::dataValue := xOptions[1]
::autoSize := lAutoSize
::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
IF Valtype(bBlock) = 'B'
  ::selected := bBlock
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* --------------------

METHOD DC_XbpRadioButton:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aArray, aGetListItem, nOptions

::xbpRadioButton:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]

DEFAULT oParent := ::setParent()

IF Valtype(::actionBlock) = 'B'
  ::selected := {|a,b,o|IIF( a,Eval(o:actionBlock,self),nil )}
ENDIF

DC_XbpSetColor( ::color, self, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

::DC_XbaseParts:setOrig(self)

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  ::SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
ENDIF

IF ::size[1] = 0 .AND. !Empty(::caption)
  aArray := GraQueryTextBox( ::lockPS(), ::caption + Chr(255) + Chr(255) )
  ::size[1] := aArray[3,1] - aArray[1,1] + 20 // width
  // ::size[2] := Max( ::size[2], ( aArray[1,2] - aArray[2,2]) ) // height
  ::size[2] := Max( ::size[2], ( aArray[1,2] - (aArray[2,2] * 2))) // height - Jack Djuif

  ::unlockPS()
  ::setSize( ::size )
ENDIF

IF Valtype(::options) == 'N'
  nOptions := GetWindowLonga(::GetHwnd(), GWL_STYLE) + ::options
  SetWindowLongA(::GetHwnd(), GWL_STYLE, nOptions )
ENDIF

RETURN self

* -----------------------

METHOD DC_XbpRadioButton:refresh()

::SetData( Eval(::datalink) == ::dataValue )
::selection := Eval(::datalink) == ::dataValue

DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )

IF Valtype(::captionBlock)='B'
  ::SetCaption(Eval(::captionBlock,self))
ENDIF

RETURN self

* ---------------------------

METHOD DC_XbpRadioButton:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* -----------------------

METHOD DC_XbpRadioButton:select()

LOCAL oParent := ::setParent(), aChildList, i
LOCAL aGetList := ::getList:getListArray

::SetData(.t.)
::GetData()
aChildList := oParent:ChildList()
FOR i := 1 TO LEN(aChildList)
  IF aChildList[i]:isDerivedFrom('XbpRadiobutton') .AND. aChildList[i] # self
    aChildList[i]:setData(.f.)
    aChildList[i]:selection := Eval(aChildList[i]:datalink)
  ENDIF
NEXT
IF Valtype(::actionBlock) == 'B'
  Eval(::actionBlock,self)
ENDIF

DC_GetRefresh(aGetList)

RETURN nil

* ==================================================================

CLASS DC_XbpSpinButton FROM DC_XbpSpinButtonSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR listBlock
  VAR pointerBlock
  VAR color
  VAR optionArray
  _METHOD Init, Create, Refresh, WhenHideEval
ENDCLASS

* -----------------

METHOD DC_XbpSpinButton:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aGetList, aGetListItem, aGetOptions

DEFAULT aSize := {0,0}
DEFAULT aSize[1] := 0, ;
        aSize[2] := 0

::XbpSpinButton:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

xOptions := aGetListItem[xGETLIST_OPTIONS]
::optionArray := xOptions

bBlock := aGetListItem[bGETLIST_REFVAR]
IF Valtype(bBlock)='A'
  bBlock := bBlock[1]
ENDIF
IF Valtype( bBlock ) = 'B'
  ::master := Eval( bBlock )
ENDIF
bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR],'N')
::datalink := bBlock
::varBlock := bBlock

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  ::SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
ENDIF
IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|DC_HiliteGets(o,2,o:getList:getOptions[nGETOPT_HILITECOLOR]), ;
                               o:getData() }
ELSE
  ::killInputFocus := { |x,y,o| o:getData() }
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
IF Valtype(bBlock) = 'B'
  ::endSpin := bBlock
  ::Keyboard := bBlock
ELSE
  ::endSpin := {|x,y,o|o:getData()}
ENDIF

::validate := DC_GetBlock(aGetListItem[bGETLIST_VALID])
::color := aGetListItem[aGETLIST_COLOR]
DEFAULT ::color := { GRA_CLR_BLACK, GRA_CLR_WHITE }
::fastspin := xOptions[1]
::padwithZeros := xOptions[2]

bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS3])
IF Valtype(bBlock) = 'B'
  ::endSpin := bBlock
ENDIF

bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS4])
IF Valtype(bBlock) = 'B'
  // ::down := bBlock
  ::down := DC_MergeBlocks({||::GetData()},bBlock)  // J. Duijf 14-08-2010
ENDIF

bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS5])
IF Valtype(bBlock) = 'B'
  // ::up := bBlock
  ::up := DC_MergeBlocks({||::GetData()},bBlock)  // J. Duijf 14-08-2010
ENDIF

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* ---------------------

METHOD DC_XbpSpinButton:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem

aGetListItem := ::getList:getListArray[::getListPointer]

::xbpSpinButton:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::setData()

DC_XbpSetColor( ::color, self, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

IF Valtype(::optionArray[3])='N'
  ::SetNumLimits( ::optionArray[3],::optionArray[4] )
ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* --------------------

METHOD DC_XbpSpinButton:refresh()

::SetData(Eval(::varBlock))

DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )

RETURN self

* ---------------------------

METHOD DC_XbpSpinButton:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ============================================================

CLASS DC_XbpDialog FROM DC_XbpDialogSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR listBlock
  VAR pointerBlock
  VAR color
  VAR optionArray
  VAR fit
  VAR fitpad
  VAR menuBar
  VAR visible
  VAR oMagicHelp
  VAR captionResType
  VAR captionResFile
  VAR restoreArray
  VAR noResize
  VAR noRestore
  _METHOD Init, Create, WhenHideEval, Destroy
ENDCLASS

* --------------------

METHOD DC_XbpDialog:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetlist )

LOCAL xOptions, bBlock, aGetList, aGetListItem

::XbpDialog:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

xOptions := aGetListItem[xGETLIST_OPTIONS4]
DEFAULT xOptions := {}
ASize(xOptions,2)
::captionResType := xOptions[1]
::captionResFile := xOptions[2]
::noResize := .f.

xOptions := aGetListItem[xGETLIST_OPTIONS5]
IF Valtype(xOptions) == 'N'
  ::xbpDialog:drawingArea:scrollbars := xOptions
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS]

IF Valtype(aGetListItem[cGETLIST_CAPTION]) = 'C'
  ::title := aGetListItem[cGETLIST_CAPTION]
ENDIF
ASIZE(xOptions,15)

DEFAULT xOptions[12] := .f., ;
        xOptions[13] := 10, ;
        xOptions[14] := .f., ;
        xOptions[15] := .f.

::visible := lVisible
DEFAULT ::visible := .t.
::optionArray := xOptions

IF Valtype(xOptions[1]) = 'N'
  ::icon := xOptions[1]
ELSEIF Valtype(DC_IconDefault())='N'
  ::icon := DC_IconDefault()
ENDIF
IF Valtype(xOptions[3]) = 'L'
  ::minButton := xOptions[3]
ENDIF
IF Valtype(xOptions[4]) = 'L'
  ::maxButton := xOptions[4]
ENDIF
IF Valtype(xOptions[6]) = 'N'
  ::border := xOptions[6]
ENDIF
IF Valtype(xOptions[7]) = 'L'
  ::titleBar := xOptions[7]
ENDIF
IF Valtype(xOptions[8]) = 'L' .AND. xOptions[8]
  ::minSize := aSize
  ::maxSize := aSize
  ::noResize := .t.
ENDIF
IF Valtype(xOptions[9]) = 'A'
  ::minsize := xOptions[9]
ENDIF
IF Valtype(xOptions[10]) = 'A'
  ::maxsize := xOptions[10]
ENDIF
IF Valtype(xOptions[11]) = 'L'
  ::taskList := !xOptions[11]
ELSE
  ::taskList := .t.
ENDIF

::fitPad := xOptions[13]
::fit := xOptions[14]
::noRestore := xOptions[15]

IF !::noRestore .AND. !Empty(DC_AutoRestoreWindow()) .AND. ;
     !Empty(::title)

  ::restoreArray := DC_RegQuery(DC_AutoRestoreWindow()[1],DC_AutoRestoreWindow()[2], ;
                    'DC_XBPDIALOG:' + ::title)
ENDIF

::color := aGetListItem[aGETLIST_COLOR]

DC_XbpSetColor( ::color, ::drawingArea, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF Valtype(aGetListItem[cGETLIST_FONT]) = 'C'
  ::drawingArea:setFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
ELSE
  ::drawingArea:setFontCompoundName( "8.Helv" )
ENDIF
IF Valtype(xOptions[2]) $ 'CNO'
  ::drawingArea:bitmap := DC_GetBitMap(xOptions[2],,::captionResType,::captionResFile,,.t.)
ENDIF

::cargo := { ::getListPointer, ;
             aGetList, ;
             aGetListItem[xGETLIST_CARGO], ;
             nil, ;
             nil, ;
             ThreadID(), ;
             self, ;
             nil, ;
             nil }

IF Valtype(aGetListItem[xGETLIST_OPTIONS3]) = 'L' .AND. ;
      aGetListItem[xGETLIST_OPTIONS3]
  ::resize := {|a,b,o,x|x := SetAppFocus(), ;
                        o:drawingArea:hide(), ;
                        DC_AutoReSize(a,b,o,o:getList:getListArray), ;
                        o:drawingArea:show(), ;
                        SetAppFocus(x) }
ELSE
  ::resize := {|a,b,o|o:invalidateRect()}
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* ---------------------

METHOD DC_XbpDialog:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL bBlock, lDrawingArea, aMenu, nKeyType, cKeyList, oMsgBox, aGetList, ;
      aGetListItem, aSaveSize

DEFAULT lVisible := ::visible

// ::drawingArea:clipChildren := .T.

::xbpDialog:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF !lVisible
  ::hide()
ENDIF

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

IF ::optionArray[14]
  SetAppWindow(self)
ENDIF

::close := {|a,b,o|PostAppEvent(xbeP_Close,,,self)}
IF ::optionArray[5]
  ::SetModalState(XBP_DISP_APPMODAL)
ENDIF
bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR],'O')
lDrawingArea := .f.
IF Valtype(bBlock) = 'B'
  Eval( bBlock, ::drawingArea )
  lDrawingArea := .t.
ENDIF
bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, IIF( lDrawingArea,self,::drawingArea) )
ENDIF
IF !Empty(aGetListItem[xGETLIST_OPTIONS2])
  aMenu := aGetListItem[xGETLIST_OPTIONS2]
  IF Valtype(aMenu)='C' .OR. (Valtype(aMenu) = 'A' .AND. Valtype(aMenu[1]) = 'C')
    IF Valtype(aMenu) = 'A'
      ASize(aMenu,4)
      nKeyType := aMenu[4]
      cKeyList := aMenu[3]
      oMsgBox := aMenu[2]
      aMenu := aMenu[1]
    ENDIF
    IF !Empty(aMenu)
      aMenu := DC_DO('DC_MenuCompile(DC_MenuLoad("'+aMenu+'"))')
    ENDIF
  ELSEIF Valtype(aMenu) = 'A' .AND. Len(aMenu) = 2
    nKeyType := aMenu[4]
    cKeyList := aMenu[3]
    oMsgBox := aMenu[2]
    aMenu := aMenu[1]
  ENDIF
  IF Valtype(aMenu)='A'
    // Install menu bar in dialog window
    ::menuBar := DC_MenuOSys( aMenu, self, .f., aGetList, oMsgBox, cKeyList, nKeyType )
  ENDIF
ENDIF

::DC_XbaseParts:setOrig(self)

IF Valtype(::restoreArray) == 'A'

  ::setPos(::restoreArray[1])
  IF !::noResize
    ::setSize(::restoreArray[2])
  ENDIF

  IF !::noResize .AND. Valtype(::restoreArray[3]) == 'N' .AND. ;
      !(::getFrameState() == ::restoreArray[3])
    ::setFrameState(::restoreArray[3])
  ENDIF

ENDIF

RETURN self

* -------------------

METHOD DC_XbpDialog:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )


* -------------------

 METHOD DC_XbpDialog:Destroy()  /// <<< Jack Djuif

 LOCAL nFrameState

 if ValType(::oMagicHelp) = "O"
    ::oMagicHelp:terminate()
    ::oMagicHelp:Synchronize(0)
    ::oMagicHelp   := nil
 endif

 IF !::noRestore .AND. !Empty(DC_AutoRestoreWindow()) .AND. !Empty(::title)
   nFrameState := ::getFrameState()
   ::setFrameState(XBPDLG_FRAMESTAT_NORMALIZED)

   DEFAULT ::restoreArray := {}
   ASize(::restoreArray,4)
   ::restoreArray[1] := ::currentPos()
   ::restoreArray[2] := ::currentSize()
   ::restoreArray[3] := nFrameState

   DC_RegWrite(DC_AutoRestoreWindow()[1],DC_AutoRestoreWindow()[2], ;
               'DC_XBPDIALOG:' + ::title, ::restoreArray)
 ENDIF

 ::xbpDialog:Destroy()

 Return SELF

* ====================

CLASS DC_XbpListBox FROM DC_XbpListBoxSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR listBlock
  VAR pointerBlock
  VAR color
  VAR dataValue
  VAR optionArray
  VAR drawingArea
  _METHOD Init, Create, WhenHideEval, setData, refresh
ENDCLASS

* --------------------

METHOD DC_XbpListBox:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aGetList, aGetListItem, aGetOptions

::XbpListBox:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

xOptions := aGetListItem[xGETLIST_OPTIONS]

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF Valtype(aGetListItem[cGETLIST_FONT])='C'
  ::SetFontCompoundName(Alltrim(aGetListItem[cGETLIST_FONT]))
ENDIF

DEFAULT xOptions := {}
ASize(xOptions,6)

::optionArray := xOptions

IF Valtype(xOptions[1]) = 'L'
  ::horizScroll := xOptions[1]
ENDIF
IF Valtype(xOptions[4]) = 'L' .AND. xOptions[4]
  ::multiColumn := .t.
ENDIF
::clipSiblings := .T.
IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  ::SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
IF Valtype(bBlock) = 'B' .AND. !(Valtype(Eval(bBlock)) $ 'CA')
  Eval(bBlock,'')
ENDIF

IF Valtype(xOptions[2]) = 'N'
  ::markmode := xOptions[2]
ELSEIF Valtype(bBlock) = 'B' .AND. Valtype(Eval(bBlock)) = 'A'
  ::markmode := XBPLISTBOX_MM_MULTIPLE
ENDIF
IF !Empty(aGetOptions[nGETOPT_HILITECOLOR])
  ::setInputFocus := {|x,y,o|DC_HiliteGets(o,1,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
  ::killInputFocus := {|x,y,o|DC_HiliteGets(o,2,o:getList:getOptions[nGETOPT_HILITECOLOR]) }
ENDIF

::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
::listBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
::pointerBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS2])
::color := aGetListItem[aGETLIST_COLOR]
DEFAULT ::color := { GRA_CLR_BLACK, GRA_CLR_WHITE }
// ::multiSelection := Valtype(Eval(::varBlock))='A'

::ItemSelected := {|mp1, mp2, obj|DC_VarFromListBox( obj )}
::ItemMarked   := {|mp1, mp2, obj|DC_VarFromListBox( obj )}

IF Valtype(xOptions[5]) = 'B'
  ::ItemMarked := DC_MergeBlocks(::ItemMarked,xOptions[5],self)
ENDIF

IF Valtype(xOptions[6]) = 'B'
  ::ItemSelected := DC_MergeBlocks(::ItemSelected,xOptions[6],self)
ENDIF

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* ---------------------

METHOD DC_XbpListBox:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL j, bBlock, aArray, aGetListItem

::xbpListBox:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]

::DC_XbaseParts:setOrig(self)

DC_XbpSetColor( ::color, self, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
IF Valtype(bBlock) == 'B'
  aArray := Eval( bBlock )
  FOR j := 1 TO LEN(aArray)
    ::Additem(aArray[j])
  NEXT
ENDIF

IF Valtype(::optionArray[3]) = 'A' //  Preset the list
  ::setData(::optionArray[3], .T.)
  DC_VarFromListBox(self)
ENDIF

RETURN self

* --------------------

METHOD DC_XbpListBox:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* --------------------

METHOD DC_XbpListBox:refresh()

DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )

RETURN self

* --------------------

METHOD DC_XbpListBox:setData( a, b )

IF PCount() > 0
  ::xbpListBox:setData( a, b )
ENDIF

RETURN self


* ====================

CLASS DC_XbpScrollBar FROM DC_XbpScrollBarSuper, DC_XbaseParts
EXPORTED:
  VAR optionArray
  _METHOD Init, Create, WhenHideEval
ENDCLASS

* --------------------

METHOD DC_XbpScrollBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aGetList, aGetListItem

::XbpScrollBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

xOptions := aGetListItem[xGETLIST_OPTIONS]

::scroll := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
::dataLink := DC_GetBlock(aGetListItem[bGETLIST_VAR])

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

IF Valtype(aGetListItem[nGETLIST_SUBTYPE]) = 'N'
  ::type := aGetListItem[nGETLIST_SUBTYPE]
ENDIF
IF Valtype(xOptions[2])='N'
  ::range := { xOptions[2], xOptions[3] }
ENDIF
::autoTrack := xOptions[1]

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* ---------------------

METHOD DC_XbpScrollBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::xbpScrollBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )


::DC_XbaseParts:setOrig(self)

IF Valtype(::datalink) = 'B'
  ::SetData()
ENDIF

RETURN self

* ---------------------------

METHOD DC_XbpScrollBar:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ======================================================

CLASS DC_XbpProgressBar FROM DC_XbpProgressBarSuper, DC_XbaseParts
EXPORTED:
  VAR barColor
  VAR backColor
  VAR optionArray
  VAR maxCount
  VAR currCount
  VAR vertical
  VAR presSpace
  VAR every
  VAR percent
  VAR percentFont
  VAR percentColor
  VAR radius
  VAR outline
  VAR dynamic
  _METHOD init, create
ENDCLASS

* ------------------

METHOD DC_XbpProgressBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aColor, aGetList, aGetListItem

::XbpStatic:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::tabstop := .f.

::vertical := .f.
::percent := .f.
::barColor := GRA_CLR_BLUE
::backColor := GRA_CLR_BACKGROUND
::percentColor := GRA_CLR_WHITE
::percentFont := '8.Arial Bold'

IF Valtype(oGetList) == 'O'

  ::DC_XbaseParts:init( oGetList,,self )

  aGetList := ::getList:getListArray
  aGetListItem := ::getList:getListArray[::getListPointer]

  xOptions := aGetListItem[xGETLIST_OPTIONS]

  IF Valtype(aGetListItem[nGETLIST_SUBTYPE]) = 'N'
    ::type := aGetListItem[nGETLIST_SUBTYPE]
  ELSE
    ::type := XBPSTATIC_TYPE_RAISEDBOX
  ENDIF

  ASize(xOptions,4)

  DEFAULT xOptions[1] := 1
  DEFAULT xOptions[2] := .f.  // Show Percentage box
  DEFAULT xOptions[3] := 1
  DEFAULT xOptions[4] := .f.  // Vertical
  IF xOptions[3] <= 0
    xOptions[3] := 1
  ENDIF

  ::optionArray := xOptions

  aColor := aGetListItem[aGETLIST_COLOR]
  IF Valtype(aColor) = 'B'
    aColor := Eval(aColor)
  ENDIF
  IF Valtype(aColor) = 'N'
    aColor :=  { aColor, GRA_CLR_PALEGRAY }
  ELSEIF Valtype(aColor) = 'A'
    ASize(aColor,2)
  ENDIF
  DEFAULT aColor[1] := GRA_CLR_DARKBLUE, ;
          aColor[2] := GRA_CLR_PALEGRAY

  ::every := Int(xOptions[3])
  ::barColor := aColor[1]
  ::backColor := aColor[2]
  ::vertical := xOptions[4]
  ::maxCount := xOptions[1]
  ::percent := ::optionArray[2]
  ::percentFont := aGetListItem[cGETLIST_FONT]
  ::percentColor := aGetListItem[xGETLIST_OPTIONS2]
  ::radius := aGetListItem[xGETLIST_OPTIONS3]
  ::dynamic := aGetListItem[xGETLIST_OPTIONS4]
  ::outline := aGetListITem[xGETLIST_OPTIONS5]

  ::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
  IF Valtype( bBlock ) = 'B'
    Eval( bBlock, self )
  ENDIF

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF

ENDIF

::currCount := 0
::clipChildren := .t.

DEFAULT ::outline := .F., ;
        ::dynamic := .F.

IF Valtype(::percentColor) = 'B'
  ::percentColor := Eval(::percentColor)
ENDIF

RETURN self

* --------------------

METHOD DC_XbpProgressBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL nWidth, nHeight, oPS, oFont

::xbpStatic:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF !Empty(::percentFont)
  ::presSpace := ::lockPS()
  IF Valtype(::percentfont) == 'C'
    oFont := GraSetFont(::presSpace)
    oFont := DC_FontConfigure( oFont, ::percentFont, nil, ::presSpace )
    GraSetFont( ::presSpace, oFont )
  ELSEIF Valtype(::percentFont) == 'O'
    GraSetFont( ::presSpace, ::percentFont )
  ENDIF

ENDIF

::DC_XbaseParts:setOrig(self)

::paint := {||DC_GetProgress(self,::currCount,::maxCount)}

RETURN self

* ------------------

STATIC FUNCTION _Pres( aPres )

IF Valtype( aPres ) = 'B'
  RETURN Eval(aPres)
ENDIF

RETURN aPres

* ======================================================

CLASS DC_XbpBitMap FROM DC_XbpBitMapSuper, DC_XbaseParts
EXPORTED:
  VAR optionArray
  VAR parentObject
  VAR dataLink
  _METHOD init, refresh
ENDCLASS

* ------------------

METHOD DC_XbpBitMap:init( oParent, oOwner, aPos, aSize, oGetList )

LOCAL aArray, xOptions, bBlock, aGetList, aGetListItem, ;
      oPS, aTarget, aSource, nStartCol, nStartRow, nWidth, nHeight

Grok(oOwner)

DEFAULT aPos := {0,0}, ;
        aSize := {0,0}

nStartCol := aPos[1]
nStartRow := aPos[2]
nWidth := aSize[1]
nHeight := aSize[2]

::parentObject := oParent
IF IsMemberVar(::parentObject,"bitmap")
  ::parentObject:bitmap := self
ENDIF

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

::XbpBitMap:init()

/*
oPS := XbpPresSpace():new():create( oParent:winDevice() )
::create(oPS)
*/

xOptions := aGetListItem[xGETLIST_OPTIONS]

aArray := xOptions
ASize(aArray,8)
IF Valtype(aArray[1]) = 'N'
  ::bits := aArray[1]
ENDIF
IF Valtype(aArray[2]) = 'N'
  ::planes := aArray[2]
ENDIF
IF Valtype(aArray[4]) = 'N'
  aSource := { aArray[4],aArray[5],aArray[6],aArray[7] }
ENDIF

aTarget := { nStartCol, nStartRow, nStartCol + nWidth, ;
             nStartRow + nHeight }
AAdd( oParent:cargo, { oPS, self, aTarget, aSource, aArray[3], aArray[8] } )
::parentObject:paint := {|a,b,o|IIF(!Empty(::dataLink),DC_BitMapDraw(o,::dataLink),nil)}
::dataLink := aGetListItem[bGETLIST_VAR]

IF Valtype(::dataLink) = 'A'
  ::dataLink := DC_GetBlock(bBlock)
ENDIF
DC_BitMapDraw( ::parentObject, ::dataLink )
// oParent:InvalidateRect()
bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF
::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], ;
             DC_GetBlock(aGetListItem[bGETLIST_HIDE]) }

RETURN self

* -----------------------

METHOD DC_XbpBitMap:refresh()

IF !Empty(::dataLink)
  DC_BitMapDraw(::parentObject, ::dataLink )
ENDIF

RETURN self

* ==================================================

CLASS DC_XbpMenuBar FROM DC_XbpMenuBarSuper, DC_XbaseParts

EXPORTED:
  VAR optionArray
  VAR images
  VAR ownerDraw
  VAR barFontCompoundName
  VAR barColorFG
  VAR barColorBG
  VAR subBgColor
  VAR subFgColor
  VAR subVertBarColorFG
  VAR subVertBarColorBG
  VAR subVertBarFontCompoundName
  VAR subCheckFontCompoundName
  VAR subCheckChar
  VAR subItemFontCompoundName
  VAR bitmaps
  VAR barBitmap
  VAR messageArray
  VAR pointerArray
  VAR drawBannerOnly
  _METHOD Init, Create
ENDCLASS

* ----------------------

METHOD DC_XbpMenuBar:init( oParent, aPres, lVisible, oGetList )

LOCAL bBlock, aGetList, aGetListItem, aOptions, lOwnerDraw

::XbpMenuBar:init( oParent, aPres, lVisible )
::drawBannerOnly := .f.

IF Valtype( oGetList ) = 'O'

  ::DC_XbaseParts:init( oGetList,,self )

  aGetList := ::getList:getListArray
  aGetListItem := ::getList:getListArray[::getListPointer]

  ::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], {}, {}, {}, {}, {}, {} }
  ::messageArray := ::cargo[5]
  ::pointerArray := ::cargo[6]

  ::ownerDraw := aGetListItem[xGETLIST_OPTIONS3]

  aOptions := aGetListItem[xGETLIST_OPTIONS4]
  DEFAULT aOptions := {}
  ASize(aOptions,12)

  ::subFgColor := aOptions[1]
  ::subBgColor := aOptions[2]
  ::subVertBarFontCompoundName := aOptions[3]
  ::subVertBarColorFG := aOptions[4]
  ::subVertBarColorBG := aOptions[5]
  ::subCheckFontCompoundName := aOptions[6]
  ::subCheckChar := aOptions[7]
  ::barFontCompoundName := aOptions[8]
  ::barColorFG := aOptions[9]
  ::barColorBG := aOptions[10]
  ::subItemFontCompoundName := aOptions[11]
  DEFAULT aOptions[12] := .f.
  ::bitmaps := !aOptions[12]

  IF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'ownerDraw')
    lOwnerDraw := oParent:ownerDraw
  ENDIF

  aOptions := aGetListItem[xGETLIST_OPTIONS5]
  DEFAULT aOptions := {}
  ASize(aOptions,5)
  ::beginMenu := aOptions[1]
  ::endMenu := aOptions[2]
  ::itemSelected := aOptions[3]
  ::itemMarked := aOptions[4]
  #if XPPVER > 1900000
    ::onMenuKey := aOptions[5]
  #endif

  ::barBitmap := aGetListItem[xGETLIST_OPTIONS6]
  IF Valtype(::barBitmap) # 'B' .AND. !Empty(::barBitmap)
    ::barBitmap := DC_GetBitmap(::barBitmap,,,,,.t.)
  ENDIF

ENDIF

DEFAULT ::subVertBarFontCompoundName := DC_XbpMenuConfig()[5], ;
        ::ownerDraw := lOwnerDraw, ;
        ::subCheckFontCompoundName := DC_XbpMenuConfig()[7], ;
        ::subCheckChar := DC_XbpMenuConfig()[8], ;
        ::barFontCompoundName := DC_XbpMenuConfig()[12], ;
        ::subItemFontCompoundname := DC_XbpMenuConfig()[13]

IF DC_MenuOwnerDrawDisable()
  ::ownerDraw := .f.
  lOwnerDraw := .f.
ENDIF

IF ::barColorBG == NIL
  ::barColorBG := DC_XbpMenuConfig()[10]
ENDIF

IF Valtype(::barColorBG) == 'A'
  ::barColorBG := GraMakeRGBColor(::barColorBG)
ENDIF

IF ::barColorFG == NIL
  IF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'fgcolor')
    ::barColorFG := ::parentObject:fgColor
  ELSE
    ::barColorFG := DC_XbpMenuConfig()[9]
  ENDIF
  DEFAULT ::barColorFG := GRA_CLR_BLACK
ENDIF

IF Valtype(::barColorFG) == 'A'
  ::barColorFG := GraMakeRGBColor(::barColorFG)
ENDIF

IF ::subVertBarColorFG == NIL
  IF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'subVertBarColorFG')
    ::subVertBarColorFG := ::parent:subVertBarColorFG
  ELSE
    ::subVertBarColorFG := DC_XbpMenuConfig()[2]
  ENDIF
ENDIF
IF Valtype(::subVertBarColorFG) == 'A'
  ::subvertBarColorFG := GraMakeRGBColor(::subVertBarColorFG)
ENDIF

IF ::subVertBarColorBG == NIL
  IF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'subVertBarColorBG')
    ::subVertBarColorBG := ::parent:subVertBarColorBG
  ELSE
    ::subVertBarColorBG := DC_XbpMenuConfig()[3]
  ENDIF
ENDIF

IF Valtype(::subVertBarColorBG) = 'A'
  ::subVertBarColorBG := GraMakeRGBColor(::subVertBarColorBG)
ENDIF

DEFAULT ::images := .F., ;
        ::ownerDraw := .F.

IF Valtype( oGetList ) = 'O'

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF

ENDIF

RETURN self

* --------------------

METHOD DC_XbpMenuBar:create( oParent, aPres, lVisible )

#if XPPVER > 1900000

LOCAL oPS, oFont

oPS := AppDesktop():lockPS()
oFont := XbpFont():new( oPS )
oFont:create( ::BarFontCompoundName )

IF ::ownerDraw
  ::measureItem := {|nItem,aDims,self| MeasureMenubarItem(oParent,self,nItem,aDims,oFont) }
  ::drawItem    := {|oPS,aInfo,self  | DrawMenubarItem(oParent,self,oPS,aInfo,oFont,::BarBitmap) }
ENDIF
#endif

::xbpMenuBar:create( oParent, aPres, lVisible )


RETURN self

//
// Function for computing the dimensions of menubar entries.
// The dimensions are computed based on the textbox
// required for drawing an item's caption string.
//

#if XPPVER > 1900000

STATIC FUNCTION MeasureMenubarItem( oDlg, oMbar, nItem, aDims, oFont )

 LOCAL oPS
 LOCAL cStr
 LOCAL cTmp
 LOCAL oFnt
 LOCAL aBox
 LOCAL xItem

   oPS  := AppDesktop():lockPS()

   oFnt := GraSetFont( oPS, oFont )

   xItem := oMBar:getItem(nItem)[1]
   IF Valtype(xItem) = 'O'
     xItem := xItem:title
   ENDIF

   cStr := xItem

   // cStr := oMbar:getItem(nItem)[1]:title
   cTmp := StrTran( cStr, "~" )

   aBox := GraQueryTextBox( oPS, cTmp )

   aDims[1] := aBox[3,1] - aBox[2,1]
   aDims[2] := oFnt:width + ITEM_SPACING *2
   AppDesktop():unlockPS()

RETURN oMbar


//
// Function for rendering the menubar entries. These
// are represented only via their caption string.
//
STATIC FUNCTION DrawMenubarItem( oDlg, oMbar, oPS, aInfo, oFont, oBitmap )

LOCAL aItem   := oMbar:getItem( aInfo[1] )
LOCAL aSAttrs := Array( GRA_AS_COUNT )
LOCAL aAAttrs := Array( GRA_AA_COUNT)
LOCAL cStr, xItem, i, nY, nLen

GraSetFont( oPS, oFont )

DEFAULT oMbar:barColorBG := GRA_CLR_BACKGROUND

IF Band(aInfo[2], XBP_DRAWACTION_DRAWALL) != 0 .AND. aInfo[1] == oMbar:numItems()
  IF Valtype(oBitmap) == 'B'
    oBitmap := Eval(oBitmap)
  ENDIF
  aAAttrs[GRA_AA_COLOR] := oMbar:barColorBG
  GraSetAttrArea( oPS, aAAttrs )
  GraBox( oPS, { aInfo[4][3], 0}, ;
      { oMbar:currentSize()[1]+3,aInfo[4][4]}, GRA_FILL )

  IF Valtype(oBitmap) == 'B'
    oBitmap := Eval(oBitmap)
  ENDIF

  IF Valtype(oBitmap) == 'O'
    IF oMbar:drawBannerOnly
      nY := 0
    ELSE
      nY := aInfo[4,3]
    ENDIF
    nLen := oMbar:currentSize()[1] + oBitmap:xSize
    DO WHILE nY < ( nLen - oBitmap:xSize )
      oBitmap:draw( oPS, { nY, 0 } )
      nY += oBitmap:xSize
    ENDDO
    IF oMbar:drawBannerOnly
      RETURN .t.
    ENDIF
  ENDIF

ENDIF

IF BAnd(aInfo[3], XBP_DRAWSTATE_SELECTED) != 0
  aAAttrs[GRA_AA_COLOR] := XBPSYSCLR_WINDOW
ELSEIF .T.
  aAAttrs[GRA_AA_COLOR] := oMbar:barColorBG
  aSAttrs[GRA_AS_COLOR] := oMbar:barColorFG
ELSE
  aAAttrs[GRA_AA_COLOR] := XBPSYSCLR_3DFACE
ENDIF

GraSetAttrArea( oPS, aAAttrs )
GraBox( oPS, {aInfo[4][1],aInfo[4][2]},{aInfo[4][3],aInfo[4][4]}, GRA_FILL )

aSAttrs[GRA_AS_VERTALIGN] := GRA_VALIGN_HALF
GraSetAttrString( oPS, aSAttrs )

xItem := aItem[1]
IF Valtype(xItem) = 'O'
  xItem := xItem:title
ENDIF

cStr := xItem

oPS:DrawCaptionStr( {aInfo[4][1] + ITEM_SPACING,aInfo[4][2]}, {aInfo[4][3],aInfo[4][4]}, cStr )

RETURN .T.

#endif


* ==========================================

CLASS DC_XbpMenu FROM DC_XbpMenuSuper, DC_XbaseParts

PROTECTED:

// Width computed for menu's items, see
// :MeasureItem()
VAR    ItemWidth

// Width and height of the font used
// for caption text, as well as for the
// text rendered at the left of a popup
// menu
VAR FontWidth
VAR FontHeight
VAR BarFont
VAR BarWidth
VAR CheckFont
VAR ItemFont
VAR SubVertBarFont
VAR bitmaps

EXPORTED:

// Internal array of images defined for
// the menu's items
VAR    ItemImages

VAR optionArray
VAR bgColor
VAR fgColor
VAR barColorFG
VAR barColorBG
VAR barText
VAR vertBarFontCompoundName
VAR ownerDraw
VAR checkFontCompoundName
VAR checkChar
VAR subItemFontCompoundName
VAR messageArray
VAR pointerArray

_METHOD Init, Create, Destroy, AddItem
#if XPPVER > 1900000
_METHOD MeasureItem, DrawItem, Popup
#endif

ENDCLASS

* ----------------------

METHOD DC_XbpMenu:init( oParent, aPres, lVisible, oGetList )

LOCAL bBlock, aGetList, aGetListItem, aOptions, lOwnerDraw := .F., ;
      cVertBarFontCompoundName := DC_XbpMenuConfig()[5], ;
      cCheckFontCompoundName := DC_XbpMenuConfig()[7], ;
      cCheckChar := DC_XbpMenuConfig()[8], ;
      cSubItemFontCompoundName := DC_XbpMenuConfig()[13]

::ItemImages := {}
::ItemWidth  := 0
::BarWidth   := 0
::FontWidth  := 0
::FontHeight := 0
::Bitmaps    := .t.
::XbpMenu:init( oParent, aPres, lVisible )

IF Valtype(oGetList) == 'O'

  ::DC_XbaseParts:init( oGetList,,self )

  aGetList := ::getList:getListArray
  aGetListItem := ::getList:getListArray[::getListPointer]

  ::ownerDraw := aGetListItem[xGETLIST_OPTIONS3]

  aOptions := aGetListItem[xGETLIST_OPTIONS4]
  DEFAULT aOptions := {}
  ASize(aOptions,10)

  IF aOptions[1] == nil
    ::barText := aGetListItem[cGETLIST_CAPTION]
    IF Valtype(::barText) == 'C'
      ::barText := Strtran(::barText,'&','')
      ::barText := Strtran(::barText,'~','')
    ENDIF
  ELSE
    ::barText := aOptions[1]
  ENDIF
  ::bgColor := aOptions[2]
  ::vertBarFontCompoundName := aOptions[3]
  ::barColorFG := aOptions[4]
  ::barColorBG := aOptions[5]
  ::checkFontCompoundName := aOptions[6]
  ::checkChar := aOptions[7]
  ::fgColor := aOptions[8]
  ::subItemFontCompoundname := aOptions[9]

  DEFAULT aOptions[10] := .f.
  IF aOptions[10]
    ::bitmaps := .f.
  ENDIF
  aOptions := aGetListItem[xGETLIST_OPTIONS8]
  DEFAULT aOptions := {}
  ASize(aOptions,5)
  ::beginMenu := aOptions[1]
  ::endMenu := aOptions[2]
  ::itemSelected := aOptions[3]
  ::itemMarked := aOptions[4]

  #if XPPVER > 1900000
    ::onMenuKey := aOptions[5]
  #endif

ENDIF

IF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'ownerDraw')
  lOwnerDraw := oParent:ownerDraw
  DEFAULT ::bitmaps := oParent:bitmaps
ENDIF

IF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'VertBarFontCompoundName')
  cVertBarFontCompoundName := oParent:VertBarFontCompoundName
ELSEIF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'SubVertBarFontCompoundName')
  cVertBarFontCompoundName := oParent:SubVertBarFontCompoundName
ENDIF
IF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'SubItemFontCompoundName')
  cSubItemFontCompoundName := oParent:SubItemFontCompoundName
ELSEIF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'SubItemFontCompoundName')
  cSubItemFontCompoundName := oParent:SubItemFontCompoundName
ENDIF
IF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'SubCheckFontCompoundName')
  cCheckFontCompoundName := oParent:subCheckFontCompoundName
  cCheckChar := oParent:subCheckChar
ELSEIF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'CheckFontCompoundName')
  cCheckFontCompoundName := oParent:CheckFontCompoundName
  cCheckChar := oParent:CheckChar
ENDIF

DEFAULT ::vertBarFontCompoundName := cVertBarFontCompoundName, ;
        ::barText := '', ;
        ::ownerDraw := lOwnerDraw, ;
        ::CheckFontCompoundName := cCheckFontCompoundName, ;
        ::CheckChar := cCheckChar, ;
        ::SubItemFontCompoundName := cSubItemFontCompoundName

IF DC_MenuOwnerDrawDisable()
  ::ownerDraw := .f.
  lOwnerDraw := .f.
ENDIF

IF ::bgColor == NIL
  IF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'SubBGColor')
    ::bgColor := ::parent:subBGColor
  ELSE
    ::bgColor := DC_XbpMenuConfig()[1]
  ENDIF
ENDIF

IF !Valtype(::bgColor) $ 'AN'
  ::bgColor := DC_XbpMenuConfig()[1]
ENDIF

IF Valtype(::bgColor) == 'A'
  ::bgColor := GraMakeRGBColor(::bgColor)
ENDIF

IF ::fgColor == NIL
  IF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'SubFGColor')
    ::fgColor := ::parent:subFGColor
  ELSE
    ::fgColor := DC_XbpMenuConfig()[11]
  ENDIF
ENDIF

IF !Valtype(::fgColor) $ 'AN'
  ::fgColor := DC_XbpMenuConfig()[11]
ENDIF

IF Valtype(::fgColor) == 'A'
  ::fgColor := GraMakeRGBColor(::fgColor)
ENDIF

IF ::barColorFG == NIL
  IF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'SubVertBarColorFG')
    ::barColorFG := ::parent:subVertBarColorFG
  ELSEIF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'BarColorFG')
    ::barColorFG := ::parent:BarColorFG
  ELSE
    ::barColorFG := DC_XbpMenuConfig()[2]
  ENDIF
ENDIF
IF Valtype(::barColorFG) == 'A'
  ::barColorFG := GraMakeRGBColor(::barColorFG)
ENDIF

IF ::barColorBG == NIL
  IF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'SubVertBarColorBG')
    ::barColorBG := ::parent:subVertBarColorBG
  ELSEIF Valtype(::parent) == 'O' .AND. IsMemberVar(::parent,'BarColorBG')
    ::barColorBG := ::parent:BarColorBG
  ELSE
    ::barColorBG := DC_XbpMenuConfig()[3]
  ENDIF
ENDIF

IF Valtype(::barColorBG) == 'A'
  ::barColorBG := GraMakeRGBColor(::barColorBG)
ENDIF

IF Valtype( oGetList ) == 'O'

  ::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], {}, {}, {}, {}, {} }

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')

  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF
  ::messageArray := ::cargo[5]
  ::pointerArray := ::cargo[6]

ENDIF

RETURN self

* --------------------

METHOD DC_XbpMenu:create( oParent, aPres, lVisible )

LOCAL oPS, oFnt, aBox

#if XPPVER > 1900000

IF ::ownerDraw // IsMemberVar(::parent,'ownerdraw') .AND. ::parent:ownerDraw

   // Create font used for rendering text at
   // the left-hand side

   oPS := AppDesktop():lockPS()
   oFnt := GraSetFont( oPS )
   ::FontWidth  := oFnt:width
   ::FontHeight := oFnt:height

   IF Len(::BarText) > 0
      ::BarFont := XbpFont():new( oPS )
      ::BarFont:create( ::vertBarFontCompoundName )
      ::BarWidth := ::BarFont:height

      // Compute default width for a menu.
      // This is used in case the first menu
      // item is a separator item.
      aBox := GraQueryTextBox( oPS, ::BarText )
      ::ItemWidth := ::BarWidth + (aBox[3][1] - aBox[2][1]) + ;
         ::FontWidth *8 + ITEM_SPACING *3
   ENDIF

   ::CheckFont := XbpFont():new( oPS )
   ::CheckFont:create( ::CheckFontCompoundName )

   ::ItemFont := XbpFont():new( oPS )
   ::ItemFont:create( ::SubItemFontCompoundName)

   // Determine width and height of the
   // font used for rendering caption
   // text
   ::FontWidth  := ::ItemFont:width
   ::FontHeight := ::ItemFont:height

   AppDesktop():unlockPS()

ENDIF
#endif

RETURN ::xbpMenu:create( oParent, aPres, lVisible )

* --------------

//
// Overloaded :Destroy() method. It frees resources
// allocate by :Create() and at run time.
//
METHOD DC_XbpMenu:Destroy()

IF ::BarFont != NIL .AND. ::BarFont:Status() > 0
  ::BarFont:Destroy()
ENDIF
IF ::CheckFont != NIL .AND. ::CheckFont:Status() > 0
  ::CheckFont:Destroy()
ENDIF
IF ::ItemFont != NIL .AND. ::ItemFont:Status() > 0
  ::ItemFont:Destroy()
ENDIF

AEval( ::ItemImages, {|x| IIF( x != NIL .AND. x:status()>0, x:Destroy(),)} )

RETURN ::xbpMenu:destroy()

//
// Overloaded :Init() method. It supports
// passing in images.
//

* ----------------

METHOD DC_XbpMenu:AddItem( aItem, nResId )

LOCAL oBmp
LOCAL xImage

IF Valtype(nResId) = 'A'
  nResId := nResId[1]
ENDIF

oBmp := DC_GetBitMap( nResId,,,,,.t. )

IF Valtype(oBmp) = 'O'
  IF oBmp:isDerivedFrom('XbpBitmap')
    IF oBmp:xSize > 0
      oBmp:transparentClr := oBmp:getDefaultBGColor()
      xImage := oBmp
    ELSE
      oBmp:Destroy()
    ENDIF
  ELSEIF oBmp:isDerivedFrom('XbpIcon')
    xImage := oBmp
  ENDIF
ENDIF

AAdd( ::ItemImages, xImage )

RETURN ::XbpMenu:AddItem( aItem )

//
// Overloaded :MeasureItem() method for computing
// the dimensions of the menu entries. The method
// uses GraQueryTextBox() to compute the textbox
// required for rendering the menu caption and
// adds the space required for drawing the bar
// at the left-hand side.
//

#if XPPVER > 1900000

METHOD DC_XbpMenu:MeasureItem( nItem, aDims )

LOCAL oPS, oFnt, aBox, oOldFont, cTmp, cStr, nType
LOCAL aItem := ::getItem( nItem )

// Check whether the menu item is a separator
// item. In this case, this method returns
// the item width previously computed and
// uses a constant value as the item's height.
// Separator items are displayed using a
// line.

IF aItem[3] != NIL .AND. BAnd(aItem[3], XBPMENUBAR_MIS_SEPARATOR) != 0
   aDims[1] := ::ItemWidth
   aDims[2] := ITEM_SPACING

  RETURN self
ENDIF

// Check whether a caption was defined for
// the menu item. If not, the item width
// computed previously is used. The height
// is determined based on the height of the
// font.
nType := ValType( aItem[1] )
IF nType == "C"
   cStr := aItem[1]
ELSEIf nType == "O"
   cStr := aItem[1]:title
ENDIF

IF cStr == NIL
   aDims[1] := ::BarWidth   + ::ItemWidth + ITEM_SPACING *4 + ::FontWidth *8
   aDims[2] := ::FontHeight + ITEM_SPACING *2
   AppDesktop():unlockPS()
   RETURN self
ENDIF

// Compute the dimensions of a menu item that
// has a caption string. The item's width is
// derived from the textbox required for
// rendering the caption string. Note that
// menu shortcuts require special processing,
// as these are displayed right-aligned.
// The height of the entry is computed based
// on the height of the font.
oPS  := AppDesktop():lockPS()

cTmp := StrTran( cStr, "~" )
cTmp := StrTran( cTmp, Chr(9) )
oOldFont := GraSetFont( oPS, ::itemFont )
aBox := GraQueryTextBox( oPS, cTmp )
IF Valtype(oOldFont) == 'O'
  GraSetFont( oPS, oOldFont )
ENDIF

AppDesktop():unlockPS()

aDims[1] := ::BarWidth + (aBox[3][1] - aBox[2][1]) + ;
   ::FontWidth *8 + ITEM_SPACING *4
aDims[2] := (::FontHeight   + ITEM_SPACING *2)

// Store item width computed, if the item
// is wider than those computed before.
// The item width stored is used for items
// not displaying a caption or for
// separator items
IF aDims[1] > ::ItemWidth
   ::ItemWidth := aDims[1]
ENDIF

RETURN self

* -------------

METHOD DC_XbpMenu:Popup( a, b, c)

DC_MenuWhenChecked(self,.f.)

RETURN ::XbpMenu:Popup( a, b, c )

//
// Overloaded :DrawItem() method. This method
// does the actual rendering of the individual
// menu items with respect to their respective
// states.
//
METHOD DC_XbpMenu:DrawItem( oPS, aInfo )

 LOCAL cStr, cSCut, aItem, nY, lChecked := .F.
 LOCAL aAAttrs := Array( GRA_AA_COUNT )
 LOCAL aLAttrs, nHeight, aPoints
 LOCAL aSAttrs := Array( GRA_AS_COUNT )
 LOCAL aDAttrs := Array( GRA_AS_COUNT ), x, y
 LOCAL nFill, nTmp, oOldFnt, oBmp, aOldAttrs, nType, bWhen, lEnabled := .T.
       // Rectangle for rendering caption text. The rectangle is aligned
       // to the right of the item's image and the bar displayed at the
       // menu's left-hand side
 LOCAL aTxtBox := {aInfo[4][1] + ::BarWidth + ITEM_SPACING*3 + IIF(::bitmaps,IMAGE_BOX,0), aInfo[4][2],;
                   aInfo[4][3] - ITEM_SPACING,aInfo[4][4] -1}
       // Rectangle for rendering an item's background. The background
       // rectangle encompasses both the caption and the item's image,
       // if defined. It is used for rendering selected menu items,
       // for example.
 LOCAL aItemBG := {aInfo[4][1] + ::BarWidth + ITEM_SPACING,aInfo[4][2],;
                   aInfo[4][3] - ITEM_SPACING,aInfo[4][4] -1}

   // If the first item is about to be rendered, clear
   // the background of the menu with a custom background
   // color. Also, output the bar displayed at the
   // left-hand side. Note that the background is drawn
   // only when the whole menu is redrawn. Otherwise,
   // unecessary flicker would result.


   IF BAND(aInfo[2], XBP_DRAWACTION_DRAWALL) != 0 .AND.aInfo[1] == 1

      aAAttrs[GRA_AA_COLOR] := ::bgColor
      GraSetAttrArea( oPS, aAAttrs )
      GraBox( oPS, {0,0}, {oPS:SetPageSize()[1,1], oPS:SetPageSize()[1,2]}, GRA_FILL )

      aAAttrs[GRA_AA_COLOR] := ::barColorBG
      GraSetAttrArea( oPS, aAAttrs )
      GraBox( oPS, {0,0}, {::BarWidth, oPS:setPageSize()[1][2]}, GRA_FILL )

      aSAttrs[GRA_AS_COLOR] := ::barColorFG
      aSAttrs[GRA_AS_ANGLE] := {0,10}
      aSAttrs[GRA_AS_VERTALIGN] := GRA_VALIGN_TOP

      IF Len(::BarText) > 0

         oOldFnt   := GraSetFont( oPS, ::BarFont )
         aOldAttrs := GraSetAttrString( oPS, aSAttrs )

         aPoints := GraQueryTextBox( oPS, ::BarText )
         nHeight := aPoints[5,2] - aPoints[5,1]
         IF nHeight <= oPS:setPageSize()[1][2]
           GraStringAt( oPS, {0,ITEM_SPACING}, ::BarText )
         ENDIF

         IF Valtype(aOldAttrs) == 'A'
           GraSetAttrString( oPS, aOldAttrs )
         ENDIF
         IF Valtype(oOldFnt) = 'O'
           GraSetFont( oPS, oOldFnt )
         ENDIF
      ENDIF

      aInfo[2] := BOr( aInfo[2], XBP_DRAWACTION_SELCHANGE )
   ENDIF

   lEnabled := ::isItemEnabled(aInfo[1])
   lChecked := ::isItemChecked(aInfo[1])

   // Display the image associated with the item,
   // if any. The image is positioned to the
   // right of the bar displayed at the left-hand
   // side of the menu, aligned vertically within
   // the item rectangle.
   oBmp := ::ItemImages[aInfo[1]]

   IF oBmp != NIL .AND. ::bitmaps
      nY := ((aInfo[4][4] - 1 - aInfo[4][2]) - oBmp:ySize) /2
      IF oBmp:isDerivedFrom('XbpIcon')
        nY += aInfo[4][2]+3
        x := aInfo[4][1] + ::BarWidth + ITEM_SPACING *2
        y := nY
        oBmp:draw( oPS, { x, y, x + 22, y + 22 } )
      ELSE
        nY += aInfo[4][2]
        oBmp:draw( oPS, {aInfo[4][1] + ::BarWidth + ITEM_SPACING *2,nY} )
      ENDIF
   ENDIF

   // Render the background of a menu item whose
   // selection state has changed. Selected items
   // are displayed using a special background color
   // and their display rectangles are framed. If
   // an image is associated with the item, it is
   // also framed. If the item has been unselected,
   // the whole item rectangle is cleared.
   IF BAnd(aInfo[2], XBP_DRAWACTION_SELCHANGE) != 0
      IF BAnd(aInfo[3], XBP_DRAWSTATE_SELECTED) != 0 // .AND. lEnabled
         aLAttrs := Array( GRA_AL_COUNT )
         aLAttrs[GRA_AL_COLOR] := DC_XbpMenuConfig()[4]

         GraSetAttrLine( oPS, aLAttrs )

         IF oBmp != NIL .AND. ::bitmaps
            GraBox( oPS, {aItemBG[1],aItemBG[2]}, ;
                         {aItemBG[1] + IIF(::bitmaps,IMAGE_BOX,0) + ITEM_SPACING *2,;
                          aItemBG[4]}, GRA_OUTLINE )

            // aItemBG[1] += IMAGE_BOX + IIF(::bitmaps,IMAGE_BOX,0) + ITEM_SPACING *2
            aItemBG[1] += IIF(::bitmaps,IMAGE_BOX,0) + ITEM_SPACING *2
         ENDIF

         aAAttrs[GRA_AA_COLOR] := ::barColorBG
         nFill := GRA_OUTLINEFILL
      ELSE
         IF oBmp != NIL .AND. ::bitmaps
            aLAttrs := Array( GRA_AL_COUNT )
            aLAttrs[GRA_AL_COLOR] := ::bgColor
            GraSetAttrLine( oPS, aLAttrs )
            GraBox( oPS, {aItemBG[1],aItemBG[2]}, ;
                         {aItemBG[1] + IIF(::bitmaps,IMAGE_BOX,0) + ITEM_SPACING *2,;
                          aItemBG[4]}, GRA_OUTLINE )

            aItemBG[1] += IIF(::bitmaps,IMAGE_BOX,0) + ITEM_SPACING *2
         ENDIF

         aAAttrs[GRA_AA_COLOR] := ::bgColor
         nFill := GRA_FILL
      ENDIF

      GraSetAttrArea( oPS, aAAttrs )
      GraBox( oPS, {aItemBG[1],aItemBG[2]}, {aItemBG[3],aItemBG[4]}, nFill )

   ENDIF

   // Render menu item's caption. For separator
   // items, a line is output. For menu items
   // with a caption string assigned, the string
   // is processed first to determine whether
   // it contains the definition of a menu shortcut.
   // The actual caption is rendered left-aligned,
   // whole the shortcut is aligned with the
   // item's right-hand border.
   aItem := ::getItem( aInfo[1] )
   nType := ValType( aItem[1] )

   IF nType == "C"
      cStr := aItem[1]
   ELSEIf nType == "O"
      cStr := aItem[1]:title
   ENDIF

   IF !Empty(cStr)
      nTmp := At( Chr(9), cStr )
      IF nTmp > 0
         cSCut := SubStr( cStr, nTmp +1 )
         cStr  := SubStr( cStr, 1, nTmp -1 )

         aSAttrs[GRA_AS_COLOR] := XBPSYSCLR_WINDOWTEXT
         aSAttrs[GRA_AS_HORIZALIGN] := GRA_HALIGN_RIGHT
         aSAttrs[GRA_AS_VERTALIGN]  := GRA_VALIGN_HALF
         aSAttrs[GRA_AS_ANGLE] := {1,0}
         aOldAttrs := GraSetAttrString( oPS, aSAttrs )
         nY := aTxtBox[2] + (aTxtBox[4] - aTxtBox[2]) /2
         GraStringAt( oPS, {aTxtBox[3] - ITEM_SPACING,nY}, cSCut )
         aOldAttrs := GraSetAttrString( oPS, aOldAttrs )
         GraSetAttrString( oPS, aOldAttrs )
      ENDIF
      aDAttrs[GRA_AS_COLOR] := GraMakeRGBColor(IIF(lEnabled,{0,0,0},{180,180,180}))
      aOldAttrs := GraSetAttrString( oPS, aDAttrs )
      IF lChecked
        oOldFnt := GraSetFont( oPS, ::CheckFont )

        oPS:DrawCaptionStr( {aTxtBox[1] + ITEM_SPACING,aTxtBox[2]}, ;
                            {aTxtBox[3],aTxtBox[4]}, ::checkChar )
        IF Valtype(oOldFnt) = 'O'
          GraSetFont( oPS, oOldFnt )
        ENDIF
      ENDIF
      oOldFnt := GraSetFont( oPS, ::ItemFont )
      oPS:DrawCaptionStr( {aTxtBox[1] + ITEM_SPACING + 15,aTxtBox[2]}, ;
                          {aTxtBox[3],aTxtBox[4]}, cStr )
      GraSetAttrString( oPS, aOldAttrs )
      IF Valtype(oOldFnt) = 'O'
        GraSetFont( oPS, oOldFnt )
      ENDIF
   ELSE
      aLAttrs := Array( GRA_AL_COUNT )
      aLAttrs[GRA_AL_COLOR] := DC_XbpMenuConfig()[4]
      GraSetAttrLine( oPS, aLAttrs )
      nY := aTxtBox[2] + (aTxtBox[4] - aTxtBox[2]) /2
      GraLine( oPS, {aItemBG[1] + ITEM_SPACING,nY},{aItemBG[3] - ITEM_SPACING *2,nY} )
   ENDIF

RETURN .T.

#endif


* =====================================

CLASS XbpPushButtonEx FROM XbpPushButton

EXPORTED:
   VAR nShortCut
   _METHOD GetShortCut, SetShortCut, init, create, destroy

ENDCLASS

/* ------------------ */

METHOD XbpPushButtonEx:Init( oParent, oOwner, aPos, aSize, ;
                             aPresParam, lVisible )
::xbpPushButton:Init( oParent, oOwner, aPos, aSize, ;
                      aPresParam, lVisible )
::nShortCut := NIL

RETURN self

* ------------------ *

METHOD XbpPushButtonEx:create( oParent, oOwner, aPos, aSize, ;
                               aPresParam, lVisible )
::xbpPushButton:create( oParent, oOwner, aPos, aSize, ;
                        aPresParam, lVisible )

::SetShortCut()

RETURN self

* ------------------

METHOD XbpPushButtonEx:SetShortCut()

IF ( ::nShortCut := ::GetShortCut()) != NIL

  SetAppEvent( ::nShortCut, { | uNil1, uNil2, o| ;
               SetAppFocus(self), ;
               IIF( SetAppFocus()==self,PostAppEvent( xbeP_Activate,,, self),nil)})
ENDIF

RETURN self

* ------------------

METHOD XbpPushButtonEx:destroy()

IF ::nShortCut != NIL
  SetAppEvent( ::nShortCut, )
ENDIF
::xbpPushButton:destroy()

RETURN self

* ------------------

METHOD XbpPushButtonEx:GetShortCut()

LOCAL nRet, nPos

IF VALTYPE( ::caption) == "C"
  IF ( nPos := AT( "&", ::caption)) != 0
       nRet := xbeK_ALT_A +       ;
       ASC( UPPER( SUBSTR( ::caption, nPos + 1, 1))) - 65
  ENDIF
ENDIF
RETURN( nRet)

* ===========================================================================

CLASS DC_XbpStatusBar FROM DC_XbpStatusBarSuper, DC_XbaseParts
EXPORTED:
  VAR optionArray
  VAR width
  VAR height
  VAR padding
  VAR align
  VAR color
  _METHOD init, create, WhenHideEval
ENDCLASS

* ---------------------

METHOD DC_XbpStatusBar:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, nWidth, nHeight, aGetList, aGetListItem

DEFAULT aSize := {0,0}
nWidth := aSize[1]
nHeight := aSize[2]

aSize := { nWidth, nHeight }

::XbpStatic:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

xOptions := aGetListItem[xGETLIST_OPTIONS]

ASize(xOptions,2)

DEFAULT xOptions[1] := DCGUI_ALIGN_BOTTOM, ;
        xOptions[2] := 3
::tabstop := .f.
::align := xOptions[1]
::padding := xOptions[2]
::width := nWidth
::height := nHeight

DEFAULT aGetListItem[nGETLIST_SUBTYPE] := XBPSTATIC_TYPE_RAISEDBOX

IF !Empty(aGetListItem[nGETLIST_SUBTYPE])
  ::type := aGetListItem[nGETLIST_SUBTYPE]
ENDIF

::clipSiblings := .T.

::optionArray := xOptions

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

::clipSiblings := .T.

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpStatusBar:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetList := ::getList:getListArray
LOCAL aGetListItem := ::getList:getListArray[::getListPointer]

::xbpStatic:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::color := aGetListItem[aGETLIST_COLOR]
IF Empty(::color)
  ::color := { nil, GRA_CLR_BACKGROUND }
ENDIF

DC_XbpSetColor( ::color, self, oParent, ;
   aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

RETURN self

* -------------------

METHOD DC_XbpStatusBar:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ===========================================================================

CLASS DC_XbpPanel FROM DC_XbpPanelSuper, DC_XbaseParts
EXPORTED:
  VAR optionArray
  VAR width
  VAR height
  VAR padding
  VAR align
  VAR color
  _METHOD init, create, WhenHideEval
ENDCLASS

* ---------------------

METHOD DC_XbpPanel:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, nWidth, nHeight, aGetList, aGetListItem, lDrawingArea := .f.

DEFAULT aSize := {0,0}
nWidth := aSize[1]
nHeight := aSize[2]

aSize := { nWidth, nHeight }
::XbpDialog:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

xOptions := aGetListItem[xGETLIST_OPTIONS]

ASize(xOptions,4)

DEFAULT xOptions[1] := DCGUI_ALIGN_BOTTOM, ;
        xOptions[2] := 3, ;
        xOptions[3] := 0, ;
        xOptions[4] := nil

::tabstop := .f.
::align := xOptions[1]
::padding := xOptions[2]
::width := nWidth
::height := nHeight
::titleBar := .f.

IF !Empty(xOptions[3])
  ::border := xOptions[3]
ENDIF
bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR],'O')
lDrawingArea := .f.
IF Valtype(bBlock) = 'B'
  Eval( bBlock, ::drawingArea )
  lDrawingArea := .t.
ENDIF
bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, IIF( lDrawingArea,self,::drawingArea) )
ENDIF

::clipSiblings := .T.

::optionArray := xOptions

::color := aGetListItem[aGETLIST_COLOR]
DC_XbpSetColor( ::color, ::drawingArea, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

::clipSiblings := .T.
::resize := {|a,b,o|DC_StatusBarRepaint(oParent:setParent(),.t.,a,b,::align)}

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self, aGetList )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpPanel:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::xbpDialog:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:setOrig(self)

RETURN self

* -------------------

METHOD DC_XbpPanel:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )


* ===========================================================================

CLASS DC_XbpTreeView FROM DC_XbpTreeViewSuper, DC_XbaseParts
EXPORTED:
  VAR validBlock
  VAR optionArray
  VAR checkedChar
  _METHOD init, create, WhenHideEval, setData
ENDCLASS

* ---------------------

METHOD DC_XbpTreeView:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, aGetList, aGetListItem, nWidth, nHeight

DEFAULT aSize := {0,0}
nWidth := aSize[1]
nHeight := aSize[2]

aSize := { nWidth, nHeight }

::XbpTreeView:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

xOptions := aGetListItem[xGETLIST_OPTIONS]

ASize(xOptions,4)

DEFAULT xOptions[1] := .f., ;
        xOptions[2] := .f., ;
        xOptions[3] := .f.

::hasButtons := xOptions[1]
::hasLines   := xOptions[2]
::alwaysShowSelection  := xOptions[3]
::checkedChar := xOptions[4]
::itemCollapsed := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS3])
::itemExpanded := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS4])
::itemMarked := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS5])
::itemSelected := _TreeItemBlock(DC_GetBlock(aGetListItem[xGETLIST_OPTIONS6]),self)

::validBlock := aGetListItem[bGETLIST_VALID]

::keyboard := ;
      {|a,b,o|IIF(a==xbeK_ENTER,PostAppEvent(xbeTV_ItemSelected,o:getData(),,o),nil)}

::clipSiblings := .T.

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpTreeView:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem

::xbpTreeView:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]

IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
  ::SetFont(aGetListItem[cGETLIST_FONT])
ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
  ::SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT] ))
ENDIF

IF !Empty(aGetListItem[aGETLIST_COLOR])
  DC_XbpSetColor( aGetListItem[aGETLIST_COLOR], self, oParent, ;
                  aGetlistItem[aGETLIST_PRESENTATION], .t., .f. )
ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* ---------------------------

METHOD DC_XbpTreeView:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ---------------------------

METHOD DC_XbpTreeView:setData(o)

IF Valtype(o) == 'O'
  RETURN ::xbpTreeView:setData(o)
ENDIF

RETURN nil

* -----------------------

STATIC FUNCTION _TreeItemBlock( bBlock )

IF Valtype(bBlock) = 'B'
  RETURN {|a,b,c|_TreeItem(a,b,c),Eval(bBlock,a,b,c)}
ENDIF

RETURN {|a,b,c|_TreeItem(a,b,c)}

* --------------------

STATIC FUNCTION  _TreeItem( oItem, aRect, oTree )

LOCAL lFirstClick, lEmpty

IF Valtype(oItem) = 'O' .AND. oItem:isderivedFrom('DC_XbpTreeViewItem')
  lEmpty := Empty(oItem:getChildItems())
  IF Valtype(oItem:actionBlock) = 'B' .AND. oItem:isItemEnabled()
    Eval(oItem:actionBlock,oItem,aRect,oTree)
    lFirstClick := oItem:firstClick
    DEFAULT lFirstClick := .f.
    IF lFirstClick
      oItem:actionBlock := nil
    ENDIF
  ENDIF
  IF aRect == NIL .AND. !lEmpty
    IF oItem:isExpanded()
      oItem:expand(.f.)
    ELSE
      oItem:expand(.t.)
    ENDIF
  ENDIF
ENDIF

RETURN nil

* ===========================================================================

CLASS DC_XbpTreeViewItem FROM DC_XbpTreeViewItemSuper, DC_XbaseParts

EXPORTED:
  VAR actionBlock
  VAR firstClick
  VAR optionArray
  VAR parentObject
  VAR checkWhenBlock
  VAR checkedChar
  VAR checkedImage
  VAR unCheckedImage
  VAR unCheckedMarkedImage
  VAR unCheckedExpandedImage
  VAR checked
  VAR enabled
  VAR treeRoot
  VAR helpLink
  VAR activateItem
  VAR index

_METHOD init, create, setData, checkItem, isItemChecked, isItemEnabled, ;
        updateItemIcon, setName

PROTECTED:
  VAR setName

ENDCLASS

* ---------------------

METHOD DC_XbpTreeViewItem:init( oParent, oGetList, nPointer )

LOCAL bBlock, aGetList, aGetListItem, aIcons, aOptions, aBitmaps

::XbpTreeViewItem:init()

IF Valtype(oGetList) # 'O'
  RETURN self
ENDIF

::getList := oGetList
IF Valtype(nPointer) == 'N'
  ::getListPointer := nPointer
ELSE
  ::getListPointer := ::getList:getListPointer
ENDIF

::DC_XbaseParts:init( oGetList, nPointer, self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

IF aGetListItem[nGETLIST_TYPE] == GETLIST_TREEITEM

  IF Valtype( aGetListItem[xGETLIST_OPTIONS2] ) $ 'CNO'
    ::expandedImage := DC_GetBitMap(aGetListItem[xGETLIST_OPTIONS2])
    ::unCheckedExpandedImage := ::expandedImage
  ENDIF

  IF Valtype( aGetListItem[xGETLIST_OPTIONS3] ) $ 'CNO'
    ::Image := DC_GetBitMap(aGetListItem[xGETLIST_OPTIONS3])
    ::unCheckedImage := ::image
  ENDIF

  IF Valtype( aGetListItem[xGETLIST_OPTIONS4] ) $ 'CNO'
    ::markedImage := DC_GetBitMap(aGetListItem[xGETLIST_OPTIONS4])
    ::unCheckedMarkedImage := ::markedImage
  ENDIF

  IF Valtype( aGetListItem[xGETLIST_OPTIONS7] ) $ 'CNO'
    ::checkedImage := DC_GetBitMap(aGetListItem[xGETLIST_OPTIONS7])
  ENDIF

  IF Valtype( aGetListItem[xGETLIST_OPTIONS5] ) = 'C'
    ::dllName := aGetListItem[xGETLIST_OPTIONS5]
  ENDIF

  ::firstClick := aGetListItem[xGETLIST_OPTIONS6]

  ::checkedChar := aGetListItem[xGETLIST_OPTIONS8]
  ::checkWhenBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS9])

  IF Empty(::checkedChar) .AND. IsMemberVar(oParent,'CHECKEDCHAR')
    ::checkedChar := oParent:checkedChar
  ENDIF

ELSEIF aGetListItem[nGETLIST_TYPE] $ { GETLIST_SUBMENU, GETLIST_MENUITEM }

  aOptions := aGetListItem[xGETLIST_OPTIONS]
  DEFAULT aOptions := {}
  ASize( aOptions, 9 )
  ::checkWhenBlock := DC_GetBlock(aOptions[9])

  aOptions := aGetListItem[xGETLIST_OPTIONS4]
  DEFAULT aOptions := {}
  ASize( aOptions, 7 )
  ::checkedChar := aOptions[7]

  aIcons := aGetListItem[xGETLIST_OPTIONS7]
  DEFAULT aIcons := {}
  ASize( aIcons, 5 )

  aBitmaps := aGetListItem[xGETLIST_OPTIONS2]
  DEFAULT aBitmaps := {}
  ASize( aBitmaps, 2 )

  IF Valtype( aIcons[1] ) $ 'CNO'
    ::expandedImage := DC_GetBitMap(aIcons[1])
  ELSEIF Valtype( aBitmaps[1] ) $ 'CNO'
    ::expandedImage := DC_GetBitMap(aBitmaps[1])
  ENDIF

  IF Valtype( aIcons[2] ) $ 'CNO'
    ::Image := DC_GetBitMap(aIcons[2])
  ELSEIF Valtype( aBitmaps[1] ) $ 'CNO'
    ::Image := DC_GetBitMap(aBitmaps[1])
  ENDIF

  IF Valtype( aIcons[3] ) $ 'CNO'
    ::markedImage := DC_GetBitMap(aIcons[2])
  ELSEIF Valtype( aBitmaps[1] ) $ 'CNO'
    ::markedImage := DC_GetBitMap(aBitmaps[1])
  ENDIF

  IF Valtype( aIcons[4] ) $ 'CNO'
    ::checkedImage := DC_GetBitMap(aIcons[3])
  ELSEIF Valtype( aBitmaps[2] ) $ 'CNO'
    ::checkedImage := DC_GetBitMap(aBitmaps[2])
  ENDIF

  IF Valtype( aIcons[5] ) = 'C'
    ::dllName := aIcons[5]
  ENDIF

  ::activateItem := aGetListItem[xGETLIST_OPTIONS6]

ENDIF

::caption := aGetListItem[cGETLIST_CAPTION]

DEFAULT ::caption := ''

IF !'~~'$::caption
  ::caption := StrTran(::caption,'~','')
ELSE
  ::caption := StrTran(::caption,'~~','~')
ENDIF

IF !'&&'$::caption
  ::caption := StrTran(::caption,'&','')
ENDIF

::parentObject := oParent
bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

::actionBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
::checked := .f.
::enabled := .t.

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpTreeViewItem:create()

LOCAL aGetListItem

::xbpTreeViewItem:create()

IF Empty(::getList)
  RETURN self
ENDIF

aGetListItem := ::getList:getListArray[::getListPointer]

IF IsMemberVar(::parentObject,'ROOTITEM')
  ::parentObject:rootitem:addItem(self)
  ::treeRoot := ::parentObject
  ::index := Len(::parentObject:rootItem:getchildItems())
ELSE
  ::parentObject:addItem(self)
  ::treeRoot := ::parentObject:treeRoot
  ::index := Len(::parentObject:getchildItems())
ENDIF

IF Valtype(aGetListItem[xGETLIST_OPTIONS5]) == 'N'
  ::setName := aGetListItem[xGETLIST_OPTIONS5]
ENDIF

RETURN self

* ---------------------------

METHOD DC_XbpTreeViewItem:setName(nName)

LOCAL nOldName := ::setName
IF Valtype(nName) = 'N'
  ::setName := nName
ENDIF

RETURN nOldName

* ---------------------------

METHOD DC_XbpTreeViewItem:setData(xValue)

IF PCount() >= 1
  RETURN ::xbpTreeViewItem:setData(xValue)
ENDIF

RETURN nil

* --------------------

METHOD DC_XbpTreeViewItem:checkItem( lCheck )

LOCAL cCaption, lUpdateIcon := .f.

IF lCheck .AND. !::checked
  ::checked := .t.
  IF !Empty(::checkedChar)
    cCaption := StrTran(::caption,::checkedChar,'')
    ::setCaption( ::checkedChar + cCaption )
  ENDIF
  lUpdateIcon := .t.
ELSEIF !lCheck .AND. ::checked
  ::checked := .f.
  IF !Empty(::checkedChar)
    cCaption := StrTran(::caption,::checkedChar,'')
    ::setCaption( cCaption )
  ENDIF
  lUpdateIcon := .t.
ENDIF

IF !Empty(::checkedImage) .AND. lUpdateIcon
  ::updateItemIcon()
ENDIF

RETURN nil

* ---------------------

METHOD DC_XbpTreeViewItem:updateItemIcon()

LOCAL i, aArray, oParentItem := ::getParentItem(), oInsAfter, oTreeItem, nNormalImage, ;
      nMarkedImage, nExpandedImage, oSaveItem, aGetList, nPointer, ;
      lChecked := ::checked, nNormalImageSave := ::image, oTreeRoot, ;
      nMarkedImageSave := ::markedImage, nExpandedImageSave := ::expandedImage

#if XPPVER > 1900000

  IF ::checked .AND. !Empty(::checkedImage)
    ::setImage(::checkedImage)
    ::setMarkedImage(::checkedImage)
    ::setExpandedImage(::checkedImage)
  ELSEIF !::checked .AND. !Empty(::uncheckedImage)
    ::setImage(::unCheckedImage)
    DEFAULT ::unCheckedMarkedImage := ::unCheckedImage, ;
            ::unCheckedExpandedImage := ::unCheckedMarkedImage
    ::setMarkedImage(::unCheckedMarkedImage)
    ::setExpandedImage(::unCheckedExpandedImage)
  ENDIF
  IF ::treeRoot:getData() == self
    ::treeRoot:setData(self)
  ENDIF

#else

aArray := oParentItem:getChildItems()
FOR i := 1 TO Len(aArray)
  IF aArray[i] == self
    IF i>1
      oInsAfter := aArray[i-1]
    ELSE
      oInsAfter := nil
    ENDIF
    EXIT
  ENDIF
NEXT

oTreeRoot := ::treeRoot
oSaveItem := ::treeRoot:getData()

oParentItem:delItem(self)

IF ::checked
  nNormalImage := ::checkedImage
  nMarkedImage := ::checkedImage
  nExpandedImage := ::checkedImage
ELSE
  nNormalImage := ::image
  nMarkedImage := ::markedImage
  nExpandedImage := ::expandedImage
ENDIF

aGetList := ::getList:getListArray
nPointer := ::getListPointer
aGetList[nPointer,xGETLIST_OPTIONS2] := nExpandedImage
aGetList[nPointer,xGETLIST_OPTIONS3] := nNormalImage
aGetList[nPointer,xGETLIST_OPTIONS4] := nMarkedImage
aGetList[nPointer,xGETLIST_OPTIONS7] := ::checkedImage

aGetList[nPointer,cGETLIST_CAPTION] := ::caption
oTreeItem := DC_XbpTreeViewItem():new( oParentItem, ::getList, nPointer )
oTreeItem:xbpTreeViewItem:create()
oTreeItem:checked := lChecked
aGetList[nPointer,oGETLIST_OBJECT] := oTreeItem
::treeRoot:lockUpdate(.t.)
oParentItem:insItem(oInsAfter, oTreeItem )
oTreeItem:image := nNormalImageSave
oTreeItem:markedImage := nMarkedImageSave
oTreeItem:expandedImage := nExpandedImageSave
oTreeItem:treeRoot := oTreeRoot
IF oSaveItem == self
  ::treeRoot:setData(oTreeItem)
ELSE
  ::treeRoot:setData(oSaveItem)
ENDIF
::treeRoot:lockUpdate(.f.)

#endif

RETURN nil

* --------------------

METHOD DC_XbpTreeViewItem:isItemEnabled()

RETURN ::enabled

* --------------------

METHOD DC_XbpTreeViewItem:isItemChecked()

RETURN ::checked

* =========================================================

#if XPPVER > 1900000

CLASS DC_XbpActiveXControl FROM DC_XbpActiveXControlSuper, DC_XbaseParts
EXPORTED:
  VAR cargo
  VAR anchorBlock
  VAR actionBlock
  VAR actionArray
  VAR colorBG
  VAR colorFG
  _METHOD init, create, WhenHideEval, Action, AddAction
ENDCLASS

* ---------------------

METHOD DC_XbpActiveXControl:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, cCaption, bBlock, lAutoSize := .f., ;
      aGetList, aGetListItem, cClsID, cLicense, ;
      aRegister, cOCX, lPrompt, cRegQuery, cRegSvr, cRegisterID


::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
::actionArray := {}

IF Empty(::clsID)
  cClsID := aGetListItem[xGETLIST_OPTIONS]
ELSE
  cClsID := ::clsID
ENDIF
cLicense := aGetListItem[xGETLIST_OPTIONS2]

IF Empty(cClsId)
  DC_WinAlert('CLSID is required for ActiveX Control')
  RETURN self
ENDIF

aRegister := aGetListItem[xGETLIST_OPTIONS9]

IF Valtype(aRegister) == 'A'
  cRegSvr := 'regsvr32.exe'
  cRegisterID := aRegister[1]
  cOCX := aRegister[2]
  lPrompt := aRegister[3]
  DEFAULT lPrompt := .f.
  cRegQuery := DC_RegQuery(HKEY_CLASSES_ROOT,'\CLSID\'+cRegisterID,'')
  IF Valtype(cRegQuery) # 'C' .OR. Empty(cRegQuery)
    IF !Empty(DC_PathFound(cRegSvr,GetEnv('PATH')))
      RunShell(cOCX +' /s',cRegSvr)
    ELSEIF lPrompt
      DC_WinAlert('Could not find ' + cRegSvr + ' to register ' + cOCX )
      RETURN self
    ENDIF
  ENDIF
  cRegQuery := DC_RegQuery(HKEY_CLASSES_ROOT,'\CLSID\'+cRegisterID,'')
  IF (Valtype(cRegQuery) # 'C' .OR. Empty(cRegQuery)) .AND. lPrompt
    DC_WinAlert('Could not register ' + cOCX )
    RETURN self
  ENDIF
ENDIF

IF Empty(aPos)
  aPos := { 1, 1 }
ENDIF

IF Empty(aSize) .OR. Empty(aSize[1]) .OR. Empty(aSize[2])
  aSize := { oParent:currentSize()[1], oParent:currentSize()[2] }
ENDIF

::XbpActiveXControl:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::clsID := cClsID
IF !Empty(cLicense)
  ::license := cLicense
ENDIF

// ::tabstop := .f.

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* ------------------

METHOD DC_XbpActiveXControl:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::xbpActiveXControl:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:setOrig(self)

RETURN self

* ---------------------------

METHOD DC_XbpActiveXControl:WhenHideEval( lEnable, lShow, lProtect )

IF Valtype(::whenBlock) = 'B'
  lEnable:= Eval(::whenBlock,self)
  IF lEnable
    ::enable()
  ELSE
    ::disable()
  ENDIF
ENDIF

IF Valtype(::hideBlock) = 'B'
  lShow := !Eval(::hideBlock,self)
  IF lShow
    IF !::isVisible()
      ::show()
    ENDIF
  ELSE
    IF ::isVisible()
      ::hide()
    ENDIF
  ENDIF
ENDIF

RETURN self

* ----------

METHOD DC_XbpActiveXControl:Action( nIndex )

LOCAL nFound

IF Valtype(nIndex) == 'N' .AND. (nFound := AScan(::actionArray,{|a|a[1]==nIndex})) > 0
  Eval(::actionArray[nFound,2],self)
ELSEIF Valtype(::actionBlock) == 'B'
  Eval(::actionBlock,self)
ENDIF

RETURN self

* ---------

METHOD DC_XbpActiveXControl:AddAction( aAction )

AAdd( ::actionArray, aAction )

RETURN self

#endif



* ========================================================================

STATIC FUNCTION _WhenHideEval( lEnable, lShow, lProtect, oXbp )

IF Valtype(oXbp:whenBlock) = 'B'
  lEnable:= Eval(oXbp:whenBlock,oXbp)
  IF lEnable
    oXbp:enable()
  ELSE
    oXbp:disable()
  ENDIF
ENDIF

IF Valtype(oXbp:hideBlock) = 'B'
  lShow := !Eval(oXbp:hideBlock,oXbp)
  IF lShow
    oXbp:show()
  ELSE
    oXbp:hide()
  ENDIF
ENDIF

IF Valtype(lProtect) == 'L' .AND. Valtype(oXbp:protectBlock) = 'B'
  lProtect := Eval(oXbp:protectBlock,oXbp)
ENDIF

RETURN oXbp

* ==============================================

STATIC FUNCTION _Default( xValue, xDefault )

IF Valtype(xValue) == Valtype(xDefault)
  RETURN xValue
ENDIF
RETURN xDefault

* ==============================================

FUNCTION DC_WinMenuDestroyMode( nMode )

STATIC snDestroyMode := DCGUI_WINMENU_DESTROYMODE_EXIT
LOCAL nOldDestroyMode := snDestroyMode
IF Valtype(nMode)=='N'
  snDestroyMode := nMode
ENDIF

RETURN nOldDestroyMode

* ==============================================

FUNCTION DC_WinMenu( lDestroy, lCreate, oGetList )
// Create menu to manage open windows.

STATIC soMenu
DEFAULT lDestroy := .f., ;
        lCreate := .f.
IF lDestroy
  soMenu := nil
ELSEIF soMenu == nil .AND. lCreate
  soMenu := DC_WindowMenu():new(DC_SetAppmenu())
  soMenu:barText := 'Window'
  soMenu:create()
ENDIF

RETURN (somenu)


// MENU CLASS TO MANAGE OPEN WINDOWS
// This class is modified from the MDI demo included in the
// Xbase++ 1.5 release.

CLASS DC_WindowMenu FROM DC_XbpMenu

   PROTECTED:
     CLASS VAR windowStack, winCount, offset

   EXPORTED:
     CLASS METHOD initClass, setWindowFocus, ;
                  cascadeWindows, minimize_windows, maximize_windows
     CLASS VAR currentWin READONLY
     _METHOD init, create, addItem, delItem, setItem, checkItem, ;
             closeWindows, delMenu, closeCurrent

ENDCLASS

// Initialize member variables of the class object (class variables)
CLASS METHOD DC_WindowMenu:initClass
   ::windowStack := {}
   ::winCount    := 0
   ::offset      := 0
RETURN self

// Set focus to a window by ordinal position in menu
CLASS METHOD DC_WindowMenu:setWindowFocus( nItem )
   LOCAL oDlg := ::windowStack[ nItem - ::offset ]

   IF oDlg:getFrameState() == XBPDLG_FRAMESTAT_MINIMIZED
      oDlg:setFrameState( XBPDLG_FRAMESTAT_NORMALIZED )
   ENDIF

   SetAppFocus( oDlg )
RETURN self

//Cascade windows
CLASS METHOD DC_WindowMenu:cascadeWindows
   LOCAL i, nParentHeight, nHeight, nStartRow

   nParentHeight := SetAppWindow():drawingArea:currentSize()[2]

   FOR i := 1 TO ::winCount

     ::windowStack[i]:hide()
     ::windowStack[i]:setFrameState( XBPDLG_FRAMESTAT_NORMALIZED )

     nHeight := ::windowStack[i]:currentSize()[2]
     nStartRow := nParentHeight - (i-1)*22 - nHeight

     ::windowStack[i]:setPos( { (i-1)*22, nStartRow } )
     ::windowStack[i]:show()
     ::windowStack[i]:toFront()

   NEXT

   IF !Empty(::windowStack)
     SetAppFocus( ATail( ::windowStack ) )
   ENDIF

RETURN self



// Minimize all windows
CLASS METHOD DC_WindowMenu:minimize_windows

local i

for i := 1 to ::wincount
  ::windowstack[i]:setframestate(XBPDLG_FRAMESTAT_MINIMIZED)
next i

return self

// Maximize all windows
CLASS METHOD DC_WindowMenu:maximize_windows

local i

for i := 1 to ::wincount
  ::windowstack[i]:setframestate(XBPDLG_FRAMESTAT_NORMALIZED)
next i

return self

// close current window
METHOD DC_WindowMenu:closeCurrent
LOCAL oDlg // , lClose, bCloseQuery

oDlg := ::currentWin
PostAppEvent(xbeP_Close,,,oDlg) // Thanks to Dian Ray for this fix
Sleep(20)

/*
IF Valtype(oDlg) = 'O' .AND. !Empty(oDlg:cargo) .AND. ThreadID() # oDlg:cargo[6]
  IF Len(oDlg:cargo) >= 7
    bCloseQuery := oDlg:cargo[7]:closeQueryBlock
  ENDIF
  IF Valtype(bCloseQuery) == 'B'
    lClose := Eval(bCloseQuery)
  ELSE
    lClose := .t.
  ENDIF
  IF lClose
    ::delItem(oDlg)
    DC_ReadGuiEvent(DCGUI_EXIT_ABORT,oDlg:cargo[2])
  ENDIF
ELSEIF Valtype(oDlg) = 'O'
  ::delItem(oDlg)
  IF oDlg:status() > 0
    oDlg:destroy()
  ENDIF
ENDIF

PostAppEvent(xbeP_None,,,oDlg)
*/

RETURN self


// Close all child windows
METHOD DC_WindowMenu:closeWindows

LOCAL oDlg, lClose, bCloseQuery

DO WHILE ! Empty( ::windowStack )
  oDlg := ATail(::windowStack)
  IF Valtype(oDlg) = 'O' .AND. !Empty(oDlg:cargo) .AND. ThreadID() # oDlg:cargo[6]
    IF Len(oDlg:cargo) >= 7
      bCloseQuery := oDlg:cargo[7]:closeQueryBlock
    ENDIF
    IF Valtype(bCloseQuery) == 'B'
      lClose := Eval(bCloseQuery)
    ELSE
      lClose := .t.
    ENDIF
    IF lClose
      ::delItem(oDlg)
      DC_ReadGuiEvent(DCGUI_EXIT_OK,oDlg:cargo[2])
    ELSE
      EXIT
    ENDIF
  ELSEIF Valtype(oDlg) = 'O' .AND. oDlg:status() > 0
    ::delItem(oDlg)
    oDlg:destroy()
  ENDIF
  PostAppEvent(xbeP_None,,,oDlg)
ENDDO

RETURN self


// Initialize object and add a submenu for basic database operations
METHOD DC_WindowMenu:init( oParent, aPresParam, lVisible )

   ::DC_xbpMenu:init( oParent, aPresParam, lVisible )
   ::title := DC_LangMsg(DCMSG_WIN_WINDOW)
RETURN self


// Request system resources and add default items
METHOD DC_WindowMenu:create( oParent, aPresParam, lVisible )

LOCAL nAttr := 0
#if XPPVER > 1900000
IF Valtype(::setParent()) == 'O' .AND. IsMemberVar(::setParent(),'OWNERDRAW') .AND. ::setParent():ownerDraw
  nAttr += XBPMENUBAR_MIA_OWNERDRAW
  ::ownerDraw := .t.
  ::barText := 'Window'
ENDIF
#endif

::DC_xbpMenu:create( oParent, aPresParam, lVisible )

   ::itemSelected := {|nItem| ::setWindowFocus( nItem ) }

   ::DC_xbpMenu:addItem( { DC_LangMsg(DCMSG_WIN_CLOSECUR), {|| DC_WinMenu():closeCurrent()    },,nAttr } )
   ::DC_xbpMenu:addItem( { DC_LangMsg(DCMSG_WIN_CLOSEALL), {|| DC_WinMenu():closeWindows()    },,nAttr } )
   ::DC_xbpMenu:addItem( { nil,,XBPMENUBAR_MIS_SEPARATOR,nAttr } )
   ::DC_xbpMenu:addItem( { DC_LangMsg(DCMSG_WIN_CASCADE),  {|| DC_WinMenu():cascadeWindows()  },,nAttr } )
   ::DC_xbpMenu:addItem( { DC_LangMsg(DCMSG_WIN_MAXIMIZE), {|| DC_WinMenu():maximize_windows()},,nAttr } )
   ::DC_xbpMenu:addItem( { DC_LangMsg(DCMSG_WIN_MINIMIZE), {|| DC_WinMenu():minimize_windows()},,nAttr } )
   ::DC_xbpMenu:addItem( { nil,,XBPMENUBAR_MIS_SEPARATOR,nAttr} )
   ::offset := 7

RETURN self

// Use title of a dialog window as text for menu item
METHOD DC_WindowMenu:addItem( oDlg )
LOCAL cItem := oDlg:getTitle()
LOCAL nAttr := 0

#if XPPVER > 1900000
IF IsMemberVar(::setParent(),'OWNERDRAW') .AND. ::setParent():ownerDraw
 nAttr += XBPMENUBAR_MIA_OWNERDRAW
ENDIF
#endif

   AAdd( ::windowStack, oDlg )
   ::winCount ++
   cItem := "~" + Ltrim( Str( ::winCount ) ) + " " + cItem
   ::DC_xbpMenu:addItem( { cItem, NIL,,nAttr} )
   IF ::numItems() == ::offset + 1
      ::setParent():insItem( ::setParent():numItems() , {self, NIL,, nAttr} )
   ENDIF

RETURN self

// Transfer changed window title to menu item
METHOD DC_WindowMenu:setItem( oDlg )
   LOCAL aItem, i, bError := ErrorBlock({|e|TrapError(e)})

   IF Empty(::windowStack)
     RETURN self
   ENDIF

   BEGIN SEQUENCE

   i := AScan( ::windowStack, oDlg )

   IF i == 0
      ::addItem( oDlg )
   ELSEIF ::xbpMenu:numItems()>= i + ::offset     // PC CAW 5-18-04 add IF and rest of line from ELSE
      aItem    := ::xbpMenu:getItem( i + ::offset )
      aItem[1] := "~" + Ltrim( Str(i) ) + " " + oDlg:getTitle()
      ::xbpMenu:setItem( i + ::offset, aItem )
      IF oDlg == ::currentWin
         ::checkItem( oDlg )
      ENDIF
   ENDIF

   END SEQUENCE
   ErrorBlock(bError)

RETURN self

* --------------

METHOD DC_WindowMenu:delMenu()

LOCAL nPos := ::setParent():numItems()-1

::setParent():delItem(nPos)
::windowStack := {}
::currentWin := NIL
::winCount := 0

RETURN self

* --------------

// Delete dialog window from window stack and from menu
METHOD DC_WindowMenu:delItem( oDlg )

LOCAL i, nPos, bError

IF Empty(::windowStack)
  RETURN self
ENDIF

i    := AScan( ::windowStack, oDlg )
nPos := ::setParent():numItems()-1

IF i > 0 .AND. i <= ::winCount

   bError := ErrorBlock({||TrapError()})
   BEGIN SEQUENCE
   ::xbpMenu:delItem( i + ::offset )

   IF ::currentWin ==  ::windowStack[i]
      ::currentWin := NIL
   ENDIF

   ADel( ::windowStack, i )
   ::winCount --
   Asize( ::windowStack, ::winCount )

   IF i <= ::winCount
      AEval( ::windowStack, {|o| ::setItem( o ) }, i )
   ENDIF

   IF ::numItems() == ::offset
      ::setParent():delItem( nPos )
   ELSEIF ::currentWin == NIL
      SetAppFocus( Atail( ::windowStack ) )
   ENDIF
   END SEQUENCE
   ErrorBlock(bError)

ENDIF

RETURN self


// Check menu item for current window
METHOD DC_WindowMenu:checkItem( oDlg )
   LOCAL i, bErrorBlock

   IF Empty(::windowStack)
     RETURN self
   ENDIF

   i = AScan( ::windowStack, oDlg ) + ::offset

   IF ::currentWin <> NIL
      ::xbpMenu:checkItem( AScan(::windowStack, ::currentWin ) + ::offset , .F. )
   ENDIF

   ::currentWin := oDlg
   bErrorBlock := ErrorBlock({||TrapError()})  // error can sometime occurs during quit of program
   BEGIN SEQUENCE
   ::xbpMenu:checkItem( i, .T. )
   END SEQUENCE
   ErrorBlock(bErrorBlock)

RETURN self

* ---------------

STATIC FUNCTION TrapError()

BREAK

RETURN nil

* ---------------

function DC_SetAppMenu(oMenuBar)
// Get/set main application menu.
// Parameters: omenu - application menu object (set) or nil (get)

STATIC soMenuBar
LOCAL oOldMenuBar := soMenuBar

IF Valtype(oMenuBar) == 'O'
  soMenuBar := oMenuBar
ENDIF

RETURN oOldMenuBar

* ---------------

FUNCTION DC_SetRoundRectRegion( oXbp, nRadiusH, nRadiusV ) // nWidth, nHeight, nRadius )

LOCAL nDLL, nDLL2, hRgn, nWidth, nHeight

nWidth := oXbp:currentSize()[1]
nHeight := oXbp:currentSize()[2]

DEFAULT nRadiusV := 10, ;
        nRadiusH := nRadiusV

nDLL := _DLLLoadLS( 'GDI32.DLL' )
IF nDll <> 0
  hRgn := DllCall( nDLL, DLL_STDCALL,"CreateRoundRectRgn", ;
            0,;
            0,;
            nWidth,;
            nHeight, ;
            nRadiusH, ;
            nRadiusV )

  nDll2 := _DLLLoadLs( 'USER32.DLL' )
  DllCall( nDll2, DLL_STDCALL,"SetWindowRgn", oXbp:GetHwnd(), hRgn, 1 )
  _DllUnloadLS(nDll)
  _DLLUnloadLs(nDll2)
ENDIF

RETURN nil

* ---------------

FUNCTION DC_SetRegion( oXbp, aRegion )

LOCAL nDLL,nDLL2, hRgn,hAdd, nX
IF Empty( aRegion )
  RETURN NIL
ELSEIF Valtype(aRegion[1]) == 'N'
  RETURN DC_SetRegionEllipse(oXbp,aRegion)
ENDIF
nDLL := _DLLLoadLS( 'GDI32.DLL' )
IF nDll <> 0
  hRgn := DllCall( nDLL, DLL_STDCALL,"CreateRectRgn", ;
            aRegion[1,1],;
            aRegion[1,2],;
            aRegion[1,3],;
            aRegion[1,4] )

  FOR nX := 2 to Len( aRegion )

    hAdd := DllCall( nDLL, DLL_STDCALL,"CreateRectRgn", ;
              aRegion[nX,1],;
              aRegion[nX,2],;
              aRegion[nX,3],;
              aRegion[nX,4] )

    DllCall( nDll, DLL_STDCALL, "CombineRgn", hRgn, hRgn, hAdd, RGN_OR )

    DllCall( nDll, DLL_STDCALL,"DeleteObject", hAdd )

  NEXT

  nDll2 := _DLLLoadLs( 'USER32.DLL' )
  DllCall( nDll2, DLL_STDCALL,"SetWindowRgn", oXbp:GetHwnd(), hRgn, 1 )
  //DllCall( nDll, DLL_STDCALL,"DeleteObject", hRgn )
  _DllUnloadLS(nDll)
  _DLLUnloadLs(nDll2)

ENDIF

RETURN Nil

* ---------------

FUNCTION DC_SetRegionEllipse( oXbp, aRegion )

LOCAL nDLL, nDLL2, hRgn

IF Empty( aRegion )
  RETURN NIL
ENDIF
nDLL := DLLLoad( 'GDI32.DLL' )
IF nDll <> 0
  hRgn := DllCall( nDLL, DLL_STDCALL,"CreateEllipticRgn", ;
            aRegion[1],;
            aRegion[2],;
            aRegion[3],;
            aRegion[4] )

  nDll2 := _DLLLoadLs( 'USER32.DLL' )
  DllCall( nDll2, DLL_STDCALL,"SetWindowRgn", oXbp:GetHwnd(), hRgn, 1 )
  DllUnload(nDll)
  DLLUnload(nDll2)
ENDIF

RETURN Nil

* ---------------

STATIC FUNCTION _DllLoadLS( cDLL, lNoUnload )

  LOCAL nHandle, nX

  DEFAULT lNoUnload := .f.
  cDLL := upper( cDLL )
  if ( nX := ascan( aDLLLoaded, { |aV| aV[1]== cDLL } ) ) > 0
    nHandle := aDLLLoaded[ nX, 2 ]
    if ! lNoUnLoad
      aDLLLoaded[ nX, 3 ] ++
    endif
  else
    nHandle := DLLLoad( cDLL )
    if nHandle <> 0      //added if statement, if dll load fails, alows another attempt at it.
      aadd( aDllLoaded, { cDLL, nHandle, 1 } )
    endif
  endif

return nHandle

* ---------------

STATIC FUNCTION _UnLoadAllLS()

  LOCAL i
  FOR i := 1 to len( aDllLoaded )
    DLLUnload( aDLLLoaded[ i, 2 ] )
  NEXT

RETURN nil

* ---------------

STATIC FUNCTION _DllUnLoadLS( nHandle )

  local nX
  if ( nX := ascan( aDLLLoaded, {|aV| aV[2] == nHandle } ) )> 0
    aDLLLoaded[ nX, 3 ] --
    if aDLLLoaded[ nX, 3 ] <= 0
      adel( aDLLLoaded, nX )
      asize( aDLLLoaded, len( aDLLLoaded ) -1 )
      DLLUnload( nHandle )
    endif
  else
    DLLUnload( nHandle )
  endif

RETURN nil

* ---------------

GETSETFUNCTION DC_GroupBoxFix DEFAULT .F.

* ------------------

GETSETFUNCTION DC_GetComboImmediate DEFAULT .F.

* ------------------

FUNCTION DC_ComboGetSetBlock( aList, aValues, xList, xValue )

RETURN {|x|_ComboGetSet( x, aList, aValues, @xList, @xValue )}

* ------------------

STATIC FUNCTION _ComboGetSet( x, aList, aValues, xList, xValue )

LOCAL nPointer

// Get
IF x == NIL
  nPointer := AScan(aValues,xValue)
  IF nPointer > 0
    RETURN aList[nPointer]
  ENDIF
  RETURN ''
ENDIF

// Set
nPointer := AScan( aValues, x )
IF nPointer > 0
  xList := aList[nPointer]
  xValue := x
ENDIF

RETURN xList

* ------------------

FUNCTION DC_ComboSelectedBlock( aList, aValues, xList, xValue )

RETURN {|x,y,o|_ComboSelected( o, aList, aValues, xList, @xValue )}

* ------------------

STATIC FUNCTION _ComboSelected( o, aList, aValues, xList, xValue )

LOCAL nPointer

Grok(xList)

nPointer := AScan( aList, o:xbpSLE:editBuffer() )
IF nPointer > 0
  xValue := aValues[nPointer]
ENDIF

RETURN nil

* --------------

FUNCTION DC_ResizeTab( oTab, aGetList )

LOCAL i, oXbp, nY, aChildList, aOldSize, aNewSize, oGetList, nDataStore

aOldSize := oTab:origSize
aNewSize := oTab:currentSize()

nY := aNewSize[2] - aOldSize[2]

nDataStore := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
oGetList := aGetList[nDataStore,oGETLIST_OBJECT]

aChildList := oTab:childList()

FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  oXbp:setPos( { oXbp:currentPos()[1], ;
                 oXbp:currentPos()[2] - nY } )

  AADD( oGetList:reSize, { oXbp, oXbp:currentPos()[1], ;
                                 oXbp:currentPos()[2], ;
                                 oXbp:currentSize()[1], ;
                                 oXbp:currentSize()[2] } )

NEXT

IF oGetList:isAutoResize
  DC_AutoReSize( aOldSize, aNewSize, oTab, aGetList )
ELSEIF oGetList:isResize
  DC_Resize( aOldSize, aNewSize, oTab, aGetList, oGetList )
ENDIF

oTab:show()

RETURN nil

* -----------------

#if XPPVER > 1900000

CLASS DC_XbpHTMLViewer FROM DC_XbpHTMLViewerSuper, DC_XbaseParts
EXPORTED:
  VAR options
  VAR callBacks
  _METHOD Init, Create, WhenHideEval
ENDCLASS

* ------------------

METHOD DC_XbpHTMLViewer:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL aGetList, aGetListItem, aGetOptions, bBlock, i

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::XbpHTMLViewer:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::options := aGetListItem[xGETLIST_OPTIONS]

DEFAULT ::options := {}
ASize(::options,3)
IF !Empty(::options[1])
  ::clsID := ::options[1]
ENDIF

::callBacks := aGetListItem[xGETLIST_OPTIONS2]

IF Valtype(::callBacks) = 'A'
  Asize(::callBacks,6)
  ::beforeNavigate := ::callBacks[1]
  ::documentComplete := ::callBacks[2]
  ::navigateComplete := ::callBacks[3]
  ::statusTextChange := ::callBacks[4]
  ::progressChange := ::callBacks[5]
  ::titleChange := ::callBacks[6]
ENDIF

::cargo := { ::getListPointer, aGetList,  aGetListItem[xGETLIST_CARGO] } ; // User Cargo

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpHTMLViewer:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aArray, aGetListItem, cNavigate, cHTML

::xbpHTMLViewer:create() // oParent, oOwner, aPos, aSize, aPres, lVisible )

::beforeNavigate2 := {||nil}

aGetListItem := ::getList:getListArray[::getListPointer]

IF !Empty(::options[2])
  ::navigate(::options[2])
ENDIF

IF !Empty(::options[3])
  ::setHTML(::options[3])
ENDIF

::DC_XbaseParts:setOrig(self)

RETURN self

* --------------------

METHOD DC_XbpHTMLViewer:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

* ====================

CLASS DC_XbpRTF FROM DC_XbpRTFSuper, DC_XbaseParts
EXPORTED:
  VAR varBlock
  VAR options
  _METHOD Init, Create, WhenHideEval
ENDCLASS

* ------------------

METHOD DC_XbpRTF:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL aGetList, aGetListItem, aGetOptions, bBlock, i, xData

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::varBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
IF Valtype(::varBlock) = 'B'
  xData := Eval(::varBlock)
  IF !DC_ReadDataCheck( xData, 'CM', aGetList, ::getListPointer )
    RETURN nil
  ENDIF
ENDIF

::XbpRTF:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::dataLink := ::varBlock
::options := aGetListItem[xGETLIST_OPTIONS]
::killInputFocus := {|x,y,o|o:xbpRTF:getData()}
::userEvents := .F.

DEFAULT ::options := {}
ASize(::options,8)

::cargo := { ::getListPointer, aGetList,  aGetListItem[xGETLIST_CARGO] } ; // User Cargo

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpRTF:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetList, aGetListItem, cFileName, xData, bBlock

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]

::xbpRTF:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

IF Valtype(::options[1]) == 'N'
  ::appearance := ::options[1]
ENDIF
IF Valtype(::options[2]) == 'N'
  ::maxLength := ::options[2]
ENDIF
IF Valtype(::options[3]) == 'N'
  ::rightMargin := ::options[3]
ENDIF
IF Valtype(::options[4]) == 'N'
  ::scrollBars := ::options[4]
ENDIF
IF Valtype(::options[5]) == 'N'
  ::bulletIndent := ::options[5]
ENDIF
IF Valtype(::options[6])= 'L'
  ::hideSelection := ::options[6]
ENDIF
IF Valtype(::options[7])= 'L'
  ::locked := ::options[7]
ENDIF
IF Valtype(::options[8])= 'L'
  ::usePopupMenu := ::options[8]
ENDIF

bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS2]) // Popup Menu
IF Valtype(bBlock) = 'B'
  ::popupMenu := Eval( bBlock, self )
ENDIF


aGetListItem := ::getList:getListArray[::getListPointer]

IF Valtype(::dataLink) = 'B'
  ::setData()
ELSEIF !Empty( cFileName := aGetListItem[xGETLIST_OPTIONS3])
  ::LoadFile(cFileName)
ENDIF

::selChange := aGetListItem[xGETLIST_OPTIONS4]
::Change := aGetListItem[xGETLIST_OPTIONS5]

::DC_XbaseParts:setOrig(self)

RETURN self

* --------------------

METHOD DC_XbpRTF:WhenHideEval( lEnable, lShow, lProtect )

RETURN _WhenHideEval( @lEnable, @lShow, @lProtect, self )

#endif

* ==================

CLASS DC_XbpSplitBar FROM DC_XbpSplitBarSuper, DC_XbaseParts

PROTECTED:

VAR    aSize                 // size of the splitbar object
VAR    lHasCapture           // mouse capture status, if .T. the
VAR    ColorBG               // object's background color
VAR    ColorFG               // foreground color
VAR    aStartMousePos        // the mouse position where splitbar
VAR    aStartPos             // the object position where splitbar movement started

METHOD AdjustClients         // adjusts the sizes of
METHOD Calibrate             // set defaults

EXPORTED:

VAR    Predecessor           // objects preceeding the splitbar
VAR    Successor             // objects succeeding the splitbar
VAR    Orientation           // object orientation: horizontal/vertical
VAR    Liveredraw            // redraw mode; if .T., the object renders
                             // intermediate steps, ie. before movement
                             // commenced
VAR    MaxSize
VAR    MinSize
VAR    MoveColor
VAR    width
VAR    height
VAR    resizeDialog

METHOD init, create          // initialization/creation
METHOD configure
METHOD LbDown, LbUp, LbDblClick, LbClick, Motion
                                // overloaded methods which
                                // catch the mouse
METHOD SetPos                // overload setpos adjusts the
                             // successor and precessor

// Callback Slots
// this callback slot is fired when the splitter has been
// moved
// mp1: aNewPos
// mp2: reserved (NIL)
INLINE METHOD SplitterMoved()
RETURN self
VAR    SplitterMoved

ENDCLASS


/* **********************************************************************
 * Initialization of the splitbar object
 */
METHOD DC_XbpSplitbar:init( oParent, oOwner, aPos, aSize, aPP, lVisible, oGetList )

LOCAL aGetList, aGetListItem, aGetOptions, aOptions, bBlock, cCaption

::DC_XbaseParts:init( oGetList,,self )

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::XbpStatic:INIT( oParent, oOwner, aPos, aSize, aPP, lVisible )

::caption := '--------'
::options := XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER

::aSize := {0,0}
IF Valtype( aSize ) == "A"
  ::aSize := AClone( aSize )
ENDIF
::colorBG := aGetListItem[aGETLIST_COLOR]
DEFAULT ::colorBG := GRA_CLR_DARKGRAY

::colorFG := GRA_CLR_WHITE

aOptions := aGetListItem[xGETLIST_OPTIONS]

DEFAULT aOptions := {}
ASize(aOptions,6)
DEFAULT aOptions[1] := DCGUI_SPLITBAR_VERTICAL, ;
        aOptions[3] := 0, ;
        aOptions[4] := 0, ;
        aOptions[5] := .t., ;
        aOptions[6] := .f.

::moveColor := aOptions[2]
DEFAULT ::moveColor := GRA_CLR_DARKGRAY
::minSize := aOptions[3]
::maxSize := aoptions[4]
::width := aSize[1]
::height := aSize[2]

DEFAULT ::width := 10, ;
        ::height := 10

// initialize internal data
::Orientation := aOptions[1]
::Liveredraw  := aOptions[5]
::lHasCapture := .f.

::cargo := { ::getListPointer, aGetList,  aGetListItem[xGETLIST_CARGO] } ; // User Cargo

bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS2],'O')
IF Valtype(bBlock) = 'B'
  ::predecessor := Eval( bBlock )
ENDIF

bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS3],'O')
IF Valtype(bBlock) = 'B'
  ::successor := Eval( bBlock )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN SELF


/* **********************************************************************
 * Create the splitbar object
 */
METHOD DC_XbpSplitbar:Create( oParent, oOwner, aPos, aSize, aPP, lVisible )

IF Valtype( aSize ) == "A"
  ::aSize := AClone( aSize )
ENDIF

// Note: a splitbar has one fixed size element!
IF ::Orientation == DCGUI_SPLITBAR_HORIZONTAL
  ::aSize[2] := 5 // ::height
ELSE
  ::aSize[1] := 5// ::width
ENDIF

::XbpStatic:Create( oParent, oOwner, aPos, aSize, aPP, lVisible )

IF ::Orientation == DCGUI_SPLITBAR_HORIZONTAL
  ::SetPointer( , XBPSTATIC_SYSICON_SIZENS, XBPWINDOW_POINTERTYPE_SYSPOINTER )
ELSE
  ::SetPointer( , XBPSTATIC_SYSICON_SIZEWE, XBPWINDOW_POINTERTYPE_SYSPOINTER )
ENDIF

IF Valtype(::colorBG) == 'N'
  ::setColorBG(::colorBG)
ENDIF
::setColorFG(::colorFG)

::DC_XbaseParts:setOrig(self)

RETURN SELF


/* **********************************************************************
 * Configure the splitbar object
 */
METHOD DC_XbpSplitbar:Configure( oParent, oOwner, aPos, aSize, aPP, lVisible )

IF Valtype( aSize ) == "A"
  ::aSize := AClone( aSize )
ENDIF

// Note: a splitbar has one fixed size element!
IF ::Orientation == DCGUI_SPLITBAR_HORIZONTAL
  IF aSize == NIL
    ::aSize[1] := ::XbpStatic:currentSize()[2]
  ENDIF
  ::aSize[2] := ::height
ELSE
  IF aSize == NIL
    ::aSize[1] := ::XbpStatic:currentSize()[1]
  ENDIF

  ::aSize[1] := ::width
ENDIF

::XbpStatic:Configure( oParent, oOwner, aPos, ::aSize, aPP, lVisible )

IF ::Orientation == DCGUI_SPLITBAR_HORIZONTAL
  ::SetPointer( , XBPSTATIC_SYSICON_SIZENS, XBPWINDOW_POINTERTYPE_SYSPOINTER )
ELSE
  ::SetPointer( , XBPSTATIC_SYSICON_SIZEWE, XBPWINDOW_POINTERTYPE_SYSPOINTER )
ENDIF

RETURN SELF


/* **********************************************************************
 * Overloaded LbDown event handler; basically, this handles capturing
 * the mouse
 */
METHOD DC_XbpSplitbar:LbDown( aPos )

   // Calculate default values for successor and precessor
IF Empty( ::Successor ) .OR. Empty( ::Predecessor )
  ::Calibrate()
ENDIF

// capture mouse and start to move
IF ::CaptureMouse( .t. )
  ::lHasCapture := .t.
  ::ToFront()
  ::aStartMousePos := NIL
  ::aStartPos   := ::CurrentPos()
  // ::ColorBG     := ::setColorBG( GRA_CLR_DARKGRAY ) //
  ::ColorBG     := ::setColorBG( ::moveColor )
  DEFAULT ::ColorBG := XBPSYSCLR_ACTIVEBORDER
ENDIF

/* forward message to parent class in order to allow
* activation of dialog which contains the splitbar
*/
RETURN ::XbpStatic:LbDown( aPos )


/* **********************************************************************
 * Overloaded LbUp event handler; basically, this releases the mouse
 * capture set in lbUp()
 */
METHOD DC_XbpSplitbar:LbUp()

IF ::lHasCapture
  IF ! ::LiveRedraw
    ::AdjustClients( ::CurrentPos() )
  ENDIF
  ::CaptureMouse( .F. )
  ::lHasCapture := .F.
  ::aStartMousePos := NIL
  ::setColorBG( ::ColorBG )
ENDIF

RETURN SELF


/* **********************************************************************
 * Overloaded LbDblClick event handler; this releases the mouse capture
 * since W*ndows sometimes omits LbUp events when clicking very fast
 */
METHOD DC_XbpSplitbar:LbDblClick( aPos )
RETURN ::LbUp( aPos )


/* **********************************************************************
 * Overloaded LbClick event handler; see notes on LbDblClick above
 */
METHOD DC_XbpSplitbar:LbClick( aPos )
RETURN ::LbUp( aPos )


/* **********************************************************************
 * Overloaded motion event handler; this adjusts the splitbar's position
 * to the current mouse cursor position
 *
 * NOTE: When this turns out to be too slow on slower machines,
 *       this code may be moved to the LbUp() method!
 */
METHOD DC_XbpSplitbar:Motion( aPos )

IF ::lHasCapture

  IF ::aStartMousePos == NIL
    ::aStartMousePos := AClone( aPos )
  ENDIF
  IF ::LiveRedraw
    // Release mouse capture since this would cause
    // trouble while repositioning the object
    ::CaptureMouse( .F. )
  ENDIF
  IF ::Orientation == DCGUI_SPLITBAR_HORIZONTAL
    ::SetPos( { ::CurrentPos()[1], ::CurrentPos()[2] + ( aPos[2] - ::aStartMousePos[2] ) } )
  ELSE
    ::SetPos( { ::CurrentPos()[1] + ( aPos[1] - ::aStartMousePos[1] ), ::CurrentPos()[2] } )
  ENDIF
  IF ::LiveRedraw
    // re-gain mouse capture
    ::CaptureMouse( .T. )
  ENDIF
ENDIF

RETURN SELF


/* **********************************************************************
 * Overloaded setPos() method, this method implicitily adjusts the size
 * and position of the predecessor and successor objects size with
 * respect to the position of the splitbar
 */
METHOD DC_XbpSplitbar:SetPos( aNewPos, lRedraw )

DEFAULT lRedraw := .t.

// When we do not have a valid predecessor or successor, then
// we will only change our position
IF Empty( ::Predecessor ) .OR. Empty( ::Successor )
  RETURN ::XbpStatic:SetPos( aNewPos, lRedraw )
ENDIF

// Make sure that we aren't moved outside the parent object
IF aNewPos[1] < ::Predecessor:CurrentPos()[1]
  aNewPos[1] := ::Predecessor:CurrentPos()[1]
ENDIF
IF aNewPos[2] < ::Predecessor:CurrentPos()[2]
  aNewPos[2] := ::Predecessor:CurrentPos()[2]
ENDIF

IF aNewPos[1] + ::CurrentSize()[1] > ::Successor:CurrentSize()[1] + ::Successor:CurrentPos()[1]
  aNewPos[1] := ::Successor:CurrentSize()[1] + ::Successor:CurrentPos()[1] - ::CurrentSize()[1]
ENDIF
IF aNewPos[2] + ::CurrentSize()[2] > ::Successor:CurrentSize()[2] + ::Successor:CurrentPos()[2]
  aNewPos[2] := ::Successor:CurrentSize()[2] + ::Successor:CurrentPos()[2] - ::CurrentSize()[2]
ENDIF

// Adjust our clients in case we draw live
IF ::LiveRedraw
  ::aStartPos := ::CurrentPos()
  ::AdjustClients( aNewPos )
ENDIF

// Call default handling of the internal static object in
// order to actually reposition ourself
RETURN ::XbpStatic:SetPos( aNewPos, lRedraw )


/* **********************************************************************
 * This method adjusts the size and position of the predecessor and
 * successor objects size with respect to the current position of the
 * splitbar
 */
METHOD DC_XbpSplitbar:AdjustClients( aNewPos )

LOCAL aSize1, aSize2, aPos, nDelta, i, aOldSize, aNewSize

// When we do not have a valid predecessor or successor, then
// we will do nothing
IF Empty( ::Predecessor ) .OR. Empty( ::Successor )
  RETURN self
ENDIF

// Position client objects with respect to the splibar's
// orientation
IF ::Orientation == DCGUI_SPLITBAR_HORIZONTAL
  // calculate delta
  nDelta := aNewPos[2] - ::aStartPos[2]
  aSize1 := ::Predecessor:CurrentSize()
  aSize2 := ::Successor:CurrentSize()
  IF nDelta < 0 .AND. Abs( nDelta ) > aSize1[2]
    nDelta := aSize1[2] * -1
  ENDIF
  IF nDelta > 0 .AND. Abs( nDelta ) > aSize2[2]
    nDelta := aSize2[2]
  ENDIF
  aNewPos[2] := ::aStartPos[2] + nDelta

  // adjust predecessor
  aSize1[2] += nDelta
  aOldSize := ::Predecessor:currentSize()
  ::Predecessor:SetSize( { ::Predecessor:CurrentSize()[1], aSize1[2] } )
  aNewSize := ::Predecessor:currentSize()
  DC_Resize( aOldSize, aNewSize, ::Predecessor, ::getList:getListArray )

  // adjust successor
  aSize2[2] -= nDelta
  aPos      := ::Successor:CurrentPos()
  aOldSize := ::Successor:currentSize()
  ::Successor:SetPosAndSize( { aPos[1], aPos[2] + nDelta }, ;
                  { ::Successor:CurrentSize()[1], aSize2[2] }, .F. )
  aNewSize := ::Successor:currentSize()
  DC_Resize( aOldSize, aNewSize, ::Successor, ::getList:getListArray )

  // _Redraw( ::Successor )
  ::Successor:SetParent():InvalidateRect()

ELSE
  // calculate delta
  nDelta := aNewPos[1] - ::aStartPos[1]
  aSize1 := ::Predecessor:CurrentSize()
  aSize2 := ::Successor:CurrentSize()
  IF nDelta < 0 .AND. Abs( nDelta ) > aSize1[1]
    nDelta := aSize1[1] * -1
  ENDIF
  IF nDelta > 0 .AND. Abs( nDelta ) > aSize2[1]
    nDelta := aSize2[1]
  ENDIF
  aNewPos[1] := ::aStartPos[1] + nDelta

  // adjust predecessor
  aSize1[1] += nDelta
  aOldSize := ::Predecessor:currentSize()
  ::Predecessor:SetSize( { aSize1[1], ::Predecessor:CurrentSize()[2] } )
  aNewSize := ::Predecessor:currentSize()
  DC_Resize( aOldSize, aNewSize, ::Predecessor, ::getList:getListArray )

  // adjust successor
  aSize2[1] -= nDelta
  aPos   := ::Successor:CurrentPos()
  aOldSize := ::Successor:CurrentSize()
  ::Successor:SetPosAndSize( { aPos[1] + nDelta, aPos[2] }, ;
                           { aSize2[1], ::Successor:CurrentSize()[2] }, .F. )
  aNewSize := ::Successor:CurrentSize()
  DC_Resize( aOldSize, aNewSize, ::Successor, ::getList:getListArray )
  // _Redraw( ::Successor )
  ::Successor:SetParent():InvalidateRect()

ENDIF

// Now provide notfication callback
::SplitterMoved( aNewPos, NIL )
IF !Empty( ::SplitterMoved )
  ::Eval( ::SplitterMoved, aNewPos, NIL, self )
ENDIF

RETURN SELF


/* **********************************************************************
 * Calibrate the splitbar object; basically, this sets the successor
 * and predecessor objects
 */
METHOD DC_XbpSplitbar:Calibrate()

LOCAL aSiblings := ::SetParent():ChildList()
LOCAL nPos      := AScan( aSiblings, SELF )

IF nPos > 1 .AND. Empty( ::Predecessor )
  ::Predecessor := aSiblings[nPos - 1]
ENDIF

IF nPos < Len( aSiblings ) .AND. Empty( ::Successor )
  ::Successor := aSiblings[ nPos + 1 ]
ENDIF

RETURN SELF


/* *******************************************************************
 * Redraw an object and its descendants
 * */
STATIC PROCEDURE _Redraw( oXbp )

LOCAL i, l, aChilds
oXbp:InvalidateRect()
IF oXbp:ClipChildren := .T.
  aChilds := oXbp:ChildList()
  l       := Len( aChilds )
  FOR i := 1 TO l
    _Redraw( aChilds[i] )
  NEXT
ENDIF

RETURN

* ----------------

FUNCTION DC_XbpMenuConfig( aParams )

STATIC saParams := nil
LOCAL aOldParams := saParams, i

IF Empty(saParams)
  saParams := { MENU_SUB_BGCOLOR, ;
                MENU_SUB_BARCOLORFG, ;
                MENU_SUB_BARCOLORBG, ;
                MENU_SUB_OUTLINECOLOR, ;
                MENU_SUB_VERTBARFONT, ;
                .F., ;
                MENU_SUB_CHECKFONT, ;
                MENU_SUB_CHECKCHAR, ;
                MENU_BAR_FGCOLOR, ;
                MENU_BAR_BGCOLOR, ;
                MENU_SUB_FGCOLOR, ;
                MENU_BAR_BARFONT, ;
                MENU_SUB_ITEMFONT }
  aOldParams := saParams
ENDIF

IF Valtype(aParams) = 'A'
  saParams := aParams
  ASize(saParams,13)

  FOR i := 1 TO 13
    IF Valtype(saParams[i]) == 'A' .AND. Len(saParams[i]) == 3
      saParams[i] := GraMakeRGBColor(saParams[i])
    ENDIF
  NEXT

  DEFAULT saParams[5] := MENU_SUB_VERTBARFONT, ;
          saParams[6] := .F., ;
          saParams[7] := MENU_SUB_CHECKFONT, ;
          saParams[8] := MENU_SUB_CHECKCHAR, ;
          saParams[9] := MENU_BAR_FGCOLOR, ;
          saParams[10] := MENU_BAR_BGCOLOR, ;
          saParams[11] := MENU_SUB_FGCOLOR, ;
          saParams[12] := MENU_BAR_BARFONT, ;
          saParams[13] := MENU_SUB_ITEMFONT
ENDIF

RETURN aOldParams

* ------------------

STATIC FUNCTION ConvertColor( anColor )

IF Valtype(anColor) == 'A' .AND. Len(anColor) == 3 .AND. Valtype(anColor[1]) == 'N'
  RETURN GraMakeRGBColor(anColor)
ENDIF
RETURN anColor

* ------------------

CLASS DC_XbaseParts

EXPORTED:

  VAR whenBlock
  VAR hideBlock
  VAR protectBlock
  VAR getList
  VAR getListPointer
  VAR userCargo
  VAR origPos
  VAR origSize
  VAR origFont
  VAR origFontSize
  VAR origCursor
  VAR fontFamilyName
  VAR dropBlock
  VAR dropType
  VAR dropCursor
  VAR dragBlock
  VAR dragType
  VAR dragDialogBlock
  VAR xbp
  VAR isValid
  VAR resizeRule
  #if XPPVER < 1900000
    VAR drawMode
  #endif
  METHOD Init, SetOrig, DCSetPos, DCSetSize, DCCurrentPos, DCCurrentSize, ;
         InitResize

ENDCLASS

* ------------

METHOD DC_XbaseParts:Init( oGetList, nPointer, oXbp )

LOCAL aGetListItem

::xbp := oXbp

::getList := oGetList
IF !Empty(nPointer)
  ::getListPointer := nPointer
ELSE
  ::getListPointer := ::getList:getListPointer
ENDIF

aGetListItem := ::getList:getListArray[::getListPointer]
::whenBlock := DC_GetBlock(aGetListItem[bGETLIST_WHEN])
::hideBlock := DC_GetBlock(aGetListItem[bGETLIST_HIDE])
::protectBlock := DC_GetBlock(aGetListItem[bGETLIST_PROTECT])
::resizeRule := aGetListItem[aGETLIST_RESIZE]
::isValid := .f.

#if XPPVER < 1900000
  ::drawMode := 0
#endif

RETURN self

* ------------

METHOD DC_XbaseParts:SetOrig( oXbp )

LOCAL oFont, aDrop, aGetListItem

aGetListItem := ::getList:getListArray[::getListPointer]
::origSize := oXbp:currentSize()
::origPos := oXbp:currentPos()
::origFont := oXbp:setFont()

IF Valtype(::origFont) = 'O'
  ::origFontSize := ::origFont:nominalPointSize
ELSEIF Valtype(oXbp:setParent()) == 'O'
  ::origFont := oXbp:setParent():setFont()
  IF Valtype(::origFont) = 'O'
    ::origFontSize := ::origFont:nominalPointSize
  ELSE
    ::origFontSize := 8
  ENDIF
ELSE
  ::origFontSize := 8
ENDIF

/*
IF oXbp:setColorFG() == NIL .OR. oXbp:setColorBG() == NIL ;
   .OR. oXbp:setColorFG() < 0 .OR. oXbp:setColorBG() < 0
  oXbp:setColorBG(GRA_CLR_YELLOW)
  oXbp:setColorFG(GRA_CLR_RED)
ENDIF
*/

IF Valtype(::origFont) == 'O'
  ::fontFamilyName := ::origFont:familyName
  IF ::origFont:bold
    ::fontFamilyName += ' Bold'
  ENDIF
  IF ::origFont:italic
    ::fontFamilyName += ' Italic'
  ENDIF
  IF ::origFont:underScore
    ::fontFamilyName += ' UnderScore'
 ENDIF
ENDIF

IF Valtype(::hideBlock)='B' .AND. !oXbp:isDerivedFrom('XbpTabPage') .AND. ;
     Eval(::hideBlock, self)
  oXbp:hide()
ENDIF

#if XPPVER > 1900000
aDrop := aGetListItem[aGETLIST_DRAGDROP]

IF !Empty(aDrop)
  ::dragBlock := aDrop[1]
  ::dragType := aDrop[2]
  ::dragDialogBlock := aDrop[3]
  ::dropBlock := aDrop[4]
  ::dropType := aDrop[5]
  ::dropCursor := aDrop[6]

  ::xbp:setTrackPointer(.t.)
  IF !Empty(::dropBlock)
    ::xbp:dropZone := .t.
    ::xbp:dragDrop := {|a,b,c,x|x := b:getData(XBPCLPBRD_FILELIST), ;
                                PostAppEvent(DCGUI_EVENT_DRAGDROP,a,x,c)}
    ::xbp:dragEnter := {|a,b,c|PostAppEvent(xbeM_Enter,a,b,c)}
  ENDIF
  IF ::xbp:isDerivedFrom("XbpColumn")
    ::xbp:dataArea:setTrackPointer(.t.)
    IF !Empty(::dropBlock)
      ::xbp:dataArea:dropZone := .t.
      ::xbp:dataArea: dragDrop := {|a,b,c,x|x := b:getData(XBPCLPBRD_FILELIST), ;
                                    PostAppEvent(DCGUI_EVENT_DRAGDROP,a,x,c)}
      ::xbp:dataArea:dragEnter := {|a,b,c|PostAppEvent(xbeM_Enter,a,b,c)}
    ENDIF
  ENDIF
ENDIF
#endif

IF _IsEditControl(oXbp)
  oXbp:setInputFocus := DC_MergeBlocks(oXbp:setInputFocus,{||DC_LastInputFocus(oXbp)})
ENDIF

RETURN self

* ---------------

METHOD DC_XbaseParts:initResize()

LOCAL nFound

IF Valtype(::getList:reSize) # 'A'
  ::getList:reSize := {}
ENDIF

nFound := AScan( ::getList:reSize, {|a|a[1] == ::xbp} )
IF nFound = 0
  AADD( ::getList:reSize, { ::xbp, ;
                            ::xbp:currentPos()[1], ;
                            ::xbp:currentPos()[2], ;
                            ::xbp:currentSize()[1], ;
                            ::xbp:currentSize()[2] } )
ENDIF

RETURN self

* ---------------

METHOD DC_XbaseParts:dcSetPos( aPos )

LOCAL nRow, nCol, nXDelta, nYDelta, nFound

IF !::getList:isPixel
  nCol := aPos[1] * ::getList:colPixels
  nRow := aPos[2] * ::getList:rowPixels
ELSE
  nCol := aPos[1]
  nRow := aPos[2]
ENDIF

nRow := ::xbp:parent:currentSize()[2] - nRow - ::xbp:currentSize()[2]

::initResize()

nFound := AScan( ::getList:reSize, {|a|a[1] == ::xbp} )

nXDelta := nCol - ::getList:resize[nFound,2]
nYDelta := nRow - ::getList:resize[nFound,3]
::getList:reSize[nFound,2] += nXDelta
::getList:reSize[nFound,3] += nYDelta

::xbp:setPos( { nCol, nRow } )

RETURN nil

* ---------------

METHOD DC_XbaseParts:dcSetSize( aSize )

LOCAL nHeight, nWidth, aCurrentPos := ::dcCurrentPos(), aChildList, ;
      aCurrentSize := ::currentSize(), i, nFound, nXDelta, nYDelta

IF !::getList:isPixel
  nWidth := aSize[1] * ::getList:colPixels
  nHeight := aSize[2] * ::getList:rowPixels
ELSE
  nWidth := aSize[1]
  nHeight := aSize[2]
ENDIF

::initResize()

nFound := AScan( ::getList:reSize, {|a|a[1] == ::xbp} )

nXDelta := nWidth - ::getList:resize[nFound,4]
nYDelta := nHeight - ::getList:resize[nFound,5]
::getList:reSize[nFound,4] += nXDelta
::getList:reSize[nFound,5] += nYDelta

::xbp:setSize( { nWidth, nHeight } )
::dcSetPos( aCurrentPos )

aChildList := ::xbp:childList()

IF Empty(::getList:resizeDefault) .OR. (Empty(::getList:resizeDefault[1]) .AND. Empty(::getList:resizeDefault[2]))
  FOR i := 1 TO Len(aChildList)
    IF IsMemberVar(aChildlist[i],"resizeRule") .AND. Empty(aChildList[i]:resizeRule)
      aChildList[i]:setPos( {aChildList[i]:currentPos()[1], ;
                    aChildList[i]:currentPos()[2]-(aCurrentSize[2]-::xbp:currentSize()[2])})
    ENDIF
  NEXT
ENDIF

RETURN nil

* ---------------

METHOD DC_XbaseParts:dcCurrentSize()

LOCAL aSize := ::xbp:currentSize()
IF !::getList:isPixel
  aSize[1] /= ::getList:colPixels
  aSize[2] /= ::getList:rowPixels
ENDIF

RETURN aSize

* ---------------

METHOD DC_XbaseParts:dcCurrentPos()

LOCAL aPos := ::xbp:currentPos()

aPos[2] := ::xbp:parent:currentSize()[2] - ::xbp:currentPos()[2] - ::xbp:currentSize()[2]

IF !::getList:isPixel
  aPos[1] /= ::getList:colPixels
  aPos[2] /= ::getList:rowPixels
ENDIF

RETURN aPos

* -------------

FUNCTION DC_LastInputFocus( oXbp )

STATIC soFocus := nil

IF Valtype(oXbp) == 'O'
  soFocus := oXbp
ENDIF

RETURN soFocus

* -------------

STATIC FUNCTION _IsEditControl( oXbp )

IF Valtype(oXbp) # 'O'
  RETURN .f.
ENDIF

RETURN oXbp:isDerivedFrom('DC_XbpGet') .OR. ;
       oXbp:isDerivedFrom('DC_XbpSle') .OR. ;
       oXbp:isDerivedFrom('DC_XbpRadioButton') .OR. ;
       oXbp:isDerivedFrom('DC_XbpComboBox') .OR. ;
       oXbp:isDerivedFrom('DC_XbpListBox') .OR. ;
       oXbp:isDerivedFrom('DC_XbpCheckBox') .OR. ;
       oXbp:isDerivedFrom('DC_XbpSpinButton') .OR. ;
       oXbp:isDerivedFrom('DC_XbpMle') .OR. ;
       oXbp:isDerivedFrom('DC_Xbp3State')

* ---------------

FUNCTION DC_IsActiveXControl( cClsId )

DEFAULT cClsId := ''

RETURN Valtype(DC_RegQuery(HKEY_CLASSES_ROOT,cClsId,'')) == 'C'

* ---------------

FUNCTION DC_TabPageColor( aColor )

STATIC saColor := nil
LOCAL aOldColor := saColor

IF Valtype(aColor) == 'A'
  saColor := aColor
ENDIF

RETURN aOldColor

* ---------------

GETSETFUNCTION DC_MenuOwnerDrawDisable DEFAULT .f.

* ---------------

FUNCTION DC_MenuOwnerDrawSet( oMenu, lOwnerDraw )

LOCAL i, aItem, nNumItems := oMenu:numItems()

DEFAULT lOwnerDraw := .f.

FOR i := 1 TO nNumItems
  aItem := oMenu:getItem(i)
  _SetItem( oMenu, i, lOwnerDraw )
  IF Valtype(aItem[1]) == 'O'
    DC_MenuOwnerDrawSet( aItem[1], lOwnerDraw )
  ENDIF
NEXT

DEFAULT lOwnerDraw := .f.

RETURN nil

* ---------------

STATIC FUNCTION _SetItem( oMenu, nIndex, lOwnerDraw )

LOCAL aItem := oMenu:getItem(nIndex), nAttr := aItem[4]

IF lOwnerDraw
  IF BAnd( nAttr, XBPMENUBAR_MIA_OWNERDRAW ) == 0
    nAttr += XBPMENUBAR_MIA_OWNERDRAW
  ENDIF
ELSE
  IF BAnd( nAttr, XBPMENUBAR_MIA_OWNERDRAW ) # 0
    nAttr -= XBPMENUBAR_MIA_OWNERDRAW
  ENDIF
ENDIF

aItem[4] := nAttr

oMenu:setItem(nIndex,aItem)

RETURN nil

* -------------

GETSETFUNCTION DC_EnableTabPageColors DEFAULT .t.
